/******/ (function() { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./node_modules/biggystring/lib/index.es.js":
/*!**************************************************!*\
  !*** ./node_modules/biggystring/lib/index.es.js ***!
  \**************************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "add": function() { return /* binding */ add; },
/* harmony export */   "sub": function() { return /* binding */ sub; },
/* harmony export */   "mul": function() { return /* binding */ mul; },
/* harmony export */   "div": function() { return /* binding */ div; },
/* harmony export */   "gt": function() { return /* binding */ gt; },
/* harmony export */   "lt": function() { return /* binding */ lt; },
/* harmony export */   "gte": function() { return /* binding */ gte; },
/* harmony export */   "lte": function() { return /* binding */ lte; },
/* harmony export */   "eq": function() { return /* binding */ eq; },
/* harmony export */   "min": function() { return /* binding */ min; },
/* harmony export */   "max": function() { return /* binding */ max; },
/* harmony export */   "log10": function() { return /* binding */ log10; },
/* harmony export */   "toFixed": function() { return /* binding */ toFixed; },
/* harmony export */   "abs": function() { return /* binding */ abs; },
/* harmony export */   "bns": function() { return /* binding */ bns; }
/* harmony export */ });
/**
 * Created by paul on 7/25/17.
 */
var BN = __webpack_require__(/*! bn.js */ "./node_modules/biggystring/node_modules/bn.js/lib/bn.js"); // const MAX_DECIMALS = 10


function isHex(x) {
  if (x.startsWith('0x') || x.startsWith('-0x') || x.toLowerCase().includes('a') || x.toLowerCase().includes('b') || x.toLowerCase().includes('c') || x.toLowerCase().includes('d') || x.toLowerCase().includes('e') || x.toLowerCase().includes('f')) {
    return true;
  } else {
    return false;
  }
}

function cropHex(x) {
  return x.replace('0x', '');
}

function addZeros(val, numZeros) {
  var out = val;

  for (var n = 0; n < numZeros; n++) {
    out += '0';
  }

  return out;
} // Remove starting and trailing zeros and decimal


function trimEnd(val) {
  // Remove starting zeros if there are any
  var out = val.replace(/^0+/, '');
  out = out.replace(/^\.+/, '0.');

  if (out.includes('.')) {
    // Remove trailing zeros
    out = out.replace(/0+$/, ''); // Remove trailing "." if there is one

    out = out.replace(/\.+$/, '');

    if (out === '') {
      out = '0';
    }
  }

  if (out === '') {
    out = '0';
  }

  return out;
}

function addDecimal(x, shift) {
  if (shift === 0) return x;
  var isNegative = false;

  if (x.slice(0, 1) === '-') {
    isNegative = true;
    x = x.slice(1);
  }

  var out = void 0;

  if (shift > x.length) {
    out = '0.' + addZeros('', shift - x.length) + x;
  } else {
    out = x.substr(0, x.length - shift) + '.' + x.substr(x.length - shift, x.length);
  }

  out = trimEnd(out);

  if (isNegative) {
    out = '-' + out;
  }

  return out;
} // Takes two floating point (base 10) numbers and finds the multiplier needed to make them both
// operable as a integer


function floatShifts(xStart, yStart, moreShift) {
  var x = xStart;
  var y = yStart;
  validate(x, y);
  var xPos = x.indexOf('.');
  var yPos = y.indexOf('.');
  var xHex = isHex(x);
  var yHex = isHex(y);

  if (xPos !== -1) {
    // Remove trailing zeros
    x = trimEnd(x);
    xPos = x.indexOf('.');
  }

  if (yPos !== -1) {
    // Remove trailing zeros
    y = trimEnd(y);
    yPos = y.indexOf('.');
  }

  if (xPos !== -1 || yPos !== -1 || typeof moreShift === 'number') {
    if (xHex || yHex) {
      throw new Error('Cannot operate on base16 float values');
    }

    var xShift = 0;
    var yShift = 0;

    if (xPos !== -1) {
      xShift = x.length - xPos - 1;
    }

    if (yPos !== -1) {
      yShift = y.length - yPos - 1;
    }

    var _shift = xShift > yShift ? xShift : yShift;

    var moreS = 0;

    if (typeof moreShift === 'number') {
      moreS = moreShift;
    }

    x = addZeros(x.replace('.', ''), _shift + moreS - xShift);
    y = addZeros(y.replace('.', ''), _shift - yShift);
    var out = {
      x: x,
      y: y,
      shift: _shift
    };
    return out;
  } else {
    // Both x and y are int and need no float conversion
    var _out = {
      x: x,
      y: y,
      shift: 0
    };
    return _out;
  }
}

function validate() {
  for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = args[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var arg = _step.value;

      if (arg.split('.').length - 1 > 1) {
        throw new Error('Invalid number: more than one decimal point');
      }

      if (arg.split('-').length - 1 > 1) {
        throw new Error('Invalid number: more than one negative sign');
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"]) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
}

function add(x1, y1) {
  var base = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;
  if (base !== 10 && base !== 16) throw new Error('Unsupported base');

  var _floatShifts = floatShifts(x1, y1),
      x = _floatShifts.x,
      y = _floatShifts.y,
      shift = _floatShifts.shift;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = xBN.add(yBN).toString(base);
  out = addDecimal(out, shift);
  return base === 10 ? out : '0x' + out;
}

function mul(x1, y1) {
  var base = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;
  if (base !== 10 && base !== 16) throw new Error('Unsupported base');

  var _floatShifts2 = floatShifts(x1, y1),
      x = _floatShifts2.x,
      y = _floatShifts2.y,
      shift = _floatShifts2.shift;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = xBN.mul(yBN).toString(base);
  out = addDecimal(out, shift * 2);
  return base === 10 ? out : '0x' + out;
}

function sub(x1, y1) {
  var base = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;
  if (base !== 10 && base !== 16) throw new Error('Unsupported base');

  var _floatShifts3 = floatShifts(x1, y1),
      x = _floatShifts3.x,
      y = _floatShifts3.y,
      shift = _floatShifts3.shift;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = xBN.sub(yBN).toString(base);
  out = addDecimal(out, shift);
  return base === 10 ? out : '0x' + out;
}

function div(x1, y1) {
  var precision = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var base = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 10;

  if (base !== 10 && precision > 0) {
    throw new Error('Cannot operate on floating point hex values');
  }

  if (base !== 10 && base !== 16) throw new Error('Unsupported base');

  var _floatShifts4 = floatShifts(x1, y1, precision),
      x = _floatShifts4.x,
      y = _floatShifts4.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = xBN.div(yBN).toString(base);
  out = addDecimal(out, precision);
  return base === 10 ? out : '0x' + out;
}

function lt(x1, y1) {
  var _floatShifts5 = floatShifts(x1, y1),
      x = _floatShifts5.x,
      y = _floatShifts5.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  return xBN.lt(yBN);
}

function lte(x1, y1) {
  var _floatShifts6 = floatShifts(x1, y1),
      x = _floatShifts6.x,
      y = _floatShifts6.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  return xBN.lte(yBN);
}

function gt(x1, y1) {
  var _floatShifts7 = floatShifts(x1, y1),
      x = _floatShifts7.x,
      y = _floatShifts7.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  return xBN.gt(yBN);
}

function gte(x1, y1) {
  var _floatShifts8 = floatShifts(x1, y1),
      x = _floatShifts8.x,
      y = _floatShifts8.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  return xBN.gte(yBN);
}

function eq(x1, y1) {
  var _floatShifts9 = floatShifts(x1, y1),
      x = _floatShifts9.x,
      y = _floatShifts9.y;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  return xBN.eq(yBN);
}

function min(x1, y1) {
  var base = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;

  var _floatShifts10 = floatShifts(x1, y1),
      x = _floatShifts10.x,
      y = _floatShifts10.y,
      shift = _floatShifts10.shift;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = void 0;

  if (xBN.lte(yBN)) {
    out = xBN.toString(base);
  } else {
    out = yBN.toString(base);
  }

  out = addDecimal(out, shift);
  return base === 10 ? out : '0x' + out;
}

function abs(x1) {
  var base = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 10;
  if (base !== 10 && base !== 16) throw new Error('Unsupported base');

  var _floatShifts11 = floatShifts(x1, '0'),
      x = _floatShifts11.x,
      shift = _floatShifts11.shift;

  var xBase = isHex(x1) ? 16 : 10;
  x = cropHex(x);
  var xBN = new BN(x, xBase);
  var out = xBN.abs(xBN).toString(base);
  out = addDecimal(out, shift);
  return base === 10 ? out : '0x' + out;
}

function max(x1, y1) {
  var base = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;

  var _floatShifts12 = floatShifts(x1, y1),
      x = _floatShifts12.x,
      y = _floatShifts12.y,
      shift = _floatShifts12.shift;

  var xBase = isHex(x) ? 16 : 10;
  var yBase = isHex(y) ? 16 : 10;
  x = cropHex(x);
  y = cropHex(y);
  var xBN = new BN(x, xBase);
  var yBN = new BN(y, yBase);
  var out = void 0;

  if (xBN.gte(yBN)) {
    out = xBN.toString(base);
  } else {
    out = yBN.toString(base);
  }

  out = addDecimal(out, shift);
  return base === 10 ? out : '0x' + out;
}

function toFixed(x1) {
  var minPrecision = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 2;
  var maxPrecision = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 8;
  validate(x1);
  var negative = false;
  var out = '';
  var x = x1;

  if (x.includes('-')) {
    negative = true; // Remove any leading '-' signs

    x = x.replace(/^-+/, '');
  }

  x = trimEnd(x); // Number of decimal places number has

  var decimalPos = x.indexOf('.');

  if (decimalPos === -1) {
    out = x + '.' + addZeros('', minPrecision);
  } else {
    var numDecimals = x.length - decimalPos - 1;

    if (numDecimals > maxPrecision) {
      out = x.substr(0, x.length - (numDecimals - maxPrecision));
    } else if (numDecimals < minPrecision) {
      out = x + addZeros('', minPrecision - numDecimals);
    } else {
      out = x;
    }
  } // Remove trailing "." if there is one


  out = out.replace(/\.+$/, '');

  if (negative) {
    out = '-' + out;
  }

  return out;
}

function log10(x) {
  if (!(x.match(/^[0-1]+$/g) !== null)) {
    throw new Error('InvalidLogInputValue: Must be a power of 10');
  }

  if (!x.startsWith('1')) {
    throw new Error('InvalidLogInputValue: Must not have leading zeros');
  }

  if ((x.match(/1/g) || []).length > 1) {
    throw new Error('InvalidLogInputValue: Must be power of 10.');
  }

  return (x.match(/0/g) || []).length;
}

var bns = {
  add: add,
  sub: sub,
  mul: mul,
  div: div,
  gt: gt,
  lt: lt,
  gte: gte,
  lte: lte,
  eq: eq,
  min: min,
  max: max,
  log10: log10,
  toFixed: toFixed,
  abs: abs
};


/***/ }),

/***/ "./node_modules/biggystring/node_modules/bn.js/lib/bn.js":
/*!***************************************************************!*\
  !*** ./node_modules/biggystring/node_modules/bn.js/lib/bn.js ***!
  \***************************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

/* module decorator */ module = __webpack_require__.nmd(module);
function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

(function (module, exports) {
  'use strict'; // Utils

  function assert(val, msg) {
    if (!val) throw new Error(msg || 'Assertion failed');
  } // Could use `inherits` module, but don't want to move from single file
  // architecture yet.


  function inherits(ctor, superCtor) {
    ctor.super_ = superCtor;

    var TempCtor = function TempCtor() {};

    TempCtor.prototype = superCtor.prototype;
    ctor.prototype = new TempCtor();
    ctor.prototype.constructor = ctor;
  } // BN


  function BN(number, base, endian) {
    if (BN.isBN(number)) {
      return number;
    }

    this.negative = 0;
    this.words = null;
    this.length = 0; // Reduction context

    this.red = null;

    if (number !== null) {
      if (base === 'le' || base === 'be') {
        endian = base;
        base = 10;
      }

      this._init(number || 0, base || 10, endian || 'be');
    }
  }

  if (_typeof(module) === 'object') {
    module.exports = BN;
  } else {
    exports.BN = BN;
  }

  BN.BN = BN;
  BN.wordSize = 26;
  var Buffer;

  try {
    Buffer = __webpack_require__(/*! buffer */ "?3521").Buffer;
  } catch (e) {}

  BN.isBN = function isBN(num) {
    if (num instanceof BN) {
      return true;
    }

    return num !== null && _typeof(num) === 'object' && num.constructor.wordSize === BN.wordSize && Array.isArray(num.words);
  };

  BN.max = function max(left, right) {
    if (left.cmp(right) > 0) return left;
    return right;
  };

  BN.min = function min(left, right) {
    if (left.cmp(right) < 0) return left;
    return right;
  };

  BN.prototype._init = function init(number, base, endian) {
    if (typeof number === 'number') {
      return this._initNumber(number, base, endian);
    }

    if (_typeof(number) === 'object') {
      return this._initArray(number, base, endian);
    }

    if (base === 'hex') {
      base = 16;
    }

    assert(base === (base | 0) && base >= 2 && base <= 36);
    number = number.toString().replace(/\s+/g, '');
    var start = 0;

    if (number[0] === '-') {
      start++;
    }

    if (base === 16) {
      this._parseHex(number, start);
    } else {
      this._parseBase(number, base, start);
    }

    if (number[0] === '-') {
      this.negative = 1;
    }

    this.strip();
    if (endian !== 'le') return;

    this._initArray(this.toArray(), base, endian);
  };

  BN.prototype._initNumber = function _initNumber(number, base, endian) {
    if (number < 0) {
      this.negative = 1;
      number = -number;
    }

    if (number < 0x4000000) {
      this.words = [number & 0x3ffffff];
      this.length = 1;
    } else if (number < 0x10000000000000) {
      this.words = [number & 0x3ffffff, number / 0x4000000 & 0x3ffffff];
      this.length = 2;
    } else {
      assert(number < 0x20000000000000); // 2 ^ 53 (unsafe)

      this.words = [number & 0x3ffffff, number / 0x4000000 & 0x3ffffff, 1];
      this.length = 3;
    }

    if (endian !== 'le') return; // Reverse the bytes

    this._initArray(this.toArray(), base, endian);
  };

  BN.prototype._initArray = function _initArray(number, base, endian) {
    // Perhaps a Uint8Array
    assert(typeof number.length === 'number');

    if (number.length <= 0) {
      this.words = [0];
      this.length = 1;
      return this;
    }

    this.length = Math.ceil(number.length / 3);
    this.words = new Array(this.length);

    for (var i = 0; i < this.length; i++) {
      this.words[i] = 0;
    }

    var j, w;
    var off = 0;

    if (endian === 'be') {
      for (i = number.length - 1, j = 0; i >= 0; i -= 3) {
        w = number[i] | number[i - 1] << 8 | number[i - 2] << 16;
        this.words[j] |= w << off & 0x3ffffff;
        this.words[j + 1] = w >>> 26 - off & 0x3ffffff;
        off += 24;

        if (off >= 26) {
          off -= 26;
          j++;
        }
      }
    } else if (endian === 'le') {
      for (i = 0, j = 0; i < number.length; i += 3) {
        w = number[i] | number[i + 1] << 8 | number[i + 2] << 16;
        this.words[j] |= w << off & 0x3ffffff;
        this.words[j + 1] = w >>> 26 - off & 0x3ffffff;
        off += 24;

        if (off >= 26) {
          off -= 26;
          j++;
        }
      }
    }

    return this.strip();
  };

  function parseHex(str, start, end) {
    var r = 0;
    var len = Math.min(str.length, end);

    for (var i = start; i < len; i++) {
      var c = str.charCodeAt(i) - 48;
      r <<= 4; // 'a' - 'f'

      if (c >= 49 && c <= 54) {
        r |= c - 49 + 0xa; // 'A' - 'F'
      } else if (c >= 17 && c <= 22) {
        r |= c - 17 + 0xa; // '0' - '9'
      } else {
        r |= c & 0xf;
      }
    }

    return r;
  }

  BN.prototype._parseHex = function _parseHex(number, start) {
    // Create possibly bigger array to ensure that it fits the number
    this.length = Math.ceil((number.length - start) / 6);
    this.words = new Array(this.length);

    for (var i = 0; i < this.length; i++) {
      this.words[i] = 0;
    }

    var j, w; // Scan 24-bit chunks and add them to the number

    var off = 0;

    for (i = number.length - 6, j = 0; i >= start; i -= 6) {
      w = parseHex(number, i, i + 6);
      this.words[j] |= w << off & 0x3ffffff; // NOTE: `0x3fffff` is intentional here, 26bits max shift + 24bit hex limb

      this.words[j + 1] |= w >>> 26 - off & 0x3fffff;
      off += 24;

      if (off >= 26) {
        off -= 26;
        j++;
      }
    }

    if (i + 6 !== start) {
      w = parseHex(number, start, i + 6);
      this.words[j] |= w << off & 0x3ffffff;
      this.words[j + 1] |= w >>> 26 - off & 0x3fffff;
    }

    this.strip();
  };

  function parseBase(str, start, end, mul) {
    var r = 0;
    var len = Math.min(str.length, end);

    for (var i = start; i < len; i++) {
      var c = str.charCodeAt(i) - 48;
      r *= mul; // 'a'

      if (c >= 49) {
        r += c - 49 + 0xa; // 'A'
      } else if (c >= 17) {
        r += c - 17 + 0xa; // '0' - '9'
      } else {
        r += c;
      }
    }

    return r;
  }

  BN.prototype._parseBase = function _parseBase(number, base, start) {
    // Initialize as zero
    this.words = [0];
    this.length = 1; // Find length of limb in base

    for (var limbLen = 0, limbPow = 1; limbPow <= 0x3ffffff; limbPow *= base) {
      limbLen++;
    }

    limbLen--;
    limbPow = limbPow / base | 0;
    var total = number.length - start;
    var mod = total % limbLen;
    var end = Math.min(total, total - mod) + start;
    var word = 0;

    for (var i = start; i < end; i += limbLen) {
      word = parseBase(number, i, i + limbLen, base);
      this.imuln(limbPow);

      if (this.words[0] + word < 0x4000000) {
        this.words[0] += word;
      } else {
        this._iaddn(word);
      }
    }

    if (mod !== 0) {
      var pow = 1;
      word = parseBase(number, i, number.length, base);

      for (i = 0; i < mod; i++) {
        pow *= base;
      }

      this.imuln(pow);

      if (this.words[0] + word < 0x4000000) {
        this.words[0] += word;
      } else {
        this._iaddn(word);
      }
    }
  };

  BN.prototype.copy = function copy(dest) {
    dest.words = new Array(this.length);

    for (var i = 0; i < this.length; i++) {
      dest.words[i] = this.words[i];
    }

    dest.length = this.length;
    dest.negative = this.negative;
    dest.red = this.red;
  };

  BN.prototype.clone = function clone() {
    var r = new BN(null);
    this.copy(r);
    return r;
  };

  BN.prototype._expand = function _expand(size) {
    while (this.length < size) {
      this.words[this.length++] = 0;
    }

    return this;
  }; // Remove leading `0` from `this`


  BN.prototype.strip = function strip() {
    while (this.length > 1 && this.words[this.length - 1] === 0) {
      this.length--;
    }

    return this._normSign();
  };

  BN.prototype._normSign = function _normSign() {
    // -0 = 0
    if (this.length === 1 && this.words[0] === 0) {
      this.negative = 0;
    }

    return this;
  };

  BN.prototype.inspect = function inspect() {
    return (this.red ? '<BN-R: ' : '<BN: ') + this.toString(16) + '>';
  };
  /*
   var zeros = [];
  var groupSizes = [];
  var groupBases = [];
   var s = '';
  var i = -1;
  while (++i < BN.wordSize) {
    zeros[i] = s;
    s += '0';
  }
  groupSizes[0] = 0;
  groupSizes[1] = 0;
  groupBases[0] = 0;
  groupBases[1] = 0;
  var base = 2 - 1;
  while (++base < 36 + 1) {
    var groupSize = 0;
    var groupBase = 1;
    while (groupBase < (1 << BN.wordSize) / base) {
      groupBase *= base;
      groupSize += 1;
    }
    groupSizes[base] = groupSize;
    groupBases[base] = groupBase;
  }
   */


  var zeros = ['', '0', '00', '000', '0000', '00000', '000000', '0000000', '00000000', '000000000', '0000000000', '00000000000', '000000000000', '0000000000000', '00000000000000', '000000000000000', '0000000000000000', '00000000000000000', '000000000000000000', '0000000000000000000', '00000000000000000000', '000000000000000000000', '0000000000000000000000', '00000000000000000000000', '000000000000000000000000', '0000000000000000000000000'];
  var groupSizes = [0, 0, 25, 16, 12, 11, 10, 9, 8, 8, 7, 7, 7, 7, 6, 6, 6, 6, 6, 6, 6, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5];
  var groupBases = [0, 0, 33554432, 43046721, 16777216, 48828125, 60466176, 40353607, 16777216, 43046721, 10000000, 19487171, 35831808, 62748517, 7529536, 11390625, 16777216, 24137569, 34012224, 47045881, 64000000, 4084101, 5153632, 6436343, 7962624, 9765625, 11881376, 14348907, 17210368, 20511149, 24300000, 28629151, 33554432, 39135393, 45435424, 52521875, 60466176];

  BN.prototype.toString = function toString(base, padding) {
    base = base || 10;
    padding = padding | 0 || 1;
    var out;

    if (base === 16 || base === 'hex') {
      out = '';
      var off = 0;
      var carry = 0;

      for (var i = 0; i < this.length; i++) {
        var w = this.words[i];
        var word = ((w << off | carry) & 0xffffff).toString(16);
        carry = w >>> 24 - off & 0xffffff;

        if (carry !== 0 || i !== this.length - 1) {
          out = zeros[6 - word.length] + word + out;
        } else {
          out = word + out;
        }

        off += 2;

        if (off >= 26) {
          off -= 26;
          i--;
        }
      }

      if (carry !== 0) {
        out = carry.toString(16) + out;
      }

      while (out.length % padding !== 0) {
        out = '0' + out;
      }

      if (this.negative !== 0) {
        out = '-' + out;
      }

      return out;
    }

    if (base === (base | 0) && base >= 2 && base <= 36) {
      // var groupSize = Math.floor(BN.wordSize * Math.LN2 / Math.log(base));
      var groupSize = groupSizes[base]; // var groupBase = Math.pow(base, groupSize);

      var groupBase = groupBases[base];
      out = '';
      var c = this.clone();
      c.negative = 0;

      while (!c.isZero()) {
        var r = c.modn(groupBase).toString(base);
        c = c.idivn(groupBase);

        if (!c.isZero()) {
          out = zeros[groupSize - r.length] + r + out;
        } else {
          out = r + out;
        }
      }

      if (this.isZero()) {
        out = '0' + out;
      }

      while (out.length % padding !== 0) {
        out = '0' + out;
      }

      if (this.negative !== 0) {
        out = '-' + out;
      }

      return out;
    }

    assert(false, 'Base should be between 2 and 36');
  };

  BN.prototype.toNumber = function toNumber() {
    var ret = this.words[0];

    if (this.length === 2) {
      ret += this.words[1] * 0x4000000;
    } else if (this.length === 3 && this.words[2] === 0x01) {
      // NOTE: at this stage it is known that the top bit is set
      ret += 0x10000000000000 + this.words[1] * 0x4000000;
    } else if (this.length > 2) {
      assert(false, 'Number can only safely store up to 53 bits');
    }

    return this.negative !== 0 ? -ret : ret;
  };

  BN.prototype.toJSON = function toJSON() {
    return this.toString(16);
  };

  BN.prototype.toBuffer = function toBuffer(endian, length) {
    assert(typeof Buffer !== 'undefined');
    return this.toArrayLike(Buffer, endian, length);
  };

  BN.prototype.toArray = function toArray(endian, length) {
    return this.toArrayLike(Array, endian, length);
  };

  BN.prototype.toArrayLike = function toArrayLike(ArrayType, endian, length) {
    var byteLength = this.byteLength();
    var reqLength = length || Math.max(1, byteLength);
    assert(byteLength <= reqLength, 'byte array longer than desired length');
    assert(reqLength > 0, 'Requested array length <= 0');
    this.strip();
    var littleEndian = endian === 'le';
    var res = new ArrayType(reqLength);
    var b, i;
    var q = this.clone();

    if (!littleEndian) {
      // Assume big-endian
      for (i = 0; i < reqLength - byteLength; i++) {
        res[i] = 0;
      }

      for (i = 0; !q.isZero(); i++) {
        b = q.andln(0xff);
        q.iushrn(8);
        res[reqLength - i - 1] = b;
      }
    } else {
      for (i = 0; !q.isZero(); i++) {
        b = q.andln(0xff);
        q.iushrn(8);
        res[i] = b;
      }

      for (; i < reqLength; i++) {
        res[i] = 0;
      }
    }

    return res;
  };

  if (Math.clz32) {
    BN.prototype._countBits = function _countBits(w) {
      return 32 - Math.clz32(w);
    };
  } else {
    BN.prototype._countBits = function _countBits(w) {
      var t = w;
      var r = 0;

      if (t >= 0x1000) {
        r += 13;
        t >>>= 13;
      }

      if (t >= 0x40) {
        r += 7;
        t >>>= 7;
      }

      if (t >= 0x8) {
        r += 4;
        t >>>= 4;
      }

      if (t >= 0x02) {
        r += 2;
        t >>>= 2;
      }

      return r + t;
    };
  }

  BN.prototype._zeroBits = function _zeroBits(w) {
    // Short-cut
    if (w === 0) return 26;
    var t = w;
    var r = 0;

    if ((t & 0x1fff) === 0) {
      r += 13;
      t >>>= 13;
    }

    if ((t & 0x7f) === 0) {
      r += 7;
      t >>>= 7;
    }

    if ((t & 0xf) === 0) {
      r += 4;
      t >>>= 4;
    }

    if ((t & 0x3) === 0) {
      r += 2;
      t >>>= 2;
    }

    if ((t & 0x1) === 0) {
      r++;
    }

    return r;
  }; // Return number of used bits in a BN


  BN.prototype.bitLength = function bitLength() {
    var w = this.words[this.length - 1];

    var hi = this._countBits(w);

    return (this.length - 1) * 26 + hi;
  };

  function toBitArray(num) {
    var w = new Array(num.bitLength());

    for (var bit = 0; bit < w.length; bit++) {
      var off = bit / 26 | 0;
      var wbit = bit % 26;
      w[bit] = (num.words[off] & 1 << wbit) >>> wbit;
    }

    return w;
  } // Number of trailing zero bits


  BN.prototype.zeroBits = function zeroBits() {
    if (this.isZero()) return 0;
    var r = 0;

    for (var i = 0; i < this.length; i++) {
      var b = this._zeroBits(this.words[i]);

      r += b;
      if (b !== 26) break;
    }

    return r;
  };

  BN.prototype.byteLength = function byteLength() {
    return Math.ceil(this.bitLength() / 8);
  };

  BN.prototype.toTwos = function toTwos(width) {
    if (this.negative !== 0) {
      return this.abs().inotn(width).iaddn(1);
    }

    return this.clone();
  };

  BN.prototype.fromTwos = function fromTwos(width) {
    if (this.testn(width - 1)) {
      return this.notn(width).iaddn(1).ineg();
    }

    return this.clone();
  };

  BN.prototype.isNeg = function isNeg() {
    return this.negative !== 0;
  }; // Return negative clone of `this`


  BN.prototype.neg = function neg() {
    return this.clone().ineg();
  };

  BN.prototype.ineg = function ineg() {
    if (!this.isZero()) {
      this.negative ^= 1;
    }

    return this;
  }; // Or `num` with `this` in-place


  BN.prototype.iuor = function iuor(num) {
    while (this.length < num.length) {
      this.words[this.length++] = 0;
    }

    for (var i = 0; i < num.length; i++) {
      this.words[i] = this.words[i] | num.words[i];
    }

    return this.strip();
  };

  BN.prototype.ior = function ior(num) {
    assert((this.negative | num.negative) === 0);
    return this.iuor(num);
  }; // Or `num` with `this`


  BN.prototype.or = function or(num) {
    if (this.length > num.length) return this.clone().ior(num);
    return num.clone().ior(this);
  };

  BN.prototype.uor = function uor(num) {
    if (this.length > num.length) return this.clone().iuor(num);
    return num.clone().iuor(this);
  }; // And `num` with `this` in-place


  BN.prototype.iuand = function iuand(num) {
    // b = min-length(num, this)
    var b;

    if (this.length > num.length) {
      b = num;
    } else {
      b = this;
    }

    for (var i = 0; i < b.length; i++) {
      this.words[i] = this.words[i] & num.words[i];
    }

    this.length = b.length;
    return this.strip();
  };

  BN.prototype.iand = function iand(num) {
    assert((this.negative | num.negative) === 0);
    return this.iuand(num);
  }; // And `num` with `this`


  BN.prototype.and = function and(num) {
    if (this.length > num.length) return this.clone().iand(num);
    return num.clone().iand(this);
  };

  BN.prototype.uand = function uand(num) {
    if (this.length > num.length) return this.clone().iuand(num);
    return num.clone().iuand(this);
  }; // Xor `num` with `this` in-place


  BN.prototype.iuxor = function iuxor(num) {
    // a.length > b.length
    var a;
    var b;

    if (this.length > num.length) {
      a = this;
      b = num;
    } else {
      a = num;
      b = this;
    }

    for (var i = 0; i < b.length; i++) {
      this.words[i] = a.words[i] ^ b.words[i];
    }

    if (this !== a) {
      for (; i < a.length; i++) {
        this.words[i] = a.words[i];
      }
    }

    this.length = a.length;
    return this.strip();
  };

  BN.prototype.ixor = function ixor(num) {
    assert((this.negative | num.negative) === 0);
    return this.iuxor(num);
  }; // Xor `num` with `this`


  BN.prototype.xor = function xor(num) {
    if (this.length > num.length) return this.clone().ixor(num);
    return num.clone().ixor(this);
  };

  BN.prototype.uxor = function uxor(num) {
    if (this.length > num.length) return this.clone().iuxor(num);
    return num.clone().iuxor(this);
  }; // Not ``this`` with ``width`` bitwidth


  BN.prototype.inotn = function inotn(width) {
    assert(typeof width === 'number' && width >= 0);
    var bytesNeeded = Math.ceil(width / 26) | 0;
    var bitsLeft = width % 26; // Extend the buffer with leading zeroes

    this._expand(bytesNeeded);

    if (bitsLeft > 0) {
      bytesNeeded--;
    } // Handle complete words


    for (var i = 0; i < bytesNeeded; i++) {
      this.words[i] = ~this.words[i] & 0x3ffffff;
    } // Handle the residue


    if (bitsLeft > 0) {
      this.words[i] = ~this.words[i] & 0x3ffffff >> 26 - bitsLeft;
    } // And remove leading zeroes


    return this.strip();
  };

  BN.prototype.notn = function notn(width) {
    return this.clone().inotn(width);
  }; // Set `bit` of `this`


  BN.prototype.setn = function setn(bit, val) {
    assert(typeof bit === 'number' && bit >= 0);
    var off = bit / 26 | 0;
    var wbit = bit % 26;

    this._expand(off + 1);

    if (val) {
      this.words[off] = this.words[off] | 1 << wbit;
    } else {
      this.words[off] = this.words[off] & ~(1 << wbit);
    }

    return this.strip();
  }; // Add `num` to `this` in-place


  BN.prototype.iadd = function iadd(num) {
    var r; // negative + positive

    if (this.negative !== 0 && num.negative === 0) {
      this.negative = 0;
      r = this.isub(num);
      this.negative ^= 1;
      return this._normSign(); // positive + negative
    } else if (this.negative === 0 && num.negative !== 0) {
      num.negative = 0;
      r = this.isub(num);
      num.negative = 1;
      return r._normSign();
    } // a.length > b.length


    var a, b;

    if (this.length > num.length) {
      a = this;
      b = num;
    } else {
      a = num;
      b = this;
    }

    var carry = 0;

    for (var i = 0; i < b.length; i++) {
      r = (a.words[i] | 0) + (b.words[i] | 0) + carry;
      this.words[i] = r & 0x3ffffff;
      carry = r >>> 26;
    }

    for (; carry !== 0 && i < a.length; i++) {
      r = (a.words[i] | 0) + carry;
      this.words[i] = r & 0x3ffffff;
      carry = r >>> 26;
    }

    this.length = a.length;

    if (carry !== 0) {
      this.words[this.length] = carry;
      this.length++; // Copy the rest of the words
    } else if (a !== this) {
      for (; i < a.length; i++) {
        this.words[i] = a.words[i];
      }
    }

    return this;
  }; // Add `num` to `this`


  BN.prototype.add = function add(num) {
    var res;

    if (num.negative !== 0 && this.negative === 0) {
      num.negative = 0;
      res = this.sub(num);
      num.negative ^= 1;
      return res;
    } else if (num.negative === 0 && this.negative !== 0) {
      this.negative = 0;
      res = num.sub(this);
      this.negative = 1;
      return res;
    }

    if (this.length > num.length) return this.clone().iadd(num);
    return num.clone().iadd(this);
  }; // Subtract `num` from `this` in-place


  BN.prototype.isub = function isub(num) {
    // this - (-num) = this + num
    if (num.negative !== 0) {
      num.negative = 0;
      var r = this.iadd(num);
      num.negative = 1;
      return r._normSign(); // -this - num = -(this + num)
    } else if (this.negative !== 0) {
      this.negative = 0;
      this.iadd(num);
      this.negative = 1;
      return this._normSign();
    } // At this point both numbers are positive


    var cmp = this.cmp(num); // Optimization - zeroify

    if (cmp === 0) {
      this.negative = 0;
      this.length = 1;
      this.words[0] = 0;
      return this;
    } // a > b


    var a, b;

    if (cmp > 0) {
      a = this;
      b = num;
    } else {
      a = num;
      b = this;
    }

    var carry = 0;

    for (var i = 0; i < b.length; i++) {
      r = (a.words[i] | 0) - (b.words[i] | 0) + carry;
      carry = r >> 26;
      this.words[i] = r & 0x3ffffff;
    }

    for (; carry !== 0 && i < a.length; i++) {
      r = (a.words[i] | 0) + carry;
      carry = r >> 26;
      this.words[i] = r & 0x3ffffff;
    } // Copy rest of the words


    if (carry === 0 && i < a.length && a !== this) {
      for (; i < a.length; i++) {
        this.words[i] = a.words[i];
      }
    }

    this.length = Math.max(this.length, i);

    if (a !== this) {
      this.negative = 1;
    }

    return this.strip();
  }; // Subtract `num` from `this`


  BN.prototype.sub = function sub(num) {
    return this.clone().isub(num);
  };

  function smallMulTo(self, num, out) {
    out.negative = num.negative ^ self.negative;
    var len = self.length + num.length | 0;
    out.length = len;
    len = len - 1 | 0; // Peel one iteration (compiler can't do it, because of code complexity)

    var a = self.words[0] | 0;
    var b = num.words[0] | 0;
    var r = a * b;
    var lo = r & 0x3ffffff;
    var carry = r / 0x4000000 | 0;
    out.words[0] = lo;

    for (var k = 1; k < len; k++) {
      // Sum all words with the same `i + j = k` and accumulate `ncarry`,
      // note that ncarry could be >= 0x3ffffff
      var ncarry = carry >>> 26;
      var rword = carry & 0x3ffffff;
      var maxJ = Math.min(k, num.length - 1);

      for (var j = Math.max(0, k - self.length + 1); j <= maxJ; j++) {
        var i = k - j | 0;
        a = self.words[i] | 0;
        b = num.words[j] | 0;
        r = a * b + rword;
        ncarry += r / 0x4000000 | 0;
        rword = r & 0x3ffffff;
      }

      out.words[k] = rword | 0;
      carry = ncarry | 0;
    }

    if (carry !== 0) {
      out.words[k] = carry | 0;
    } else {
      out.length--;
    }

    return out.strip();
  } // TODO(indutny): it may be reasonable to omit it for users who don't need
  // to work with 256-bit numbers, otherwise it gives 20% improvement for 256-bit
  // multiplication (like elliptic secp256k1).


  var comb10MulTo = function comb10MulTo(self, num, out) {
    var a = self.words;
    var b = num.words;
    var o = out.words;
    var c = 0;
    var lo;
    var mid;
    var hi;
    var a0 = a[0] | 0;
    var al0 = a0 & 0x1fff;
    var ah0 = a0 >>> 13;
    var a1 = a[1] | 0;
    var al1 = a1 & 0x1fff;
    var ah1 = a1 >>> 13;
    var a2 = a[2] | 0;
    var al2 = a2 & 0x1fff;
    var ah2 = a2 >>> 13;
    var a3 = a[3] | 0;
    var al3 = a3 & 0x1fff;
    var ah3 = a3 >>> 13;
    var a4 = a[4] | 0;
    var al4 = a4 & 0x1fff;
    var ah4 = a4 >>> 13;
    var a5 = a[5] | 0;
    var al5 = a5 & 0x1fff;
    var ah5 = a5 >>> 13;
    var a6 = a[6] | 0;
    var al6 = a6 & 0x1fff;
    var ah6 = a6 >>> 13;
    var a7 = a[7] | 0;
    var al7 = a7 & 0x1fff;
    var ah7 = a7 >>> 13;
    var a8 = a[8] | 0;
    var al8 = a8 & 0x1fff;
    var ah8 = a8 >>> 13;
    var a9 = a[9] | 0;
    var al9 = a9 & 0x1fff;
    var ah9 = a9 >>> 13;
    var b0 = b[0] | 0;
    var bl0 = b0 & 0x1fff;
    var bh0 = b0 >>> 13;
    var b1 = b[1] | 0;
    var bl1 = b1 & 0x1fff;
    var bh1 = b1 >>> 13;
    var b2 = b[2] | 0;
    var bl2 = b2 & 0x1fff;
    var bh2 = b2 >>> 13;
    var b3 = b[3] | 0;
    var bl3 = b3 & 0x1fff;
    var bh3 = b3 >>> 13;
    var b4 = b[4] | 0;
    var bl4 = b4 & 0x1fff;
    var bh4 = b4 >>> 13;
    var b5 = b[5] | 0;
    var bl5 = b5 & 0x1fff;
    var bh5 = b5 >>> 13;
    var b6 = b[6] | 0;
    var bl6 = b6 & 0x1fff;
    var bh6 = b6 >>> 13;
    var b7 = b[7] | 0;
    var bl7 = b7 & 0x1fff;
    var bh7 = b7 >>> 13;
    var b8 = b[8] | 0;
    var bl8 = b8 & 0x1fff;
    var bh8 = b8 >>> 13;
    var b9 = b[9] | 0;
    var bl9 = b9 & 0x1fff;
    var bh9 = b9 >>> 13;
    out.negative = self.negative ^ num.negative;
    out.length = 19;
    /* k = 0 */

    lo = Math.imul(al0, bl0);
    mid = Math.imul(al0, bh0);
    mid = mid + Math.imul(ah0, bl0) | 0;
    hi = Math.imul(ah0, bh0);
    var w0 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w0 >>> 26) | 0;
    w0 &= 0x3ffffff;
    /* k = 1 */

    lo = Math.imul(al1, bl0);
    mid = Math.imul(al1, bh0);
    mid = mid + Math.imul(ah1, bl0) | 0;
    hi = Math.imul(ah1, bh0);
    lo = lo + Math.imul(al0, bl1) | 0;
    mid = mid + Math.imul(al0, bh1) | 0;
    mid = mid + Math.imul(ah0, bl1) | 0;
    hi = hi + Math.imul(ah0, bh1) | 0;
    var w1 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w1 >>> 26) | 0;
    w1 &= 0x3ffffff;
    /* k = 2 */

    lo = Math.imul(al2, bl0);
    mid = Math.imul(al2, bh0);
    mid = mid + Math.imul(ah2, bl0) | 0;
    hi = Math.imul(ah2, bh0);
    lo = lo + Math.imul(al1, bl1) | 0;
    mid = mid + Math.imul(al1, bh1) | 0;
    mid = mid + Math.imul(ah1, bl1) | 0;
    hi = hi + Math.imul(ah1, bh1) | 0;
    lo = lo + Math.imul(al0, bl2) | 0;
    mid = mid + Math.imul(al0, bh2) | 0;
    mid = mid + Math.imul(ah0, bl2) | 0;
    hi = hi + Math.imul(ah0, bh2) | 0;
    var w2 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w2 >>> 26) | 0;
    w2 &= 0x3ffffff;
    /* k = 3 */

    lo = Math.imul(al3, bl0);
    mid = Math.imul(al3, bh0);
    mid = mid + Math.imul(ah3, bl0) | 0;
    hi = Math.imul(ah3, bh0);
    lo = lo + Math.imul(al2, bl1) | 0;
    mid = mid + Math.imul(al2, bh1) | 0;
    mid = mid + Math.imul(ah2, bl1) | 0;
    hi = hi + Math.imul(ah2, bh1) | 0;
    lo = lo + Math.imul(al1, bl2) | 0;
    mid = mid + Math.imul(al1, bh2) | 0;
    mid = mid + Math.imul(ah1, bl2) | 0;
    hi = hi + Math.imul(ah1, bh2) | 0;
    lo = lo + Math.imul(al0, bl3) | 0;
    mid = mid + Math.imul(al0, bh3) | 0;
    mid = mid + Math.imul(ah0, bl3) | 0;
    hi = hi + Math.imul(ah0, bh3) | 0;
    var w3 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w3 >>> 26) | 0;
    w3 &= 0x3ffffff;
    /* k = 4 */

    lo = Math.imul(al4, bl0);
    mid = Math.imul(al4, bh0);
    mid = mid + Math.imul(ah4, bl0) | 0;
    hi = Math.imul(ah4, bh0);
    lo = lo + Math.imul(al3, bl1) | 0;
    mid = mid + Math.imul(al3, bh1) | 0;
    mid = mid + Math.imul(ah3, bl1) | 0;
    hi = hi + Math.imul(ah3, bh1) | 0;
    lo = lo + Math.imul(al2, bl2) | 0;
    mid = mid + Math.imul(al2, bh2) | 0;
    mid = mid + Math.imul(ah2, bl2) | 0;
    hi = hi + Math.imul(ah2, bh2) | 0;
    lo = lo + Math.imul(al1, bl3) | 0;
    mid = mid + Math.imul(al1, bh3) | 0;
    mid = mid + Math.imul(ah1, bl3) | 0;
    hi = hi + Math.imul(ah1, bh3) | 0;
    lo = lo + Math.imul(al0, bl4) | 0;
    mid = mid + Math.imul(al0, bh4) | 0;
    mid = mid + Math.imul(ah0, bl4) | 0;
    hi = hi + Math.imul(ah0, bh4) | 0;
    var w4 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w4 >>> 26) | 0;
    w4 &= 0x3ffffff;
    /* k = 5 */

    lo = Math.imul(al5, bl0);
    mid = Math.imul(al5, bh0);
    mid = mid + Math.imul(ah5, bl0) | 0;
    hi = Math.imul(ah5, bh0);
    lo = lo + Math.imul(al4, bl1) | 0;
    mid = mid + Math.imul(al4, bh1) | 0;
    mid = mid + Math.imul(ah4, bl1) | 0;
    hi = hi + Math.imul(ah4, bh1) | 0;
    lo = lo + Math.imul(al3, bl2) | 0;
    mid = mid + Math.imul(al3, bh2) | 0;
    mid = mid + Math.imul(ah3, bl2) | 0;
    hi = hi + Math.imul(ah3, bh2) | 0;
    lo = lo + Math.imul(al2, bl3) | 0;
    mid = mid + Math.imul(al2, bh3) | 0;
    mid = mid + Math.imul(ah2, bl3) | 0;
    hi = hi + Math.imul(ah2, bh3) | 0;
    lo = lo + Math.imul(al1, bl4) | 0;
    mid = mid + Math.imul(al1, bh4) | 0;
    mid = mid + Math.imul(ah1, bl4) | 0;
    hi = hi + Math.imul(ah1, bh4) | 0;
    lo = lo + Math.imul(al0, bl5) | 0;
    mid = mid + Math.imul(al0, bh5) | 0;
    mid = mid + Math.imul(ah0, bl5) | 0;
    hi = hi + Math.imul(ah0, bh5) | 0;
    var w5 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w5 >>> 26) | 0;
    w5 &= 0x3ffffff;
    /* k = 6 */

    lo = Math.imul(al6, bl0);
    mid = Math.imul(al6, bh0);
    mid = mid + Math.imul(ah6, bl0) | 0;
    hi = Math.imul(ah6, bh0);
    lo = lo + Math.imul(al5, bl1) | 0;
    mid = mid + Math.imul(al5, bh1) | 0;
    mid = mid + Math.imul(ah5, bl1) | 0;
    hi = hi + Math.imul(ah5, bh1) | 0;
    lo = lo + Math.imul(al4, bl2) | 0;
    mid = mid + Math.imul(al4, bh2) | 0;
    mid = mid + Math.imul(ah4, bl2) | 0;
    hi = hi + Math.imul(ah4, bh2) | 0;
    lo = lo + Math.imul(al3, bl3) | 0;
    mid = mid + Math.imul(al3, bh3) | 0;
    mid = mid + Math.imul(ah3, bl3) | 0;
    hi = hi + Math.imul(ah3, bh3) | 0;
    lo = lo + Math.imul(al2, bl4) | 0;
    mid = mid + Math.imul(al2, bh4) | 0;
    mid = mid + Math.imul(ah2, bl4) | 0;
    hi = hi + Math.imul(ah2, bh4) | 0;
    lo = lo + Math.imul(al1, bl5) | 0;
    mid = mid + Math.imul(al1, bh5) | 0;
    mid = mid + Math.imul(ah1, bl5) | 0;
    hi = hi + Math.imul(ah1, bh5) | 0;
    lo = lo + Math.imul(al0, bl6) | 0;
    mid = mid + Math.imul(al0, bh6) | 0;
    mid = mid + Math.imul(ah0, bl6) | 0;
    hi = hi + Math.imul(ah0, bh6) | 0;
    var w6 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w6 >>> 26) | 0;
    w6 &= 0x3ffffff;
    /* k = 7 */

    lo = Math.imul(al7, bl0);
    mid = Math.imul(al7, bh0);
    mid = mid + Math.imul(ah7, bl0) | 0;
    hi = Math.imul(ah7, bh0);
    lo = lo + Math.imul(al6, bl1) | 0;
    mid = mid + Math.imul(al6, bh1) | 0;
    mid = mid + Math.imul(ah6, bl1) | 0;
    hi = hi + Math.imul(ah6, bh1) | 0;
    lo = lo + Math.imul(al5, bl2) | 0;
    mid = mid + Math.imul(al5, bh2) | 0;
    mid = mid + Math.imul(ah5, bl2) | 0;
    hi = hi + Math.imul(ah5, bh2) | 0;
    lo = lo + Math.imul(al4, bl3) | 0;
    mid = mid + Math.imul(al4, bh3) | 0;
    mid = mid + Math.imul(ah4, bl3) | 0;
    hi = hi + Math.imul(ah4, bh3) | 0;
    lo = lo + Math.imul(al3, bl4) | 0;
    mid = mid + Math.imul(al3, bh4) | 0;
    mid = mid + Math.imul(ah3, bl4) | 0;
    hi = hi + Math.imul(ah3, bh4) | 0;
    lo = lo + Math.imul(al2, bl5) | 0;
    mid = mid + Math.imul(al2, bh5) | 0;
    mid = mid + Math.imul(ah2, bl5) | 0;
    hi = hi + Math.imul(ah2, bh5) | 0;
    lo = lo + Math.imul(al1, bl6) | 0;
    mid = mid + Math.imul(al1, bh6) | 0;
    mid = mid + Math.imul(ah1, bl6) | 0;
    hi = hi + Math.imul(ah1, bh6) | 0;
    lo = lo + Math.imul(al0, bl7) | 0;
    mid = mid + Math.imul(al0, bh7) | 0;
    mid = mid + Math.imul(ah0, bl7) | 0;
    hi = hi + Math.imul(ah0, bh7) | 0;
    var w7 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w7 >>> 26) | 0;
    w7 &= 0x3ffffff;
    /* k = 8 */

    lo = Math.imul(al8, bl0);
    mid = Math.imul(al8, bh0);
    mid = mid + Math.imul(ah8, bl0) | 0;
    hi = Math.imul(ah8, bh0);
    lo = lo + Math.imul(al7, bl1) | 0;
    mid = mid + Math.imul(al7, bh1) | 0;
    mid = mid + Math.imul(ah7, bl1) | 0;
    hi = hi + Math.imul(ah7, bh1) | 0;
    lo = lo + Math.imul(al6, bl2) | 0;
    mid = mid + Math.imul(al6, bh2) | 0;
    mid = mid + Math.imul(ah6, bl2) | 0;
    hi = hi + Math.imul(ah6, bh2) | 0;
    lo = lo + Math.imul(al5, bl3) | 0;
    mid = mid + Math.imul(al5, bh3) | 0;
    mid = mid + Math.imul(ah5, bl3) | 0;
    hi = hi + Math.imul(ah5, bh3) | 0;
    lo = lo + Math.imul(al4, bl4) | 0;
    mid = mid + Math.imul(al4, bh4) | 0;
    mid = mid + Math.imul(ah4, bl4) | 0;
    hi = hi + Math.imul(ah4, bh4) | 0;
    lo = lo + Math.imul(al3, bl5) | 0;
    mid = mid + Math.imul(al3, bh5) | 0;
    mid = mid + Math.imul(ah3, bl5) | 0;
    hi = hi + Math.imul(ah3, bh5) | 0;
    lo = lo + Math.imul(al2, bl6) | 0;
    mid = mid + Math.imul(al2, bh6) | 0;
    mid = mid + Math.imul(ah2, bl6) | 0;
    hi = hi + Math.imul(ah2, bh6) | 0;
    lo = lo + Math.imul(al1, bl7) | 0;
    mid = mid + Math.imul(al1, bh7) | 0;
    mid = mid + Math.imul(ah1, bl7) | 0;
    hi = hi + Math.imul(ah1, bh7) | 0;
    lo = lo + Math.imul(al0, bl8) | 0;
    mid = mid + Math.imul(al0, bh8) | 0;
    mid = mid + Math.imul(ah0, bl8) | 0;
    hi = hi + Math.imul(ah0, bh8) | 0;
    var w8 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w8 >>> 26) | 0;
    w8 &= 0x3ffffff;
    /* k = 9 */

    lo = Math.imul(al9, bl0);
    mid = Math.imul(al9, bh0);
    mid = mid + Math.imul(ah9, bl0) | 0;
    hi = Math.imul(ah9, bh0);
    lo = lo + Math.imul(al8, bl1) | 0;
    mid = mid + Math.imul(al8, bh1) | 0;
    mid = mid + Math.imul(ah8, bl1) | 0;
    hi = hi + Math.imul(ah8, bh1) | 0;
    lo = lo + Math.imul(al7, bl2) | 0;
    mid = mid + Math.imul(al7, bh2) | 0;
    mid = mid + Math.imul(ah7, bl2) | 0;
    hi = hi + Math.imul(ah7, bh2) | 0;
    lo = lo + Math.imul(al6, bl3) | 0;
    mid = mid + Math.imul(al6, bh3) | 0;
    mid = mid + Math.imul(ah6, bl3) | 0;
    hi = hi + Math.imul(ah6, bh3) | 0;
    lo = lo + Math.imul(al5, bl4) | 0;
    mid = mid + Math.imul(al5, bh4) | 0;
    mid = mid + Math.imul(ah5, bl4) | 0;
    hi = hi + Math.imul(ah5, bh4) | 0;
    lo = lo + Math.imul(al4, bl5) | 0;
    mid = mid + Math.imul(al4, bh5) | 0;
    mid = mid + Math.imul(ah4, bl5) | 0;
    hi = hi + Math.imul(ah4, bh5) | 0;
    lo = lo + Math.imul(al3, bl6) | 0;
    mid = mid + Math.imul(al3, bh6) | 0;
    mid = mid + Math.imul(ah3, bl6) | 0;
    hi = hi + Math.imul(ah3, bh6) | 0;
    lo = lo + Math.imul(al2, bl7) | 0;
    mid = mid + Math.imul(al2, bh7) | 0;
    mid = mid + Math.imul(ah2, bl7) | 0;
    hi = hi + Math.imul(ah2, bh7) | 0;
    lo = lo + Math.imul(al1, bl8) | 0;
    mid = mid + Math.imul(al1, bh8) | 0;
    mid = mid + Math.imul(ah1, bl8) | 0;
    hi = hi + Math.imul(ah1, bh8) | 0;
    lo = lo + Math.imul(al0, bl9) | 0;
    mid = mid + Math.imul(al0, bh9) | 0;
    mid = mid + Math.imul(ah0, bl9) | 0;
    hi = hi + Math.imul(ah0, bh9) | 0;
    var w9 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w9 >>> 26) | 0;
    w9 &= 0x3ffffff;
    /* k = 10 */

    lo = Math.imul(al9, bl1);
    mid = Math.imul(al9, bh1);
    mid = mid + Math.imul(ah9, bl1) | 0;
    hi = Math.imul(ah9, bh1);
    lo = lo + Math.imul(al8, bl2) | 0;
    mid = mid + Math.imul(al8, bh2) | 0;
    mid = mid + Math.imul(ah8, bl2) | 0;
    hi = hi + Math.imul(ah8, bh2) | 0;
    lo = lo + Math.imul(al7, bl3) | 0;
    mid = mid + Math.imul(al7, bh3) | 0;
    mid = mid + Math.imul(ah7, bl3) | 0;
    hi = hi + Math.imul(ah7, bh3) | 0;
    lo = lo + Math.imul(al6, bl4) | 0;
    mid = mid + Math.imul(al6, bh4) | 0;
    mid = mid + Math.imul(ah6, bl4) | 0;
    hi = hi + Math.imul(ah6, bh4) | 0;
    lo = lo + Math.imul(al5, bl5) | 0;
    mid = mid + Math.imul(al5, bh5) | 0;
    mid = mid + Math.imul(ah5, bl5) | 0;
    hi = hi + Math.imul(ah5, bh5) | 0;
    lo = lo + Math.imul(al4, bl6) | 0;
    mid = mid + Math.imul(al4, bh6) | 0;
    mid = mid + Math.imul(ah4, bl6) | 0;
    hi = hi + Math.imul(ah4, bh6) | 0;
    lo = lo + Math.imul(al3, bl7) | 0;
    mid = mid + Math.imul(al3, bh7) | 0;
    mid = mid + Math.imul(ah3, bl7) | 0;
    hi = hi + Math.imul(ah3, bh7) | 0;
    lo = lo + Math.imul(al2, bl8) | 0;
    mid = mid + Math.imul(al2, bh8) | 0;
    mid = mid + Math.imul(ah2, bl8) | 0;
    hi = hi + Math.imul(ah2, bh8) | 0;
    lo = lo + Math.imul(al1, bl9) | 0;
    mid = mid + Math.imul(al1, bh9) | 0;
    mid = mid + Math.imul(ah1, bl9) | 0;
    hi = hi + Math.imul(ah1, bh9) | 0;
    var w10 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w10 >>> 26) | 0;
    w10 &= 0x3ffffff;
    /* k = 11 */

    lo = Math.imul(al9, bl2);
    mid = Math.imul(al9, bh2);
    mid = mid + Math.imul(ah9, bl2) | 0;
    hi = Math.imul(ah9, bh2);
    lo = lo + Math.imul(al8, bl3) | 0;
    mid = mid + Math.imul(al8, bh3) | 0;
    mid = mid + Math.imul(ah8, bl3) | 0;
    hi = hi + Math.imul(ah8, bh3) | 0;
    lo = lo + Math.imul(al7, bl4) | 0;
    mid = mid + Math.imul(al7, bh4) | 0;
    mid = mid + Math.imul(ah7, bl4) | 0;
    hi = hi + Math.imul(ah7, bh4) | 0;
    lo = lo + Math.imul(al6, bl5) | 0;
    mid = mid + Math.imul(al6, bh5) | 0;
    mid = mid + Math.imul(ah6, bl5) | 0;
    hi = hi + Math.imul(ah6, bh5) | 0;
    lo = lo + Math.imul(al5, bl6) | 0;
    mid = mid + Math.imul(al5, bh6) | 0;
    mid = mid + Math.imul(ah5, bl6) | 0;
    hi = hi + Math.imul(ah5, bh6) | 0;
    lo = lo + Math.imul(al4, bl7) | 0;
    mid = mid + Math.imul(al4, bh7) | 0;
    mid = mid + Math.imul(ah4, bl7) | 0;
    hi = hi + Math.imul(ah4, bh7) | 0;
    lo = lo + Math.imul(al3, bl8) | 0;
    mid = mid + Math.imul(al3, bh8) | 0;
    mid = mid + Math.imul(ah3, bl8) | 0;
    hi = hi + Math.imul(ah3, bh8) | 0;
    lo = lo + Math.imul(al2, bl9) | 0;
    mid = mid + Math.imul(al2, bh9) | 0;
    mid = mid + Math.imul(ah2, bl9) | 0;
    hi = hi + Math.imul(ah2, bh9) | 0;
    var w11 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w11 >>> 26) | 0;
    w11 &= 0x3ffffff;
    /* k = 12 */

    lo = Math.imul(al9, bl3);
    mid = Math.imul(al9, bh3);
    mid = mid + Math.imul(ah9, bl3) | 0;
    hi = Math.imul(ah9, bh3);
    lo = lo + Math.imul(al8, bl4) | 0;
    mid = mid + Math.imul(al8, bh4) | 0;
    mid = mid + Math.imul(ah8, bl4) | 0;
    hi = hi + Math.imul(ah8, bh4) | 0;
    lo = lo + Math.imul(al7, bl5) | 0;
    mid = mid + Math.imul(al7, bh5) | 0;
    mid = mid + Math.imul(ah7, bl5) | 0;
    hi = hi + Math.imul(ah7, bh5) | 0;
    lo = lo + Math.imul(al6, bl6) | 0;
    mid = mid + Math.imul(al6, bh6) | 0;
    mid = mid + Math.imul(ah6, bl6) | 0;
    hi = hi + Math.imul(ah6, bh6) | 0;
    lo = lo + Math.imul(al5, bl7) | 0;
    mid = mid + Math.imul(al5, bh7) | 0;
    mid = mid + Math.imul(ah5, bl7) | 0;
    hi = hi + Math.imul(ah5, bh7) | 0;
    lo = lo + Math.imul(al4, bl8) | 0;
    mid = mid + Math.imul(al4, bh8) | 0;
    mid = mid + Math.imul(ah4, bl8) | 0;
    hi = hi + Math.imul(ah4, bh8) | 0;
    lo = lo + Math.imul(al3, bl9) | 0;
    mid = mid + Math.imul(al3, bh9) | 0;
    mid = mid + Math.imul(ah3, bl9) | 0;
    hi = hi + Math.imul(ah3, bh9) | 0;
    var w12 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w12 >>> 26) | 0;
    w12 &= 0x3ffffff;
    /* k = 13 */

    lo = Math.imul(al9, bl4);
    mid = Math.imul(al9, bh4);
    mid = mid + Math.imul(ah9, bl4) | 0;
    hi = Math.imul(ah9, bh4);
    lo = lo + Math.imul(al8, bl5) | 0;
    mid = mid + Math.imul(al8, bh5) | 0;
    mid = mid + Math.imul(ah8, bl5) | 0;
    hi = hi + Math.imul(ah8, bh5) | 0;
    lo = lo + Math.imul(al7, bl6) | 0;
    mid = mid + Math.imul(al7, bh6) | 0;
    mid = mid + Math.imul(ah7, bl6) | 0;
    hi = hi + Math.imul(ah7, bh6) | 0;
    lo = lo + Math.imul(al6, bl7) | 0;
    mid = mid + Math.imul(al6, bh7) | 0;
    mid = mid + Math.imul(ah6, bl7) | 0;
    hi = hi + Math.imul(ah6, bh7) | 0;
    lo = lo + Math.imul(al5, bl8) | 0;
    mid = mid + Math.imul(al5, bh8) | 0;
    mid = mid + Math.imul(ah5, bl8) | 0;
    hi = hi + Math.imul(ah5, bh8) | 0;
    lo = lo + Math.imul(al4, bl9) | 0;
    mid = mid + Math.imul(al4, bh9) | 0;
    mid = mid + Math.imul(ah4, bl9) | 0;
    hi = hi + Math.imul(ah4, bh9) | 0;
    var w13 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w13 >>> 26) | 0;
    w13 &= 0x3ffffff;
    /* k = 14 */

    lo = Math.imul(al9, bl5);
    mid = Math.imul(al9, bh5);
    mid = mid + Math.imul(ah9, bl5) | 0;
    hi = Math.imul(ah9, bh5);
    lo = lo + Math.imul(al8, bl6) | 0;
    mid = mid + Math.imul(al8, bh6) | 0;
    mid = mid + Math.imul(ah8, bl6) | 0;
    hi = hi + Math.imul(ah8, bh6) | 0;
    lo = lo + Math.imul(al7, bl7) | 0;
    mid = mid + Math.imul(al7, bh7) | 0;
    mid = mid + Math.imul(ah7, bl7) | 0;
    hi = hi + Math.imul(ah7, bh7) | 0;
    lo = lo + Math.imul(al6, bl8) | 0;
    mid = mid + Math.imul(al6, bh8) | 0;
    mid = mid + Math.imul(ah6, bl8) | 0;
    hi = hi + Math.imul(ah6, bh8) | 0;
    lo = lo + Math.imul(al5, bl9) | 0;
    mid = mid + Math.imul(al5, bh9) | 0;
    mid = mid + Math.imul(ah5, bl9) | 0;
    hi = hi + Math.imul(ah5, bh9) | 0;
    var w14 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w14 >>> 26) | 0;
    w14 &= 0x3ffffff;
    /* k = 15 */

    lo = Math.imul(al9, bl6);
    mid = Math.imul(al9, bh6);
    mid = mid + Math.imul(ah9, bl6) | 0;
    hi = Math.imul(ah9, bh6);
    lo = lo + Math.imul(al8, bl7) | 0;
    mid = mid + Math.imul(al8, bh7) | 0;
    mid = mid + Math.imul(ah8, bl7) | 0;
    hi = hi + Math.imul(ah8, bh7) | 0;
    lo = lo + Math.imul(al7, bl8) | 0;
    mid = mid + Math.imul(al7, bh8) | 0;
    mid = mid + Math.imul(ah7, bl8) | 0;
    hi = hi + Math.imul(ah7, bh8) | 0;
    lo = lo + Math.imul(al6, bl9) | 0;
    mid = mid + Math.imul(al6, bh9) | 0;
    mid = mid + Math.imul(ah6, bl9) | 0;
    hi = hi + Math.imul(ah6, bh9) | 0;
    var w15 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w15 >>> 26) | 0;
    w15 &= 0x3ffffff;
    /* k = 16 */

    lo = Math.imul(al9, bl7);
    mid = Math.imul(al9, bh7);
    mid = mid + Math.imul(ah9, bl7) | 0;
    hi = Math.imul(ah9, bh7);
    lo = lo + Math.imul(al8, bl8) | 0;
    mid = mid + Math.imul(al8, bh8) | 0;
    mid = mid + Math.imul(ah8, bl8) | 0;
    hi = hi + Math.imul(ah8, bh8) | 0;
    lo = lo + Math.imul(al7, bl9) | 0;
    mid = mid + Math.imul(al7, bh9) | 0;
    mid = mid + Math.imul(ah7, bl9) | 0;
    hi = hi + Math.imul(ah7, bh9) | 0;
    var w16 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w16 >>> 26) | 0;
    w16 &= 0x3ffffff;
    /* k = 17 */

    lo = Math.imul(al9, bl8);
    mid = Math.imul(al9, bh8);
    mid = mid + Math.imul(ah9, bl8) | 0;
    hi = Math.imul(ah9, bh8);
    lo = lo + Math.imul(al8, bl9) | 0;
    mid = mid + Math.imul(al8, bh9) | 0;
    mid = mid + Math.imul(ah8, bl9) | 0;
    hi = hi + Math.imul(ah8, bh9) | 0;
    var w17 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w17 >>> 26) | 0;
    w17 &= 0x3ffffff;
    /* k = 18 */

    lo = Math.imul(al9, bl9);
    mid = Math.imul(al9, bh9);
    mid = mid + Math.imul(ah9, bl9) | 0;
    hi = Math.imul(ah9, bh9);
    var w18 = (c + lo | 0) + ((mid & 0x1fff) << 13) | 0;
    c = (hi + (mid >>> 13) | 0) + (w18 >>> 26) | 0;
    w18 &= 0x3ffffff;
    o[0] = w0;
    o[1] = w1;
    o[2] = w2;
    o[3] = w3;
    o[4] = w4;
    o[5] = w5;
    o[6] = w6;
    o[7] = w7;
    o[8] = w8;
    o[9] = w9;
    o[10] = w10;
    o[11] = w11;
    o[12] = w12;
    o[13] = w13;
    o[14] = w14;
    o[15] = w15;
    o[16] = w16;
    o[17] = w17;
    o[18] = w18;

    if (c !== 0) {
      o[19] = c;
      out.length++;
    }

    return out;
  }; // Polyfill comb


  if (!Math.imul) {
    comb10MulTo = smallMulTo;
  }

  function bigMulTo(self, num, out) {
    out.negative = num.negative ^ self.negative;
    out.length = self.length + num.length;
    var carry = 0;
    var hncarry = 0;

    for (var k = 0; k < out.length - 1; k++) {
      // Sum all words with the same `i + j = k` and accumulate `ncarry`,
      // note that ncarry could be >= 0x3ffffff
      var ncarry = hncarry;
      hncarry = 0;
      var rword = carry & 0x3ffffff;
      var maxJ = Math.min(k, num.length - 1);

      for (var j = Math.max(0, k - self.length + 1); j <= maxJ; j++) {
        var i = k - j;
        var a = self.words[i] | 0;
        var b = num.words[j] | 0;
        var r = a * b;
        var lo = r & 0x3ffffff;
        ncarry = ncarry + (r / 0x4000000 | 0) | 0;
        lo = lo + rword | 0;
        rword = lo & 0x3ffffff;
        ncarry = ncarry + (lo >>> 26) | 0;
        hncarry += ncarry >>> 26;
        ncarry &= 0x3ffffff;
      }

      out.words[k] = rword;
      carry = ncarry;
      ncarry = hncarry;
    }

    if (carry !== 0) {
      out.words[k] = carry;
    } else {
      out.length--;
    }

    return out.strip();
  }

  function jumboMulTo(self, num, out) {
    var fftm = new FFTM();
    return fftm.mulp(self, num, out);
  }

  BN.prototype.mulTo = function mulTo(num, out) {
    var res;
    var len = this.length + num.length;

    if (this.length === 10 && num.length === 10) {
      res = comb10MulTo(this, num, out);
    } else if (len < 63) {
      res = smallMulTo(this, num, out);
    } else if (len < 1024) {
      res = bigMulTo(this, num, out);
    } else {
      res = jumboMulTo(this, num, out);
    }

    return res;
  }; // Cooley-Tukey algorithm for FFT
  // slightly revisited to rely on looping instead of recursion


  function FFTM(x, y) {
    this.x = x;
    this.y = y;
  }

  FFTM.prototype.makeRBT = function makeRBT(N) {
    var t = new Array(N);
    var l = BN.prototype._countBits(N) - 1;

    for (var i = 0; i < N; i++) {
      t[i] = this.revBin(i, l, N);
    }

    return t;
  }; // Returns binary-reversed representation of `x`


  FFTM.prototype.revBin = function revBin(x, l, N) {
    if (x === 0 || x === N - 1) return x;
    var rb = 0;

    for (var i = 0; i < l; i++) {
      rb |= (x & 1) << l - i - 1;
      x >>= 1;
    }

    return rb;
  }; // Performs "tweedling" phase, therefore 'emulating'
  // behaviour of the recursive algorithm


  FFTM.prototype.permute = function permute(rbt, rws, iws, rtws, itws, N) {
    for (var i = 0; i < N; i++) {
      rtws[i] = rws[rbt[i]];
      itws[i] = iws[rbt[i]];
    }
  };

  FFTM.prototype.transform = function transform(rws, iws, rtws, itws, N, rbt) {
    this.permute(rbt, rws, iws, rtws, itws, N);

    for (var s = 1; s < N; s <<= 1) {
      var l = s << 1;
      var rtwdf = Math.cos(2 * Math.PI / l);
      var itwdf = Math.sin(2 * Math.PI / l);

      for (var p = 0; p < N; p += l) {
        var rtwdf_ = rtwdf;
        var itwdf_ = itwdf;

        for (var j = 0; j < s; j++) {
          var re = rtws[p + j];
          var ie = itws[p + j];
          var ro = rtws[p + j + s];
          var io = itws[p + j + s];
          var rx = rtwdf_ * ro - itwdf_ * io;
          io = rtwdf_ * io + itwdf_ * ro;
          ro = rx;
          rtws[p + j] = re + ro;
          itws[p + j] = ie + io;
          rtws[p + j + s] = re - ro;
          itws[p + j + s] = ie - io;
          /* jshint maxdepth : false */

          if (j !== l) {
            rx = rtwdf * rtwdf_ - itwdf * itwdf_;
            itwdf_ = rtwdf * itwdf_ + itwdf * rtwdf_;
            rtwdf_ = rx;
          }
        }
      }
    }
  };

  FFTM.prototype.guessLen13b = function guessLen13b(n, m) {
    var N = Math.max(m, n) | 1;
    var odd = N & 1;
    var i = 0;

    for (N = N / 2 | 0; N; N = N >>> 1) {
      i++;
    }

    return 1 << i + 1 + odd;
  };

  FFTM.prototype.conjugate = function conjugate(rws, iws, N) {
    if (N <= 1) return;

    for (var i = 0; i < N / 2; i++) {
      var t = rws[i];
      rws[i] = rws[N - i - 1];
      rws[N - i - 1] = t;
      t = iws[i];
      iws[i] = -iws[N - i - 1];
      iws[N - i - 1] = -t;
    }
  };

  FFTM.prototype.normalize13b = function normalize13b(ws, N) {
    var carry = 0;

    for (var i = 0; i < N / 2; i++) {
      var w = Math.round(ws[2 * i + 1] / N) * 0x2000 + Math.round(ws[2 * i] / N) + carry;
      ws[i] = w & 0x3ffffff;

      if (w < 0x4000000) {
        carry = 0;
      } else {
        carry = w / 0x4000000 | 0;
      }
    }

    return ws;
  };

  FFTM.prototype.convert13b = function convert13b(ws, len, rws, N) {
    var carry = 0;

    for (var i = 0; i < len; i++) {
      carry = carry + (ws[i] | 0);
      rws[2 * i] = carry & 0x1fff;
      carry = carry >>> 13;
      rws[2 * i + 1] = carry & 0x1fff;
      carry = carry >>> 13;
    } // Pad with zeroes


    for (i = 2 * len; i < N; ++i) {
      rws[i] = 0;
    }

    assert(carry === 0);
    assert((carry & ~0x1fff) === 0);
  };

  FFTM.prototype.stub = function stub(N) {
    var ph = new Array(N);

    for (var i = 0; i < N; i++) {
      ph[i] = 0;
    }

    return ph;
  };

  FFTM.prototype.mulp = function mulp(x, y, out) {
    var N = 2 * this.guessLen13b(x.length, y.length);
    var rbt = this.makeRBT(N);

    var _ = this.stub(N);

    var rws = new Array(N);
    var rwst = new Array(N);
    var iwst = new Array(N);
    var nrws = new Array(N);
    var nrwst = new Array(N);
    var niwst = new Array(N);
    var rmws = out.words;
    rmws.length = N;
    this.convert13b(x.words, x.length, rws, N);
    this.convert13b(y.words, y.length, nrws, N);
    this.transform(rws, _, rwst, iwst, N, rbt);
    this.transform(nrws, _, nrwst, niwst, N, rbt);

    for (var i = 0; i < N; i++) {
      var rx = rwst[i] * nrwst[i] - iwst[i] * niwst[i];
      iwst[i] = rwst[i] * niwst[i] + iwst[i] * nrwst[i];
      rwst[i] = rx;
    }

    this.conjugate(rwst, iwst, N);
    this.transform(rwst, iwst, rmws, _, N, rbt);
    this.conjugate(rmws, _, N);
    this.normalize13b(rmws, N);
    out.negative = x.negative ^ y.negative;
    out.length = x.length + y.length;
    return out.strip();
  }; // Multiply `this` by `num`


  BN.prototype.mul = function mul(num) {
    var out = new BN(null);
    out.words = new Array(this.length + num.length);
    return this.mulTo(num, out);
  }; // Multiply employing FFT


  BN.prototype.mulf = function mulf(num) {
    var out = new BN(null);
    out.words = new Array(this.length + num.length);
    return jumboMulTo(this, num, out);
  }; // In-place Multiplication


  BN.prototype.imul = function imul(num) {
    return this.clone().mulTo(num, this);
  };

  BN.prototype.imuln = function imuln(num) {
    assert(typeof num === 'number');
    assert(num < 0x4000000); // Carry

    var carry = 0;

    for (var i = 0; i < this.length; i++) {
      var w = (this.words[i] | 0) * num;
      var lo = (w & 0x3ffffff) + (carry & 0x3ffffff);
      carry >>= 26;
      carry += w / 0x4000000 | 0; // NOTE: lo is 27bit maximum

      carry += lo >>> 26;
      this.words[i] = lo & 0x3ffffff;
    }

    if (carry !== 0) {
      this.words[i] = carry;
      this.length++;
    }

    return this;
  };

  BN.prototype.muln = function muln(num) {
    return this.clone().imuln(num);
  }; // `this` * `this`


  BN.prototype.sqr = function sqr() {
    return this.mul(this);
  }; // `this` * `this` in-place


  BN.prototype.isqr = function isqr() {
    return this.imul(this.clone());
  }; // Math.pow(`this`, `num`)


  BN.prototype.pow = function pow(num) {
    var w = toBitArray(num);
    if (w.length === 0) return new BN(1); // Skip leading zeroes

    var res = this;

    for (var i = 0; i < w.length; i++, res = res.sqr()) {
      if (w[i] !== 0) break;
    }

    if (++i < w.length) {
      for (var q = res.sqr(); i < w.length; i++, q = q.sqr()) {
        if (w[i] === 0) continue;
        res = res.mul(q);
      }
    }

    return res;
  }; // Shift-left in-place


  BN.prototype.iushln = function iushln(bits) {
    assert(typeof bits === 'number' && bits >= 0);
    var r = bits % 26;
    var s = (bits - r) / 26;
    var carryMask = 0x3ffffff >>> 26 - r << 26 - r;
    var i;

    if (r !== 0) {
      var carry = 0;

      for (i = 0; i < this.length; i++) {
        var newCarry = this.words[i] & carryMask;
        var c = (this.words[i] | 0) - newCarry << r;
        this.words[i] = c | carry;
        carry = newCarry >>> 26 - r;
      }

      if (carry) {
        this.words[i] = carry;
        this.length++;
      }
    }

    if (s !== 0) {
      for (i = this.length - 1; i >= 0; i--) {
        this.words[i + s] = this.words[i];
      }

      for (i = 0; i < s; i++) {
        this.words[i] = 0;
      }

      this.length += s;
    }

    return this.strip();
  };

  BN.prototype.ishln = function ishln(bits) {
    // TODO(indutny): implement me
    assert(this.negative === 0);
    return this.iushln(bits);
  }; // Shift-right in-place
  // NOTE: `hint` is a lowest bit before trailing zeroes
  // NOTE: if `extended` is present - it will be filled with destroyed bits


  BN.prototype.iushrn = function iushrn(bits, hint, extended) {
    assert(typeof bits === 'number' && bits >= 0);
    var h;

    if (hint) {
      h = (hint - hint % 26) / 26;
    } else {
      h = 0;
    }

    var r = bits % 26;
    var s = Math.min((bits - r) / 26, this.length);
    var mask = 0x3ffffff ^ 0x3ffffff >>> r << r;
    var maskedWords = extended;
    h -= s;
    h = Math.max(0, h); // Extended mode, copy masked part

    if (maskedWords) {
      for (var i = 0; i < s; i++) {
        maskedWords.words[i] = this.words[i];
      }

      maskedWords.length = s;
    }

    if (s === 0) {// No-op, we should not move anything at all
    } else if (this.length > s) {
      this.length -= s;

      for (i = 0; i < this.length; i++) {
        this.words[i] = this.words[i + s];
      }
    } else {
      this.words[0] = 0;
      this.length = 1;
    }

    var carry = 0;

    for (i = this.length - 1; i >= 0 && (carry !== 0 || i >= h); i--) {
      var word = this.words[i] | 0;
      this.words[i] = carry << 26 - r | word >>> r;
      carry = word & mask;
    } // Push carried bits as a mask


    if (maskedWords && carry !== 0) {
      maskedWords.words[maskedWords.length++] = carry;
    }

    if (this.length === 0) {
      this.words[0] = 0;
      this.length = 1;
    }

    return this.strip();
  };

  BN.prototype.ishrn = function ishrn(bits, hint, extended) {
    // TODO(indutny): implement me
    assert(this.negative === 0);
    return this.iushrn(bits, hint, extended);
  }; // Shift-left


  BN.prototype.shln = function shln(bits) {
    return this.clone().ishln(bits);
  };

  BN.prototype.ushln = function ushln(bits) {
    return this.clone().iushln(bits);
  }; // Shift-right


  BN.prototype.shrn = function shrn(bits) {
    return this.clone().ishrn(bits);
  };

  BN.prototype.ushrn = function ushrn(bits) {
    return this.clone().iushrn(bits);
  }; // Test if n bit is set


  BN.prototype.testn = function testn(bit) {
    assert(typeof bit === 'number' && bit >= 0);
    var r = bit % 26;
    var s = (bit - r) / 26;
    var q = 1 << r; // Fast case: bit is much higher than all existing words

    if (this.length <= s) return false; // Check bit and return

    var w = this.words[s];
    return !!(w & q);
  }; // Return only lowers bits of number (in-place)


  BN.prototype.imaskn = function imaskn(bits) {
    assert(typeof bits === 'number' && bits >= 0);
    var r = bits % 26;
    var s = (bits - r) / 26;
    assert(this.negative === 0, 'imaskn works only with positive numbers');

    if (this.length <= s) {
      return this;
    }

    if (r !== 0) {
      s++;
    }

    this.length = Math.min(s, this.length);

    if (r !== 0) {
      var mask = 0x3ffffff ^ 0x3ffffff >>> r << r;
      this.words[this.length - 1] &= mask;
    }

    return this.strip();
  }; // Return only lowers bits of number


  BN.prototype.maskn = function maskn(bits) {
    return this.clone().imaskn(bits);
  }; // Add plain number `num` to `this`


  BN.prototype.iaddn = function iaddn(num) {
    assert(typeof num === 'number');
    assert(num < 0x4000000);
    if (num < 0) return this.isubn(-num); // Possible sign change

    if (this.negative !== 0) {
      if (this.length === 1 && (this.words[0] | 0) < num) {
        this.words[0] = num - (this.words[0] | 0);
        this.negative = 0;
        return this;
      }

      this.negative = 0;
      this.isubn(num);
      this.negative = 1;
      return this;
    } // Add without checks


    return this._iaddn(num);
  };

  BN.prototype._iaddn = function _iaddn(num) {
    this.words[0] += num; // Carry

    for (var i = 0; i < this.length && this.words[i] >= 0x4000000; i++) {
      this.words[i] -= 0x4000000;

      if (i === this.length - 1) {
        this.words[i + 1] = 1;
      } else {
        this.words[i + 1]++;
      }
    }

    this.length = Math.max(this.length, i + 1);
    return this;
  }; // Subtract plain number `num` from `this`


  BN.prototype.isubn = function isubn(num) {
    assert(typeof num === 'number');
    assert(num < 0x4000000);
    if (num < 0) return this.iaddn(-num);

    if (this.negative !== 0) {
      this.negative = 0;
      this.iaddn(num);
      this.negative = 1;
      return this;
    }

    this.words[0] -= num;

    if (this.length === 1 && this.words[0] < 0) {
      this.words[0] = -this.words[0];
      this.negative = 1;
    } else {
      // Carry
      for (var i = 0; i < this.length && this.words[i] < 0; i++) {
        this.words[i] += 0x4000000;
        this.words[i + 1] -= 1;
      }
    }

    return this.strip();
  };

  BN.prototype.addn = function addn(num) {
    return this.clone().iaddn(num);
  };

  BN.prototype.subn = function subn(num) {
    return this.clone().isubn(num);
  };

  BN.prototype.iabs = function iabs() {
    this.negative = 0;
    return this;
  };

  BN.prototype.abs = function abs() {
    return this.clone().iabs();
  };

  BN.prototype._ishlnsubmul = function _ishlnsubmul(num, mul, shift) {
    var len = num.length + shift;
    var i;

    this._expand(len);

    var w;
    var carry = 0;

    for (i = 0; i < num.length; i++) {
      w = (this.words[i + shift] | 0) + carry;
      var right = (num.words[i] | 0) * mul;
      w -= right & 0x3ffffff;
      carry = (w >> 26) - (right / 0x4000000 | 0);
      this.words[i + shift] = w & 0x3ffffff;
    }

    for (; i < this.length - shift; i++) {
      w = (this.words[i + shift] | 0) + carry;
      carry = w >> 26;
      this.words[i + shift] = w & 0x3ffffff;
    }

    if (carry === 0) return this.strip(); // Subtraction overflow

    assert(carry === -1);
    carry = 0;

    for (i = 0; i < this.length; i++) {
      w = -(this.words[i] | 0) + carry;
      carry = w >> 26;
      this.words[i] = w & 0x3ffffff;
    }

    this.negative = 1;
    return this.strip();
  };

  BN.prototype._wordDiv = function _wordDiv(num, mode) {
    var shift = this.length - num.length;
    var a = this.clone();
    var b = num; // Normalize

    var bhi = b.words[b.length - 1] | 0;

    var bhiBits = this._countBits(bhi);

    shift = 26 - bhiBits;

    if (shift !== 0) {
      b = b.ushln(shift);
      a.iushln(shift);
      bhi = b.words[b.length - 1] | 0;
    } // Initialize quotient


    var m = a.length - b.length;
    var q;

    if (mode !== 'mod') {
      q = new BN(null);
      q.length = m + 1;
      q.words = new Array(q.length);

      for (var i = 0; i < q.length; i++) {
        q.words[i] = 0;
      }
    }

    var diff = a.clone()._ishlnsubmul(b, 1, m);

    if (diff.negative === 0) {
      a = diff;

      if (q) {
        q.words[m] = 1;
      }
    }

    for (var j = m - 1; j >= 0; j--) {
      var qj = (a.words[b.length + j] | 0) * 0x4000000 + (a.words[b.length + j - 1] | 0); // NOTE: (qj / bhi) is (0x3ffffff * 0x4000000 + 0x3ffffff) / 0x2000000 max
      // (0x7ffffff)

      qj = Math.min(qj / bhi | 0, 0x3ffffff);

      a._ishlnsubmul(b, qj, j);

      while (a.negative !== 0) {
        qj--;
        a.negative = 0;

        a._ishlnsubmul(b, 1, j);

        if (!a.isZero()) {
          a.negative ^= 1;
        }
      }

      if (q) {
        q.words[j] = qj;
      }
    }

    if (q) {
      q.strip();
    }

    a.strip(); // Denormalize

    if (mode !== 'div' && shift !== 0) {
      a.iushrn(shift);
    }

    return {
      div: q || null,
      mod: a
    };
  }; // NOTE: 1) `mode` can be set to `mod` to request mod only,
  //       to `div` to request div only, or be absent to
  //       request both div & mod
  //       2) `positive` is true if unsigned mod is requested


  BN.prototype.divmod = function divmod(num, mode, positive) {
    assert(!num.isZero());

    if (this.isZero()) {
      return {
        div: new BN(0),
        mod: new BN(0)
      };
    }

    var div, mod, res;

    if (this.negative !== 0 && num.negative === 0) {
      res = this.neg().divmod(num, mode);

      if (mode !== 'mod') {
        div = res.div.neg();
      }

      if (mode !== 'div') {
        mod = res.mod.neg();

        if (positive && mod.negative !== 0) {
          mod.iadd(num);
        }
      }

      return {
        div: div,
        mod: mod
      };
    }

    if (this.negative === 0 && num.negative !== 0) {
      res = this.divmod(num.neg(), mode);

      if (mode !== 'mod') {
        div = res.div.neg();
      }

      return {
        div: div,
        mod: res.mod
      };
    }

    if ((this.negative & num.negative) !== 0) {
      res = this.neg().divmod(num.neg(), mode);

      if (mode !== 'div') {
        mod = res.mod.neg();

        if (positive && mod.negative !== 0) {
          mod.isub(num);
        }
      }

      return {
        div: res.div,
        mod: mod
      };
    } // Both numbers are positive at this point
    // Strip both numbers to approximate shift value


    if (num.length > this.length || this.cmp(num) < 0) {
      return {
        div: new BN(0),
        mod: this
      };
    } // Very short reduction


    if (num.length === 1) {
      if (mode === 'div') {
        return {
          div: this.divn(num.words[0]),
          mod: null
        };
      }

      if (mode === 'mod') {
        return {
          div: null,
          mod: new BN(this.modn(num.words[0]))
        };
      }

      return {
        div: this.divn(num.words[0]),
        mod: new BN(this.modn(num.words[0]))
      };
    }

    return this._wordDiv(num, mode);
  }; // Find `this` / `num`


  BN.prototype.div = function div(num) {
    return this.divmod(num, 'div', false).div;
  }; // Find `this` % `num`


  BN.prototype.mod = function mod(num) {
    return this.divmod(num, 'mod', false).mod;
  };

  BN.prototype.umod = function umod(num) {
    return this.divmod(num, 'mod', true).mod;
  }; // Find Round(`this` / `num`)


  BN.prototype.divRound = function divRound(num) {
    var dm = this.divmod(num); // Fast case - exact division

    if (dm.mod.isZero()) return dm.div;
    var mod = dm.div.negative !== 0 ? dm.mod.isub(num) : dm.mod;
    var half = num.ushrn(1);
    var r2 = num.andln(1);
    var cmp = mod.cmp(half); // Round down

    if (cmp < 0 || r2 === 1 && cmp === 0) return dm.div; // Round up

    return dm.div.negative !== 0 ? dm.div.isubn(1) : dm.div.iaddn(1);
  };

  BN.prototype.modn = function modn(num) {
    assert(num <= 0x3ffffff);
    var p = (1 << 26) % num;
    var acc = 0;

    for (var i = this.length - 1; i >= 0; i--) {
      acc = (p * acc + (this.words[i] | 0)) % num;
    }

    return acc;
  }; // In-place division by number


  BN.prototype.idivn = function idivn(num) {
    assert(num <= 0x3ffffff);
    var carry = 0;

    for (var i = this.length - 1; i >= 0; i--) {
      var w = (this.words[i] | 0) + carry * 0x4000000;
      this.words[i] = w / num | 0;
      carry = w % num;
    }

    return this.strip();
  };

  BN.prototype.divn = function divn(num) {
    return this.clone().idivn(num);
  };

  BN.prototype.egcd = function egcd(p) {
    assert(p.negative === 0);
    assert(!p.isZero());
    var x = this;
    var y = p.clone();

    if (x.negative !== 0) {
      x = x.umod(p);
    } else {
      x = x.clone();
    } // A * x + B * y = x


    var A = new BN(1);
    var B = new BN(0); // C * x + D * y = y

    var C = new BN(0);
    var D = new BN(1);
    var g = 0;

    while (x.isEven() && y.isEven()) {
      x.iushrn(1);
      y.iushrn(1);
      ++g;
    }

    var yp = y.clone();
    var xp = x.clone();

    while (!x.isZero()) {
      for (var i = 0, im = 1; (x.words[0] & im) === 0 && i < 26; ++i, im <<= 1) {
        ;
      }

      if (i > 0) {
        x.iushrn(i);

        while (i-- > 0) {
          if (A.isOdd() || B.isOdd()) {
            A.iadd(yp);
            B.isub(xp);
          }

          A.iushrn(1);
          B.iushrn(1);
        }
      }

      for (var j = 0, jm = 1; (y.words[0] & jm) === 0 && j < 26; ++j, jm <<= 1) {
        ;
      }

      if (j > 0) {
        y.iushrn(j);

        while (j-- > 0) {
          if (C.isOdd() || D.isOdd()) {
            C.iadd(yp);
            D.isub(xp);
          }

          C.iushrn(1);
          D.iushrn(1);
        }
      }

      if (x.cmp(y) >= 0) {
        x.isub(y);
        A.isub(C);
        B.isub(D);
      } else {
        y.isub(x);
        C.isub(A);
        D.isub(B);
      }
    }

    return {
      a: C,
      b: D,
      gcd: y.iushln(g)
    };
  }; // This is reduced incarnation of the binary EEA
  // above, designated to invert members of the
  // _prime_ fields F(p) at a maximal speed


  BN.prototype._invmp = function _invmp(p) {
    assert(p.negative === 0);
    assert(!p.isZero());
    var a = this;
    var b = p.clone();

    if (a.negative !== 0) {
      a = a.umod(p);
    } else {
      a = a.clone();
    }

    var x1 = new BN(1);
    var x2 = new BN(0);
    var delta = b.clone();

    while (a.cmpn(1) > 0 && b.cmpn(1) > 0) {
      for (var i = 0, im = 1; (a.words[0] & im) === 0 && i < 26; ++i, im <<= 1) {
        ;
      }

      if (i > 0) {
        a.iushrn(i);

        while (i-- > 0) {
          if (x1.isOdd()) {
            x1.iadd(delta);
          }

          x1.iushrn(1);
        }
      }

      for (var j = 0, jm = 1; (b.words[0] & jm) === 0 && j < 26; ++j, jm <<= 1) {
        ;
      }

      if (j > 0) {
        b.iushrn(j);

        while (j-- > 0) {
          if (x2.isOdd()) {
            x2.iadd(delta);
          }

          x2.iushrn(1);
        }
      }

      if (a.cmp(b) >= 0) {
        a.isub(b);
        x1.isub(x2);
      } else {
        b.isub(a);
        x2.isub(x1);
      }
    }

    var res;

    if (a.cmpn(1) === 0) {
      res = x1;
    } else {
      res = x2;
    }

    if (res.cmpn(0) < 0) {
      res.iadd(p);
    }

    return res;
  };

  BN.prototype.gcd = function gcd(num) {
    if (this.isZero()) return num.abs();
    if (num.isZero()) return this.abs();
    var a = this.clone();
    var b = num.clone();
    a.negative = 0;
    b.negative = 0; // Remove common factor of two

    for (var shift = 0; a.isEven() && b.isEven(); shift++) {
      a.iushrn(1);
      b.iushrn(1);
    }

    do {
      while (a.isEven()) {
        a.iushrn(1);
      }

      while (b.isEven()) {
        b.iushrn(1);
      }

      var r = a.cmp(b);

      if (r < 0) {
        // Swap `a` and `b` to make `a` always bigger than `b`
        var t = a;
        a = b;
        b = t;
      } else if (r === 0 || b.cmpn(1) === 0) {
        break;
      }

      a.isub(b);
    } while (true);

    return b.iushln(shift);
  }; // Invert number in the field F(num)


  BN.prototype.invm = function invm(num) {
    return this.egcd(num).a.umod(num);
  };

  BN.prototype.isEven = function isEven() {
    return (this.words[0] & 1) === 0;
  };

  BN.prototype.isOdd = function isOdd() {
    return (this.words[0] & 1) === 1;
  }; // And first word and num


  BN.prototype.andln = function andln(num) {
    return this.words[0] & num;
  }; // Increment at the bit position in-line


  BN.prototype.bincn = function bincn(bit) {
    assert(typeof bit === 'number');
    var r = bit % 26;
    var s = (bit - r) / 26;
    var q = 1 << r; // Fast case: bit is much higher than all existing words

    if (this.length <= s) {
      this._expand(s + 1);

      this.words[s] |= q;
      return this;
    } // Add bit and propagate, if needed


    var carry = q;

    for (var i = s; carry !== 0 && i < this.length; i++) {
      var w = this.words[i] | 0;
      w += carry;
      carry = w >>> 26;
      w &= 0x3ffffff;
      this.words[i] = w;
    }

    if (carry !== 0) {
      this.words[i] = carry;
      this.length++;
    }

    return this;
  };

  BN.prototype.isZero = function isZero() {
    return this.length === 1 && this.words[0] === 0;
  };

  BN.prototype.cmpn = function cmpn(num) {
    var negative = num < 0;
    if (this.negative !== 0 && !negative) return -1;
    if (this.negative === 0 && negative) return 1;
    this.strip();
    var res;

    if (this.length > 1) {
      res = 1;
    } else {
      if (negative) {
        num = -num;
      }

      assert(num <= 0x3ffffff, 'Number is too big');
      var w = this.words[0] | 0;
      res = w === num ? 0 : w < num ? -1 : 1;
    }

    if (this.negative !== 0) return -res | 0;
    return res;
  }; // Compare two numbers and return:
  // 1 - if `this` > `num`
  // 0 - if `this` == `num`
  // -1 - if `this` < `num`


  BN.prototype.cmp = function cmp(num) {
    if (this.negative !== 0 && num.negative === 0) return -1;
    if (this.negative === 0 && num.negative !== 0) return 1;
    var res = this.ucmp(num);
    if (this.negative !== 0) return -res | 0;
    return res;
  }; // Unsigned comparison


  BN.prototype.ucmp = function ucmp(num) {
    // At this point both numbers have the same sign
    if (this.length > num.length) return 1;
    if (this.length < num.length) return -1;
    var res = 0;

    for (var i = this.length - 1; i >= 0; i--) {
      var a = this.words[i] | 0;
      var b = num.words[i] | 0;
      if (a === b) continue;

      if (a < b) {
        res = -1;
      } else if (a > b) {
        res = 1;
      }

      break;
    }

    return res;
  };

  BN.prototype.gtn = function gtn(num) {
    return this.cmpn(num) === 1;
  };

  BN.prototype.gt = function gt(num) {
    return this.cmp(num) === 1;
  };

  BN.prototype.gten = function gten(num) {
    return this.cmpn(num) >= 0;
  };

  BN.prototype.gte = function gte(num) {
    return this.cmp(num) >= 0;
  };

  BN.prototype.ltn = function ltn(num) {
    return this.cmpn(num) === -1;
  };

  BN.prototype.lt = function lt(num) {
    return this.cmp(num) === -1;
  };

  BN.prototype.lten = function lten(num) {
    return this.cmpn(num) <= 0;
  };

  BN.prototype.lte = function lte(num) {
    return this.cmp(num) <= 0;
  };

  BN.prototype.eqn = function eqn(num) {
    return this.cmpn(num) === 0;
  };

  BN.prototype.eq = function eq(num) {
    return this.cmp(num) === 0;
  }; //
  // A reduce context, could be using montgomery or something better, depending
  // on the `m` itself.
  //


  BN.red = function red(num) {
    return new Red(num);
  };

  BN.prototype.toRed = function toRed(ctx) {
    assert(!this.red, 'Already a number in reduction context');
    assert(this.negative === 0, 'red works only with positives');
    return ctx.convertTo(this)._forceRed(ctx);
  };

  BN.prototype.fromRed = function fromRed() {
    assert(this.red, 'fromRed works only with numbers in reduction context');
    return this.red.convertFrom(this);
  };

  BN.prototype._forceRed = function _forceRed(ctx) {
    this.red = ctx;
    return this;
  };

  BN.prototype.forceRed = function forceRed(ctx) {
    assert(!this.red, 'Already a number in reduction context');
    return this._forceRed(ctx);
  };

  BN.prototype.redAdd = function redAdd(num) {
    assert(this.red, 'redAdd works only with red numbers');
    return this.red.add(this, num);
  };

  BN.prototype.redIAdd = function redIAdd(num) {
    assert(this.red, 'redIAdd works only with red numbers');
    return this.red.iadd(this, num);
  };

  BN.prototype.redSub = function redSub(num) {
    assert(this.red, 'redSub works only with red numbers');
    return this.red.sub(this, num);
  };

  BN.prototype.redISub = function redISub(num) {
    assert(this.red, 'redISub works only with red numbers');
    return this.red.isub(this, num);
  };

  BN.prototype.redShl = function redShl(num) {
    assert(this.red, 'redShl works only with red numbers');
    return this.red.shl(this, num);
  };

  BN.prototype.redMul = function redMul(num) {
    assert(this.red, 'redMul works only with red numbers');

    this.red._verify2(this, num);

    return this.red.mul(this, num);
  };

  BN.prototype.redIMul = function redIMul(num) {
    assert(this.red, 'redMul works only with red numbers');

    this.red._verify2(this, num);

    return this.red.imul(this, num);
  };

  BN.prototype.redSqr = function redSqr() {
    assert(this.red, 'redSqr works only with red numbers');

    this.red._verify1(this);

    return this.red.sqr(this);
  };

  BN.prototype.redISqr = function redISqr() {
    assert(this.red, 'redISqr works only with red numbers');

    this.red._verify1(this);

    return this.red.isqr(this);
  }; // Square root over p


  BN.prototype.redSqrt = function redSqrt() {
    assert(this.red, 'redSqrt works only with red numbers');

    this.red._verify1(this);

    return this.red.sqrt(this);
  };

  BN.prototype.redInvm = function redInvm() {
    assert(this.red, 'redInvm works only with red numbers');

    this.red._verify1(this);

    return this.red.invm(this);
  }; // Return negative clone of `this` % `red modulo`


  BN.prototype.redNeg = function redNeg() {
    assert(this.red, 'redNeg works only with red numbers');

    this.red._verify1(this);

    return this.red.neg(this);
  };

  BN.prototype.redPow = function redPow(num) {
    assert(this.red && !num.red, 'redPow(normalNum)');

    this.red._verify1(this);

    return this.red.pow(this, num);
  }; // Prime numbers with efficient reduction


  var primes = {
    k256: null,
    p224: null,
    p192: null,
    p25519: null
  }; // Pseudo-Mersenne prime

  function MPrime(name, p) {
    // P = 2 ^ N - K
    this.name = name;
    this.p = new BN(p, 16);
    this.n = this.p.bitLength();
    this.k = new BN(1).iushln(this.n).isub(this.p);
    this.tmp = this._tmp();
  }

  MPrime.prototype._tmp = function _tmp() {
    var tmp = new BN(null);
    tmp.words = new Array(Math.ceil(this.n / 13));
    return tmp;
  };

  MPrime.prototype.ireduce = function ireduce(num) {
    // Assumes that `num` is less than `P^2`
    // num = HI * (2 ^ N - K) + HI * K + LO = HI * K + LO (mod P)
    var r = num;
    var rlen;

    do {
      this.split(r, this.tmp);
      r = this.imulK(r);
      r = r.iadd(this.tmp);
      rlen = r.bitLength();
    } while (rlen > this.n);

    var cmp = rlen < this.n ? -1 : r.ucmp(this.p);

    if (cmp === 0) {
      r.words[0] = 0;
      r.length = 1;
    } else if (cmp > 0) {
      r.isub(this.p);
    } else {
      r.strip();
    }

    return r;
  };

  MPrime.prototype.split = function split(input, out) {
    input.iushrn(this.n, 0, out);
  };

  MPrime.prototype.imulK = function imulK(num) {
    return num.imul(this.k);
  };

  function K256() {
    MPrime.call(this, 'k256', 'ffffffff ffffffff ffffffff ffffffff ffffffff ffffffff fffffffe fffffc2f');
  }

  inherits(K256, MPrime);

  K256.prototype.split = function split(input, output) {
    // 256 = 9 * 26 + 22
    var mask = 0x3fffff;
    var outLen = Math.min(input.length, 9);

    for (var i = 0; i < outLen; i++) {
      output.words[i] = input.words[i];
    }

    output.length = outLen;

    if (input.length <= 9) {
      input.words[0] = 0;
      input.length = 1;
      return;
    } // Shift by 9 limbs


    var prev = input.words[9];
    output.words[output.length++] = prev & mask;

    for (i = 10; i < input.length; i++) {
      var next = input.words[i] | 0;
      input.words[i - 10] = (next & mask) << 4 | prev >>> 22;
      prev = next;
    }

    prev >>>= 22;
    input.words[i - 10] = prev;

    if (prev === 0 && input.length > 10) {
      input.length -= 10;
    } else {
      input.length -= 9;
    }
  };

  K256.prototype.imulK = function imulK(num) {
    // K = 0x1000003d1 = [ 0x40, 0x3d1 ]
    num.words[num.length] = 0;
    num.words[num.length + 1] = 0;
    num.length += 2; // bounded at: 0x40 * 0x3ffffff + 0x3d0 = 0x100000390

    var lo = 0;

    for (var i = 0; i < num.length; i++) {
      var w = num.words[i] | 0;
      lo += w * 0x3d1;
      num.words[i] = lo & 0x3ffffff;
      lo = w * 0x40 + (lo / 0x4000000 | 0);
    } // Fast length reduction


    if (num.words[num.length - 1] === 0) {
      num.length--;

      if (num.words[num.length - 1] === 0) {
        num.length--;
      }
    }

    return num;
  };

  function P224() {
    MPrime.call(this, 'p224', 'ffffffff ffffffff ffffffff ffffffff 00000000 00000000 00000001');
  }

  inherits(P224, MPrime);

  function P192() {
    MPrime.call(this, 'p192', 'ffffffff ffffffff ffffffff fffffffe ffffffff ffffffff');
  }

  inherits(P192, MPrime);

  function P25519() {
    // 2 ^ 255 - 19
    MPrime.call(this, '25519', '7fffffffffffffff ffffffffffffffff ffffffffffffffff ffffffffffffffed');
  }

  inherits(P25519, MPrime);

  P25519.prototype.imulK = function imulK(num) {
    // K = 0x13
    var carry = 0;

    for (var i = 0; i < num.length; i++) {
      var hi = (num.words[i] | 0) * 0x13 + carry;
      var lo = hi & 0x3ffffff;
      hi >>>= 26;
      num.words[i] = lo;
      carry = hi;
    }

    if (carry !== 0) {
      num.words[num.length++] = carry;
    }

    return num;
  }; // Exported mostly for testing purposes, use plain name instead


  BN._prime = function prime(name) {
    // Cached version of prime
    if (primes[name]) return primes[name];
    var prime;

    if (name === 'k256') {
      prime = new K256();
    } else if (name === 'p224') {
      prime = new P224();
    } else if (name === 'p192') {
      prime = new P192();
    } else if (name === 'p25519') {
      prime = new P25519();
    } else {
      throw new Error('Unknown prime ' + name);
    }

    primes[name] = prime;
    return prime;
  }; //
  // Base reduction engine
  //


  function Red(m) {
    if (typeof m === 'string') {
      var prime = BN._prime(m);

      this.m = prime.p;
      this.prime = prime;
    } else {
      assert(m.gtn(1), 'modulus must be greater than 1');
      this.m = m;
      this.prime = null;
    }
  }

  Red.prototype._verify1 = function _verify1(a) {
    assert(a.negative === 0, 'red works only with positives');
    assert(a.red, 'red works only with red numbers');
  };

  Red.prototype._verify2 = function _verify2(a, b) {
    assert((a.negative | b.negative) === 0, 'red works only with positives');
    assert(a.red && a.red === b.red, 'red works only with red numbers');
  };

  Red.prototype.imod = function imod(a) {
    if (this.prime) return this.prime.ireduce(a)._forceRed(this);
    return a.umod(this.m)._forceRed(this);
  };

  Red.prototype.neg = function neg(a) {
    if (a.isZero()) {
      return a.clone();
    }

    return this.m.sub(a)._forceRed(this);
  };

  Red.prototype.add = function add(a, b) {
    this._verify2(a, b);

    var res = a.add(b);

    if (res.cmp(this.m) >= 0) {
      res.isub(this.m);
    }

    return res._forceRed(this);
  };

  Red.prototype.iadd = function iadd(a, b) {
    this._verify2(a, b);

    var res = a.iadd(b);

    if (res.cmp(this.m) >= 0) {
      res.isub(this.m);
    }

    return res;
  };

  Red.prototype.sub = function sub(a, b) {
    this._verify2(a, b);

    var res = a.sub(b);

    if (res.cmpn(0) < 0) {
      res.iadd(this.m);
    }

    return res._forceRed(this);
  };

  Red.prototype.isub = function isub(a, b) {
    this._verify2(a, b);

    var res = a.isub(b);

    if (res.cmpn(0) < 0) {
      res.iadd(this.m);
    }

    return res;
  };

  Red.prototype.shl = function shl(a, num) {
    this._verify1(a);

    return this.imod(a.ushln(num));
  };

  Red.prototype.imul = function imul(a, b) {
    this._verify2(a, b);

    return this.imod(a.imul(b));
  };

  Red.prototype.mul = function mul(a, b) {
    this._verify2(a, b);

    return this.imod(a.mul(b));
  };

  Red.prototype.isqr = function isqr(a) {
    return this.imul(a, a.clone());
  };

  Red.prototype.sqr = function sqr(a) {
    return this.mul(a, a);
  };

  Red.prototype.sqrt = function sqrt(a) {
    if (a.isZero()) return a.clone();
    var mod3 = this.m.andln(3);
    assert(mod3 % 2 === 1); // Fast case

    if (mod3 === 3) {
      var pow = this.m.add(new BN(1)).iushrn(2);
      return this.pow(a, pow);
    } // Tonelli-Shanks algorithm (Totally unoptimized and slow)
    //
    // Find Q and S, that Q * 2 ^ S = (P - 1)


    var q = this.m.subn(1);
    var s = 0;

    while (!q.isZero() && q.andln(1) === 0) {
      s++;
      q.iushrn(1);
    }

    assert(!q.isZero());
    var one = new BN(1).toRed(this);
    var nOne = one.redNeg(); // Find quadratic non-residue
    // NOTE: Max is such because of generalized Riemann hypothesis.

    var lpow = this.m.subn(1).iushrn(1);
    var z = this.m.bitLength();
    z = new BN(2 * z * z).toRed(this);

    while (this.pow(z, lpow).cmp(nOne) !== 0) {
      z.redIAdd(nOne);
    }

    var c = this.pow(z, q);
    var r = this.pow(a, q.addn(1).iushrn(1));
    var t = this.pow(a, q);
    var m = s;

    while (t.cmp(one) !== 0) {
      var tmp = t;

      for (var i = 0; tmp.cmp(one) !== 0; i++) {
        tmp = tmp.redSqr();
      }

      assert(i < m);
      var b = this.pow(c, new BN(1).iushln(m - i - 1));
      r = r.redMul(b);
      c = b.redSqr();
      t = t.redMul(c);
      m = i;
    }

    return r;
  };

  Red.prototype.invm = function invm(a) {
    var inv = a._invmp(this.m);

    if (inv.negative !== 0) {
      inv.negative = 0;
      return this.imod(inv).redNeg();
    } else {
      return this.imod(inv);
    }
  };

  Red.prototype.pow = function pow(a, num) {
    if (num.isZero()) return new BN(1).toRed(this);
    if (num.cmpn(1) === 0) return a.clone();
    var windowSize = 4;
    var wnd = new Array(1 << windowSize);
    wnd[0] = new BN(1).toRed(this);
    wnd[1] = a;

    for (var i = 2; i < wnd.length; i++) {
      wnd[i] = this.mul(wnd[i - 1], a);
    }

    var res = wnd[0];
    var current = 0;
    var currentLen = 0;
    var start = num.bitLength() % 26;

    if (start === 0) {
      start = 26;
    }

    for (i = num.length - 1; i >= 0; i--) {
      var word = num.words[i];

      for (var j = start - 1; j >= 0; j--) {
        var bit = word >> j & 1;

        if (res !== wnd[0]) {
          res = this.sqr(res);
        }

        if (bit === 0 && current === 0) {
          currentLen = 0;
          continue;
        }

        current <<= 1;
        current |= bit;
        currentLen++;
        if (currentLen !== windowSize && (i !== 0 || j !== 0)) continue;
        res = this.mul(res, wnd[current]);
        currentLen = 0;
        current = 0;
      }

      start = 26;
    }

    return res;
  };

  Red.prototype.convertTo = function convertTo(num) {
    var r = num.umod(this.m);
    return r === num ? r.clone() : r;
  };

  Red.prototype.convertFrom = function convertFrom(num) {
    var res = num.clone();
    res.red = null;
    return res;
  }; //
  // Montgomery method engine
  //


  BN.mont = function mont(num) {
    return new Mont(num);
  };

  function Mont(m) {
    Red.call(this, m);
    this.shift = this.m.bitLength();

    if (this.shift % 26 !== 0) {
      this.shift += 26 - this.shift % 26;
    }

    this.r = new BN(1).iushln(this.shift);
    this.r2 = this.imod(this.r.sqr());
    this.rinv = this.r._invmp(this.m);
    this.minv = this.rinv.mul(this.r).isubn(1).div(this.m);
    this.minv = this.minv.umod(this.r);
    this.minv = this.r.sub(this.minv);
  }

  inherits(Mont, Red);

  Mont.prototype.convertTo = function convertTo(num) {
    return this.imod(num.ushln(this.shift));
  };

  Mont.prototype.convertFrom = function convertFrom(num) {
    var r = this.imod(num.mul(this.rinv));
    r.red = null;
    return r;
  };

  Mont.prototype.imul = function imul(a, b) {
    if (a.isZero() || b.isZero()) {
      a.words[0] = 0;
      a.length = 1;
      return a;
    }

    var t = a.imul(b);
    var c = t.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m);
    var u = t.isub(c).iushrn(this.shift);
    var res = u;

    if (u.cmp(this.m) >= 0) {
      res = u.isub(this.m);
    } else if (u.cmpn(0) < 0) {
      res = u.iadd(this.m);
    }

    return res._forceRed(this);
  };

  Mont.prototype.mul = function mul(a, b) {
    if (a.isZero() || b.isZero()) return new BN(0)._forceRed(this);
    var t = a.mul(b);
    var c = t.maskn(this.shift).mul(this.minv).imaskn(this.shift).mul(this.m);
    var u = t.isub(c).iushrn(this.shift);
    var res = u;

    if (u.cmp(this.m) >= 0) {
      res = u.isub(this.m);
    } else if (u.cmpn(0) < 0) {
      res = u.iadd(this.m);
    }

    return res._forceRed(this);
  };

  Mont.prototype.invm = function invm(a) {
    // (AR)^-1 * R^2 = (A^-1 * R^-1) * R^2 = A^-1 * R
    var res = this.imod(a._invmp(this.m).mul(this.r2));
    return res._forceRed(this);
  };
})( false || module, this);

/***/ }),

/***/ "./node_modules/cleaners/lib/index.js":
/*!********************************************!*\
  !*** ./node_modules/cleaners/lib/index.js ***!
  \********************************************/
/***/ (function(__unused_webpack_module, exports) {

"use strict";


function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", ({
  value: true
})); // simple types --------------------------------------------------------------

function asBoolean(raw) {
  if (typeof raw !== 'boolean') throw new TypeError('Expected a boolean');
  return raw;
}

var asNull = asValue(null);

function asNumber(raw) {
  if (typeof raw !== 'number') throw new TypeError('Expected a number');
  return raw;
}

function asString(raw) {
  if (typeof raw !== 'string') throw new TypeError('Expected a string');
  return raw;
}

var asUndefined = asValue(undefined);
var asNone = asOptional(asNull);

function asUnknown(raw) {
  return raw;
} // data structures -----------------------------------------------------------


function asArray(cleaner) {
  return function asArray(raw) {
    if (!Array.isArray(raw)) {
      throw new TypeError('Expected an array');
    }

    var out = [];

    for (var i = 0; i < raw.length; ++i) {
      try {
        out[i] = cleaner(raw[i]);
      } catch (error) {
        throw locateError(error, '[' + i + ']', 0);
      }
    }

    return out;
  };
}

function asObject(shape) {
  // The key-value version:
  if (typeof shape === 'function') {
    return function asObject(raw) {
      if (_typeof(raw) !== 'object' || raw == null) {
        throw new TypeError('Expected an object');
      }

      var out = {};
      var keys = Object.keys(raw);

      for (var i = 0; i < keys.length; ++i) {
        var key = keys[i];
        if (key === '__proto__') continue;

        try {
          out[key] = shape(raw[key]);
        } catch (error) {
          throw locateError(error, '[' + JSON.stringify(key) + ']', 0);
        }
      }

      return out;
    };
  } // The shape-aware version:


  var keys = Object.keys(shape);

  function bindObjectShape(keepRest) {
    return function asObject(raw) {
      if (_typeof(raw) !== 'object' || raw == null) {
        throw new TypeError('Expected an object');
      }

      var i;
      var out = {};

      if (keepRest) {
        var toCopy = Object.keys(raw);

        for (i = 0; i < toCopy.length; ++i) {
          var key = toCopy[i];
          if (key === '__proto__') continue;
          out[key] = raw[key];
        }
      }

      for (i = 0; i < keys.length; ++i) {
        var _key = keys[i];

        try {
          out[_key] = shape[_key](raw[_key]);
        } catch (error) {
          throw locateError(error, '.' + _key, 0);
        }
      }

      return out;
    };
  }

  var out = bindObjectShape(false);
  out.shape = shape;
  out.withRest = bindObjectShape(true);
  return out;
} // branching -----------------------------------------------------------------


function asEither() {
  for (var _len = arguments.length, shape = new Array(_len), _key2 = 0; _key2 < _len; _key2++) {
    shape[_key2] = arguments[_key2];
  }

  return function asEither(raw) {
    for (var i = 0; i < shape.length; i++) {
      try {
        return shape[i](raw);
      } catch (error) {
        if (i + 1 >= shape.length) throw error;
      }
    }
  };
}

function asMaybe(cleaner, fallback) {
  return function asMaybe(raw) {
    try {
      return cleaner(raw);
    } catch (e) {
      return fallback;
    }
  };
}

function asOptional(cleaner, fallback) {
  return function asOptional(raw) {
    return raw != null ? cleaner(raw) : fallback;
  };
} // parsing -------------------------------------------------------------------


var uncleaning = 0;

function asCodec(cleaner, uncleaner) {
  return function asCodec(raw) {
    return uncleaning > 0 ? uncleaner(raw) : cleaner(raw);
  };
}

var asDate = asCodec(function asDate(raw) {
  if (typeof raw !== 'string' && !(raw instanceof Date)) {
    throw new TypeError('Expected a date string');
  }

  var out = new Date(raw);
  if (out.toJSON() == null) throw new TypeError('Invalid date format');
  return out;
}, function wasDate(clean) {
  return clean.toISOString();
});

function asJSON(cleaner) {
  return asCodec(function asJSON(raw) {
    var value = JSON.parse(asString(raw));

    try {
      return cleaner(value);
    } catch (error) {
      throw locateError(error, 'JSON.parse()', 11);
    }
  }, function wasJSON(clean) {
    return JSON.stringify(cleaner(clean));
  });
}

function uncleaner(cleaner) {
  return function uncleaner(raw) {
    try {
      ++uncleaning;
      return cleaner(raw);
    } finally {
      --uncleaning;
    }
  };
}

function asValue(value) {
  return function asValue(raw) {
    if (raw !== value) {
      throw new TypeError("Expected " + JSON.stringify(value));
    }

    return raw;
  };
} // deprecated ----------------------------------------------------------------


var asMap = asObject; // helpers -------------------------------------------------------------------

/**
 * Adds location information to an error message.
 *
 * Errors can occur inside deeply-nested cleaners,
 * such as "TypeError: Expected a string at .array[0].some.property".
 * To build this information, each cleaner along the path
 * should add its own location information as the stack unwinds.
 *
 * If the error has a `insertStepAt` property, that is the character offset
 * where the next step will go in the error message. Otherwise,
 * the next step just goes on the end of the string with the word "at".
 */

function locateError(error, step, offset) {
  if (error instanceof Error) {
    if (error.insertStepAt == null) {
      error.message += ' at ';
      error.insertStepAt = error.message.length;
    }

    error.message = error.message.slice(0, error.insertStepAt) + step + error.message.slice(error.insertStepAt);
    error.insertStepAt += offset;
  }

  return error;
}

exports.asArray = asArray;
exports.asBoolean = asBoolean;
exports.asCodec = asCodec;
exports.asDate = asDate;
exports.asEither = asEither;
exports.asJSON = asJSON;
exports.asMap = asMap;
exports.asMaybe = asMaybe;
exports.asNone = asNone;
exports.asNull = asNull;
exports.asNumber = asNumber;
exports.asObject = asObject;
exports.asOptional = asOptional;
exports.asString = asString;
exports.asUndefined = asUndefined;
exports.asUnknown = asUnknown;
exports.asValue = asValue;
exports.uncleaner = uncleaner;

/***/ }),

/***/ "./node_modules/edge-core-js/types.js":
/*!********************************************!*\
  !*** ./node_modules/edge-core-js/types.js ***!
  \********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

(function (e, a) {
  for (var i in a) {
    e[i] = a[i];
  }
})(exports,
/******/
function (modules) {
  // webpackBootstrap

  /******/
  // The module cache

  /******/
  var installedModules = {};
  /******/

  /******/
  // The require function

  /******/

  function __nested_webpack_require_644__(moduleId) {
    /******/

    /******/
    // Check if module is in cache

    /******/
    if (installedModules[moduleId]) {
      /******/
      return installedModules[moduleId].exports;
      /******/
    }
    /******/
    // Create a new module (and put it into the cache)

    /******/


    var module = installedModules[moduleId] = {
      /******/
      i: moduleId,

      /******/
      l: false,

      /******/
      exports: {}
      /******/

    };
    /******/

    /******/
    // Execute the module function

    /******/

    modules[moduleId].call(module.exports, module, module.exports, __nested_webpack_require_644__);
    /******/

    /******/
    // Flag the module as loaded

    /******/

    module.l = true;
    /******/

    /******/
    // Return the exports of the module

    /******/

    return module.exports;
    /******/
  }
  /******/

  /******/

  /******/
  // expose the modules object (__webpack_modules__)

  /******/


  __nested_webpack_require_644__.m = modules;
  /******/

  /******/
  // expose the module cache

  /******/

  __nested_webpack_require_644__.c = installedModules;
  /******/

  /******/
  // define getter function for harmony exports

  /******/

  __nested_webpack_require_644__.d = function (exports, name, getter) {
    /******/
    if (!__nested_webpack_require_644__.o(exports, name)) {
      /******/
      Object.defineProperty(exports, name, {
        enumerable: true,
        get: getter
      });
      /******/
    }
    /******/

  };
  /******/

  /******/
  // define __esModule on exports

  /******/


  __nested_webpack_require_644__.r = function (exports) {
    /******/
    if (typeof Symbol !== 'undefined' && Symbol.toStringTag) {
      /******/
      Object.defineProperty(exports, Symbol.toStringTag, {
        value: 'Module'
      });
      /******/
    }
    /******/


    Object.defineProperty(exports, '__esModule', {
      value: true
    });
    /******/
  };
  /******/

  /******/
  // create a fake namespace object

  /******/
  // mode & 1: value is a module id, require it

  /******/
  // mode & 2: merge all properties of value into the ns

  /******/
  // mode & 4: return value when already ns object

  /******/
  // mode & 8|1: behave like require

  /******/


  __nested_webpack_require_644__.t = function (value, mode) {
    /******/
    if (mode & 1) value = __nested_webpack_require_644__(value);
    /******/

    if (mode & 8) return value;
    /******/

    if (mode & 4 && _typeof(value) === 'object' && value && value.__esModule) return value;
    /******/

    var ns = Object.create(null);
    /******/

    __nested_webpack_require_644__.r(ns);
    /******/


    Object.defineProperty(ns, 'default', {
      enumerable: true,
      value: value
    });
    /******/

    if (mode & 2 && typeof value != 'string') for (var key in value) {
      __nested_webpack_require_644__.d(ns, key, function (key) {
        return value[key];
      }.bind(null, key));
    }
    /******/

    return ns;
    /******/
  };
  /******/

  /******/
  // getDefaultExport function for compatibility with non-harmony modules

  /******/


  __nested_webpack_require_644__.n = function (module) {
    /******/
    var getter = module && module.__esModule ?
    /******/
    function getDefault() {
      return module['default'];
    } :
    /******/
    function getModuleExports() {
      return module;
    };
    /******/

    __nested_webpack_require_644__.d(getter, 'a', getter);
    /******/


    return getter;
    /******/
  };
  /******/

  /******/
  // Object.prototype.hasOwnProperty.call

  /******/


  __nested_webpack_require_644__.o = function (object, property) {
    return Object.prototype.hasOwnProperty.call(object, property);
  };
  /******/

  /******/
  // __webpack_public_path__

  /******/


  __nested_webpack_require_644__.p = "";
  /******/

  /******/

  /******/
  // Load entry module and return exports

  /******/

  return __nested_webpack_require_644__(__nested_webpack_require_644__.s = 2);
  /******/
}(
/************************************************************************/

/******/
[
/* 0 */

/***/
function (module, exports) {
  module.exports = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.js");
  /***/
},
/* 1 */

/***/
function (module, exports) {
  module.exports = __webpack_require__(/*! rfc4648 */ "./node_modules/rfc4648/lib/index.js");
  /***/
},
/* 2 */

/***/
function (module, __webpack_exports__, __nested_webpack_require_4881__) {
  "use strict"; // ESM COMPAT FLAG

  __nested_webpack_require_4881__.r(__webpack_exports__); // EXPORTS


  __nested_webpack_require_4881__.d(__webpack_exports__, "errorNames", function () {
    return (
      /* reexport */
      errorNames
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "DustSpendError", function () {
    return (
      /* reexport */
      DustSpendError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "InsufficientFundsError", function () {
    return (
      /* reexport */
      InsufficientFundsError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "NetworkError", function () {
    return (
      /* reexport */
      NetworkError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "NoAmountSpecifiedError", function () {
    return (
      /* reexport */
      NoAmountSpecifiedError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "ObsoleteApiError", function () {
    return (
      /* reexport */
      ObsoleteApiError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "OtpError", function () {
    return (
      /* reexport */
      OtpError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "PasswordError", function () {
    return (
      /* reexport */
      PasswordError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "PendingFundsError", function () {
    return (
      /* reexport */
      PendingFundsError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SameCurrencyError", function () {
    return (
      /* reexport */
      SameCurrencyError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SpendToSelfError", function () {
    return (
      /* reexport */
      SpendToSelfError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SwapAboveLimitError", function () {
    return (
      /* reexport */
      SwapAboveLimitError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SwapBelowLimitError", function () {
    return (
      /* reexport */
      SwapBelowLimitError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SwapCurrencyError", function () {
    return (
      /* reexport */
      SwapCurrencyError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "SwapPermissionError", function () {
    return (
      /* reexport */
      SwapPermissionError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "UsernameError", function () {
    return (
      /* reexport */
      UsernameError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeDustSpendError", function () {
    return (
      /* reexport */
      asMaybeDustSpendError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeInsufficientFundsError", function () {
    return (
      /* reexport */
      asMaybeInsufficientFundsError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeNetworkError", function () {
    return (
      /* reexport */
      asMaybeNetworkError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeNoAmountSpecifiedError", function () {
    return (
      /* reexport */
      asMaybeNoAmountSpecifiedError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeObsoleteApiError", function () {
    return (
      /* reexport */
      asMaybeObsoleteApiError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeOtpError", function () {
    return (
      /* reexport */
      asMaybeOtpError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybePasswordError", function () {
    return (
      /* reexport */
      asMaybePasswordError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybePendingFundsError", function () {
    return (
      /* reexport */
      asMaybePendingFundsError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSameCurrencyError", function () {
    return (
      /* reexport */
      asMaybeSameCurrencyError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSpendToSelfError", function () {
    return (
      /* reexport */
      asMaybeSpendToSelfError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSwapAboveLimitError", function () {
    return (
      /* reexport */
      asMaybeSwapAboveLimitError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSwapBelowLimitError", function () {
    return (
      /* reexport */
      asMaybeSwapBelowLimitError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSwapCurrencyError", function () {
    return (
      /* reexport */
      asMaybeSwapCurrencyError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeSwapPermissionError", function () {
    return (
      /* reexport */
      asMaybeSwapPermissionError
    );
  });

  __nested_webpack_require_4881__.d(__webpack_exports__, "asMaybeUsernameError", function () {
    return (
      /* reexport */
      asMaybeUsernameError
    );
  }); // EXTERNAL MODULE: external "rfc4648"


  var external_rfc4648_ = __nested_webpack_require_4881__(1); // EXTERNAL MODULE: external "cleaners"


  var external_cleaners_ = __nested_webpack_require_4881__(0); // CONCATENATED MODULE: ./src/types/server-cleaners.js

  /**
   * A string of base64-encoded binary data.
   */


  var asBase64 = Object(external_cleaners_["asCodec"])(function (raw) {
    return external_rfc4648_["base64"].parse(Object(external_cleaners_["asString"])(raw));
  }, function (clean) {
    return external_rfc4648_["base64"].stringify(clean);
  }); // ---------------------------------------------------------------------
  // public Edge types
  // ---------------------------------------------------------------------

  var asEdgePendingVoucher = Object(external_cleaners_["asObject"])({
    voucherId: external_cleaners_["asString"],
    activates: external_cleaners_["asDate"],
    created: external_cleaners_["asDate"],
    ip: external_cleaners_["asString"],
    ipDescription: external_cleaners_["asString"],
    deviceDescription: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"])
  });
  var asEdgeLoginMessage = Object(external_cleaners_["asObject"])({
    loginId: external_cleaners_["asString"],
    otpResetPending: Object(external_cleaners_["asOptional"])(external_cleaners_["asBoolean"], false),
    pendingVouchers: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(asEdgePendingVoucher), []),
    recovery2Corrupt: Object(external_cleaners_["asOptional"])(external_cleaners_["asBoolean"], false)
  });
  var asEdgeRecoveryQuestionChoice = Object(external_cleaners_["asObject"])({
    min_length: external_cleaners_["asNumber"],
    category: function category(raw) {
      var clean = Object(external_cleaners_["asString"])(raw);

      switch (clean) {
        case 'address':
        case 'must':
        case 'numeric':
        case 'recovery2':
        case 'string':
          return clean;
      }

      throw new TypeError('Invalid question category');
    },
    question: external_cleaners_["asString"]
  }); // ---------------------------------------------------------------------
  // internal Edge types
  // ---------------------------------------------------------------------

  var asEdgeBox = Object(external_cleaners_["asObject"])({
    encryptionType: external_cleaners_["asNumber"],
    data_base64: external_cleaners_["asString"],
    iv_hex: external_cleaners_["asString"]
  });
  var asEdgeSnrp = Object(external_cleaners_["asObject"])({
    salt_hex: external_cleaners_["asString"],
    n: external_cleaners_["asNumber"],
    r: external_cleaners_["asNumber"],
    p: external_cleaners_["asNumber"]
  });
  var asEdgeLobbyRequest = Object(external_cleaners_["asObject"])({
    publicKey: external_cleaners_["asString"],
    loginRequest: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asObject"])({
      appId: external_cleaners_["asString"]
    }).withRest),
    timeout: Object(external_cleaners_["asOptional"])(external_cleaners_["asNumber"])
  }).withRest;
  var asEdgeLobbyReply = Object(external_cleaners_["asObject"])({
    publicKey: external_cleaners_["asString"],
    box: asEdgeBox
  });
  /**
   * An array of base64-encoded hashed recovery answers.
   */

  var asRecovery2Auth = Object(external_cleaners_["asArray"])(asBase64); // ---------------------------------------------------------------------
  // top-level request & response bodies
  // ---------------------------------------------------------------------

  var asLoginRequestBody = Object(external_cleaners_["asObject"])({
    // The request payload:
    data: external_cleaners_["asUnknown"],
    // Common fields for all login methods:
    deviceDescription: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    otp: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    voucherId: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    voucherAuth: Object(external_cleaners_["asOptional"])(asBase64),
    // Secret-key login:
    loginId: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    loginAuth: Object(external_cleaners_["asOptional"])(asBase64),
    // Password login:
    userId: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    passwordAuth: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    // PIN login:
    pin2Id: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    pin2Auth: Object(external_cleaners_["asOptional"])(asBase64),
    // Recovery login:
    recovery2Id: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    recovery2Auth: Object(external_cleaners_["asOptional"])(asRecovery2Auth),
    // Messages:
    loginIds: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(external_cleaners_["asString"])),
    // OTP reset:
    otpResetAuth: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    // Legacy:
    did: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    l1: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    lp1: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    lpin1: Object(external_cleaners_["asOptional"])(asBase64),
    lra1: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    recoveryAuth: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]) // lra1

  });
  var asLoginResponseBody = Object(external_cleaners_["asObject"])({
    // The response payload:
    results: Object(external_cleaners_["asOptional"])(external_cleaners_["asUnknown"]),
    // What type of response is this (success or failure)?:
    status_code: external_cleaners_["asNumber"],
    message: external_cleaners_["asString"]
  }); // ---------------------------------------------------------------------
  // request payloads
  // ---------------------------------------------------------------------

  var asChangeOtpPayload = Object(external_cleaners_["asObject"])({
    otpTimeout: Object(external_cleaners_["asOptional"])(external_cleaners_["asNumber"], 7 * 24 * 60 * 60),
    // seconds
    otpKey: external_cleaners_["asString"]
  });
  var asChangePasswordPayload = Object(external_cleaners_["asObject"])({
    passwordAuth: external_cleaners_["asString"],
    passwordAuthBox: asEdgeBox,
    passwordAuthSnrp: asEdgeSnrp,
    passwordBox: asEdgeBox,
    passwordKeySnrp: asEdgeSnrp
  });
  var asChangePin2Payload = Object(external_cleaners_["asObject"])({
    pin2Id: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    pin2Auth: Object(external_cleaners_["asOptional"])(asBase64),
    pin2Box: Object(external_cleaners_["asOptional"])(asEdgeBox),
    pin2KeyBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    pin2TextBox: asEdgeBox
  });
  var asChangeRecovery2Payload = Object(external_cleaners_["asObject"])({
    recovery2Id: external_cleaners_["asString"],
    recovery2Auth: asRecovery2Auth,
    recovery2Box: asEdgeBox,
    recovery2KeyBox: asEdgeBox,
    question2Box: asEdgeBox
  });
  var asChangeSecretPayload = Object(external_cleaners_["asObject"])({
    loginAuthBox: asEdgeBox,
    loginAuth: asBase64
  });
  var asChangeVouchersPayload = Object(external_cleaners_["asObject"])({
    approvedVouchers: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(external_cleaners_["asString"])),
    rejectedVouchers: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(external_cleaners_["asString"]))
  });
  var asCreateKeysPayload = Object(external_cleaners_["asObject"])({
    keyBoxes: Object(external_cleaners_["asArray"])(asEdgeBox),
    newSyncKeys: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(external_cleaners_["asString"]), [])
  });
  var asCreateLoginPayload = Object(external_cleaners_["asObject"])({
    appId: external_cleaners_["asString"],
    loginId: external_cleaners_["asString"],
    // base64
    parentBox: Object(external_cleaners_["asOptional"])(asEdgeBox)
  }).withRest; // ---------------------------------------------------------------------
  // response payloads
  // ---------------------------------------------------------------------

  var asLobbyPayload = Object(external_cleaners_["asObject"])({
    request: asEdgeLobbyRequest,
    replies: Object(external_cleaners_["asArray"])(asEdgeLobbyReply)
  });
  var asLoginPayload = Object(external_cleaners_["asObject"])({
    // Identity:
    appId: external_cleaners_["asString"],
    created: Object(external_cleaners_["asOptional"])(external_cleaners_["asDate"]),
    loginId: external_cleaners_["asString"],
    // Nested logins:
    children: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(function (raw) {
      return asLoginPayload(raw);
    })),
    parentBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    // 2-factor login:
    otpKey: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    otpResetDate: Object(external_cleaners_["asOptional"])(external_cleaners_["asDate"]),
    otpTimeout: Object(external_cleaners_["asOptional"])(external_cleaners_["asNumber"]),
    // Password login:
    passwordAuthBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    passwordAuthSnrp: Object(external_cleaners_["asOptional"])(asEdgeSnrp),
    passwordBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    passwordKeySnrp: Object(external_cleaners_["asOptional"])(asEdgeSnrp),
    // PIN v2 login:
    pin2Box: Object(external_cleaners_["asOptional"])(asEdgeBox),
    pin2KeyBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    pin2TextBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    // Recovery v2 login:
    question2Box: Object(external_cleaners_["asOptional"])(asEdgeBox),
    recovery2Box: Object(external_cleaners_["asOptional"])(asEdgeBox),
    recovery2KeyBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    // Secret-key login:
    loginAuthBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    // Voucher login:
    pendingVouchers: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(asEdgePendingVoucher), []),
    // Resources:
    keyBoxes: Object(external_cleaners_["asOptional"])(Object(external_cleaners_["asArray"])(asEdgeBox)),
    mnemonicBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    rootKeyBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    syncKeyBox: Object(external_cleaners_["asOptional"])(asEdgeBox)
  });
  var asMessagesPayload = Object(external_cleaners_["asArray"])(asEdgeLoginMessage);
  var asOtpErrorPayload = Object(external_cleaners_["asObject"])({
    login_id: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    otp_reset_auth: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    otp_timeout_date: Object(external_cleaners_["asOptional"])(external_cleaners_["asDate"]),
    reason: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"]),
    voucher_activates: Object(external_cleaners_["asOptional"])(external_cleaners_["asDate"]),
    voucher_auth: Object(external_cleaners_["asOptional"])(asBase64),
    voucher_id: Object(external_cleaners_["asOptional"])(external_cleaners_["asString"])
  });
  var asOtpResetPayload = Object(external_cleaners_["asObject"])({
    otpResetDate: external_cleaners_["asDate"]
  });
  var asPasswordErrorPayload = Object(external_cleaners_["asObject"])({
    wait_seconds: Object(external_cleaners_["asOptional"])(external_cleaners_["asNumber"])
  });
  var asQuestionChoicesPayload = Object(external_cleaners_["asArray"])(asEdgeRecoveryQuestionChoice);
  var asRecovery2InfoPayload = Object(external_cleaners_["asObject"])({
    question2Box: asEdgeBox
  });
  var asUsernameInfoPayload = Object(external_cleaners_["asObject"])({
    // Password login:
    passwordAuthSnrp: Object(external_cleaners_["asOptional"])(asEdgeSnrp),
    // Recovery v1 login:
    questionBox: Object(external_cleaners_["asOptional"])(asEdgeBox),
    questionKeySnrp: Object(external_cleaners_["asOptional"])(asEdgeSnrp),
    recoveryAuthSnrp: Object(external_cleaners_["asOptional"])(asEdgeSnrp)
  }); // CONCATENATED MODULE: ./src/types/error.js

  /*
   * These are errors the core knows about.
   *
   * The GUI should handle these errors in an "intelligent" way, such as by
   * displaying a localized error message or asking the user for more info.
   * All these errors have a `name` field, which the GUI can use to select
   * the appropriate response.
   *
   * Other errors are possible, of course, since the Javascript language
   * itself can generate exceptions. Those errors won't have a `type` field,
   * and the GUI should just show them with a stack trace & generic message,
   * since the program has basically crashed at that point.
   */

  var errorNames = {
    DustSpendError: 'DustSpendError',
    InsufficientFundsError: 'InsufficientFundsError',
    NetworkError: 'NetworkError',
    NoAmountSpecifiedError: 'NoAmountSpecifiedError',
    ObsoleteApiError: 'ObsoleteApiError',
    OtpError: 'OtpError',
    PasswordError: 'PasswordError',
    PendingFundsError: 'PendingFundsError',
    SameCurrencyError: 'SameCurrencyError',
    SpendToSelfError: 'SpendToSelfError',
    SwapAboveLimitError: 'SwapAboveLimitError',
    SwapBelowLimitError: 'SwapBelowLimitError',
    SwapCurrencyError: 'SwapCurrencyError',
    SwapPermissionError: 'SwapPermissionError',
    UsernameError: 'UsernameError'
  };
  /**
   * Trying to spend an uneconomically small amount of money.
   */

  function DustSpendError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Please send a larger amount';
    if (!(this instanceof DustSpendError)) throw new TypeError("Class constructor DustSpendError cannot be invoked without 'new'");

    var _this;

    function _super(message) {
      _this = new Error(message);
      Object.defineProperty(_this, "constructor", {
        value: DustSpendError,
        configurable: true,
        writable: true
      });
      return _this;
    }

    _super(message);

    _this.name = 'DustSpendError';
    return _this;
  }
  /**
   * Trying to spend more money than the wallet contains.
   */


  function InsufficientFundsError(currencyCode) {
    if (!(this instanceof InsufficientFundsError)) throw new TypeError("Class constructor InsufficientFundsError cannot be invoked without 'new'");

    var _this2;

    function _super2(message) {
      _this2 = new Error(message);
      Object.defineProperty(_this2, "constructor", {
        value: InsufficientFundsError,
        configurable: true,
        writable: true
      });
      return _this2;
    }

    var message;

    if (currencyCode == null) {
      message = 'Insufficient funds';
    } else if (currencyCode.length > 5) {
      // Some plugins pass a message instead of a currency code:
      message = currencyCode;
      currencyCode = undefined;
    } else {
      message = "Insufficient ".concat(currencyCode);
    }

    _super2(message);

    _this2.name = 'InsufficientFundsError';
    if (currencyCode != null) _this2.currencyCode = currencyCode;
    return _this2;
  }
  /**
   * Could not reach the server at all.
   */


  function NetworkError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Cannot reach the network';
    if (!(this instanceof NetworkError)) throw new TypeError("Class constructor NetworkError cannot be invoked without 'new'");

    var _this3;

    function _super3(message) {
      _this3 = new Error(message);
      Object.defineProperty(_this3, "constructor", {
        value: NetworkError,
        configurable: true,
        writable: true
      });
      return _this3;
    }

    _super3(message);

    _this3.name = _this3.type = 'NetworkError';
    return _this3;
  }
  /**
   * Attempting to create a MakeSpend without specifying an amount of currency to send
   */


  function NoAmountSpecifiedError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Unable to create zero-amount transaction.';
    if (!(this instanceof NoAmountSpecifiedError)) throw new TypeError("Class constructor NoAmountSpecifiedError cannot be invoked without 'new'");

    var _this4;

    function _super4(message) {
      _this4 = new Error(message);
      Object.defineProperty(_this4, "constructor", {
        value: NoAmountSpecifiedError,
        configurable: true,
        writable: true
      });
      return _this4;
    }

    _super4(message);

    _this4.name = 'NoAmountSpecifiedError';
    return _this4;
  }
  /**
   * The endpoint on the server is obsolete, and the app needs to be upgraded.
   */


  function ObsoleteApiError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'The application is too old. Please upgrade.';
    if (!(this instanceof ObsoleteApiError)) throw new TypeError("Class constructor ObsoleteApiError cannot be invoked without 'new'");

    var _this5;

    function _super5(message) {
      _this5 = new Error(message);
      Object.defineProperty(_this5, "constructor", {
        value: ObsoleteApiError,
        configurable: true,
        writable: true
      });
      return _this5;
    }

    _super5(message);

    _this5.name = _this5.type = 'ObsoleteApiError';
    return _this5;
  }
  /**
   * The OTP token was missing / incorrect.
   *
   * The error object should include a `resetToken` member,
   * which can be used to reset OTP protection on the account.
   *
   * The error object may include a `resetDate` member,
   * which indicates that an OTP reset is already pending,
   * and when it will complete.
   */


  function OtpError(resultsJson) {
    var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Invalid OTP token';
    if (!(this instanceof OtpError)) throw new TypeError("Class constructor OtpError cannot be invoked without 'new'");

    var _this6;

    function _super6(message) {
      _this6 = new Error(message);
      Object.defineProperty(_this6, "constructor", {
        value: OtpError,
        configurable: true,
        writable: true
      });
      return _this6;
    }

    _super6(message);

    _this6.name = _this6.type = 'OtpError';
    _this6.reason = 'otp';

    try {
      var clean = asOtpErrorPayload(resultsJson); // This should usually be present:

      if (clean.login_id != null) {
        _this6.loginId = clean.login_id;
      } // Use this to request an OTP reset (if enabled):


      if (clean.otp_reset_auth != null) {
        _this6.resetToken = clean.otp_reset_auth;
      } // We might also get a different reason:


      if (clean.reason === 'ip') _this6.reason = 'ip'; // Set if an OTP reset has already been requested:

      if (clean.otp_timeout_date != null) {
        _this6.resetDate = new Date(clean.otp_timeout_date);
      } // We might also get a login voucher:


      if (clean.voucher_activates != null) {
        _this6.voucherActivates = clean.voucher_activates;
      }

      if (clean.voucher_auth != null) {
        _this6.voucherAuth = external_rfc4648_["base64"].stringify(clean.voucher_auth);
      }

      if (clean.voucher_id != null) _this6.voucherId = clean.voucher_id;
    } catch (e) {}

    return _this6;
  }
  /**
   * The provided authentication is incorrect.
   *
   * Reasons could include:
   * - Password login: wrong password
   * - PIN login: wrong PIN
   * - Recovery login: wrong answers
   *
   * The error object may include a `wait` member,
   * which is the number of seconds the user must wait before trying again.
   */


  function PasswordError(resultsJson) {
    var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Invalid password';
    if (!(this instanceof PasswordError)) throw new TypeError("Class constructor PasswordError cannot be invoked without 'new'");

    var _this7;

    function _super7(message) {
      _this7 = new Error(message);
      Object.defineProperty(_this7, "constructor", {
        value: PasswordError,
        configurable: true,
        writable: true
      });
      return _this7;
    }

    _super7(message);

    _this7.name = _this7.type = 'PasswordError';

    try {
      var clean = asPasswordErrorPayload(resultsJson);
      _this7.wait = clean.wait_seconds;
    } catch (e) {}

    return _this7;
  }
  /**
   * Trying to spend funds that are not yet confirmed.
   */


  function PendingFundsError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Not enough confirmed funds';
    if (!(this instanceof PendingFundsError)) throw new TypeError("Class constructor PendingFundsError cannot be invoked without 'new'");

    var _this8;

    function _super8(message) {
      _this8 = new Error(message);
      Object.defineProperty(_this8, "constructor", {
        value: PendingFundsError,
        configurable: true,
        writable: true
      });
      return _this8;
    }

    _super8(message);

    _this8.name = 'PendingFundsError';
    return _this8;
  }
  /**
   * Attempting to shape shift between two wallets of same currency.
   */


  function SameCurrencyError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Wallets can not be the same currency';
    if (!(this instanceof SameCurrencyError)) throw new TypeError("Class constructor SameCurrencyError cannot be invoked without 'new'");

    var _this9;

    function _super9(message) {
      _this9 = new Error(message);
      Object.defineProperty(_this9, "constructor", {
        value: SameCurrencyError,
        configurable: true,
        writable: true
      });
      return _this9;
    }

    _super9(message);

    _this9.name = 'SameCurrencyError';
    return _this9;
  }
  /**
   * Trying to spend to an address of the source wallet
   */


  function SpendToSelfError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Spending to self';
    if (!(this instanceof SpendToSelfError)) throw new TypeError("Class constructor SpendToSelfError cannot be invoked without 'new'");

    var _this10;

    function _super10(message) {
      _this10 = new Error(message);
      Object.defineProperty(_this10, "constructor", {
        value: SpendToSelfError,
        configurable: true,
        writable: true
      });
      return _this10;
    }

    _super10(message);

    _this10.name = 'SpendToSelfError';
    return _this10;
  }
  /**
   * Trying to swap an amount that is either too low or too high.
   * @param nativeMax the maximum supported amount, in the "from" currency.
   */


  function SwapAboveLimitError(swapInfo, nativeMax) {
    if (!(this instanceof SwapAboveLimitError)) throw new TypeError("Class constructor SwapAboveLimitError cannot be invoked without 'new'");

    var _this11;

    function _super11(message) {
      _this11 = new Error(message);
      Object.defineProperty(_this11, "constructor", {
        value: SwapAboveLimitError,
        configurable: true,
        writable: true
      });
      return _this11;
    }

    _super11('Amount is too high');

    _this11.name = 'SwapAboveLimitError';
    _this11.pluginId = swapInfo.pluginId;
    _this11.nativeMax = nativeMax;
    return _this11;
  }
  /**
   * Trying to swap an amount that is either too low or too high.
   * @param nativeMin the minimum supported amount, in the "from" currency.
   */


  function SwapBelowLimitError(swapInfo, nativeMin) {
    if (!(this instanceof SwapBelowLimitError)) throw new TypeError("Class constructor SwapBelowLimitError cannot be invoked without 'new'");

    var _this12;

    function _super12(message) {
      _this12 = new Error(message);
      Object.defineProperty(_this12, "constructor", {
        value: SwapBelowLimitError,
        configurable: true,
        writable: true
      });
      return _this12;
    }

    _super12('Amount is too low');

    _this12.name = 'SwapBelowLimitError';
    _this12.pluginId = swapInfo.pluginId;
    _this12.nativeMin = nativeMin;
    return _this12;
  }
  /**
   * The swap plugin does not support this currency pair.
   */


  function SwapCurrencyError(swapInfo, fromCurrency, toCurrency) {
    if (!(this instanceof SwapCurrencyError)) throw new TypeError("Class constructor SwapCurrencyError cannot be invoked without 'new'");

    var _this13;

    function _super13(message) {
      _this13 = new Error(message);
      Object.defineProperty(_this13, "constructor", {
        value: SwapCurrencyError,
        configurable: true,
        writable: true
      });
      return _this13;
    }

    _super13("".concat(swapInfo.displayName, " does not support ").concat(fromCurrency, " to ").concat(toCurrency));

    _this13.name = 'SwapCurrencyError';
    _this13.pluginId = swapInfo.pluginId;
    _this13.fromCurrency = fromCurrency;
    _this13.toCurrency = toCurrency;
    return _this13;
  }
  /**
   * The user is not allowed to swap these coins for some reason
   * (no KYC, restricted IP address, etc...).
   * @param reason A string giving the reason for the denial.
   * - 'geoRestriction': The IP address is in a restricted region
   * - 'noVerification': The user needs to provide KYC credentials
   * - 'needsActivation': The user needs to log into the service.
   */


  function SwapPermissionError(swapInfo, reason) {
    if (!(this instanceof SwapPermissionError)) throw new TypeError("Class constructor SwapPermissionError cannot be invoked without 'new'");

    var _this14;

    function _super14(message) {
      _this14 = new Error(message);
      Object.defineProperty(_this14, "constructor", {
        value: SwapPermissionError,
        configurable: true,
        writable: true
      });
      return _this14;
    }

    if (reason != null) _super14(reason);else _super14('You are not allowed to make this trade');
    _this14.name = 'SwapPermissionError';
    _this14.pluginId = swapInfo.pluginId;
    _this14.reason = reason;
    return _this14;
  }
  /**
   * Cannot find a login with that id.
   *
   * Reasons could include:
   * - Password login: wrong username
   * - PIN login: wrong PIN key
   * - Recovery login: wrong username, or wrong recovery key
   */


  function UsernameError() {
    var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'Invalid username';
    if (!(this instanceof UsernameError)) throw new TypeError("Class constructor UsernameError cannot be invoked without 'new'");

    var _this15;

    function _super15(message) {
      _this15 = new Error(message);
      Object.defineProperty(_this15, "constructor", {
        value: UsernameError,
        configurable: true,
        writable: true
      });
      return _this15;
    }

    _super15(message);

    _this15.name = _this15.type = 'UsernameError';
    return _this15;
  }

  function asMaybeError(name) {
    return function asError(raw) {
      if (raw instanceof Error && raw.name === name) {
        var typeHack = raw;
        return typeHack;
      }
    };
  }

  var asMaybeDustSpendError = asMaybeError('DustSpendError');
  var asMaybeInsufficientFundsError = asMaybeError('InsufficientFundsError');
  var asMaybeNetworkError = asMaybeError('NetworkError');
  var asMaybeNoAmountSpecifiedError = asMaybeError('NoAmountSpecifiedError');
  var asMaybeObsoleteApiError = asMaybeError('ObsoleteApiError');
  var asMaybeOtpError = asMaybeError('OtpError');
  var asMaybePasswordError = asMaybeError('PasswordError');
  var asMaybePendingFundsError = asMaybeError('PendingFundsError');
  var asMaybeSameCurrencyError = asMaybeError('SameCurrencyError');
  var asMaybeSpendToSelfError = asMaybeError('SpendToSelfError');
  var asMaybeSwapAboveLimitError = asMaybeError('SwapAboveLimitError');
  var asMaybeSwapBelowLimitError = asMaybeError('SwapBelowLimitError');
  var asMaybeSwapCurrencyError = asMaybeError('SwapCurrencyError');
  var asMaybeSwapPermissionError = asMaybeError('SwapPermissionError');
  var asMaybeUsernameError = asMaybeError('UsernameError'); // CONCATENATED MODULE: ./src/types/types.js
  // ---------------------------------------------------------------------
  // helper types
  // ---------------------------------------------------------------------

  /** A JSON object (as opposed to an array or primitive). */

  /***/
}
/******/
]));

/***/ }),

/***/ "./node_modules/hash.js/lib/hash.js":
/*!******************************************!*\
  !*** ./node_modules/hash.js/lib/hash.js ***!
  \******************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

var hash = exports;
hash.utils = __webpack_require__(/*! ./hash/utils */ "./node_modules/hash.js/lib/hash/utils.js");
hash.common = __webpack_require__(/*! ./hash/common */ "./node_modules/hash.js/lib/hash/common.js");
hash.sha = __webpack_require__(/*! ./hash/sha */ "./node_modules/hash.js/lib/hash/sha.js");
hash.ripemd = __webpack_require__(/*! ./hash/ripemd */ "./node_modules/hash.js/lib/hash/ripemd.js");
hash.hmac = __webpack_require__(/*! ./hash/hmac */ "./node_modules/hash.js/lib/hash/hmac.js"); // Proxy hash functions to the main object

hash.sha1 = hash.sha.sha1;
hash.sha256 = hash.sha.sha256;
hash.sha224 = hash.sha.sha224;
hash.sha384 = hash.sha.sha384;
hash.sha512 = hash.sha.sha512;
hash.ripemd160 = hash.ripemd.ripemd160;

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/common.js":
/*!*************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/common.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./utils */ "./node_modules/hash.js/lib/hash/utils.js");

var assert = __webpack_require__(/*! minimalistic-assert */ "./node_modules/minimalistic-assert/index.js");

function BlockHash() {
  this.pending = null;
  this.pendingTotal = 0;
  this.blockSize = this.constructor.blockSize;
  this.outSize = this.constructor.outSize;
  this.hmacStrength = this.constructor.hmacStrength;
  this.padLength = this.constructor.padLength / 8;
  this.endian = 'big';
  this._delta8 = this.blockSize / 8;
  this._delta32 = this.blockSize / 32;
}

exports.BlockHash = BlockHash;

BlockHash.prototype.update = function update(msg, enc) {
  // Convert message to array, pad it, and join into 32bit blocks
  msg = utils.toArray(msg, enc);
  if (!this.pending) this.pending = msg;else this.pending = this.pending.concat(msg);
  this.pendingTotal += msg.length; // Enough data, try updating

  if (this.pending.length >= this._delta8) {
    msg = this.pending; // Process pending data in blocks

    var r = msg.length % this._delta8;
    this.pending = msg.slice(msg.length - r, msg.length);
    if (this.pending.length === 0) this.pending = null;
    msg = utils.join32(msg, 0, msg.length - r, this.endian);

    for (var i = 0; i < msg.length; i += this._delta32) {
      this._update(msg, i, i + this._delta32);
    }
  }

  return this;
};

BlockHash.prototype.digest = function digest(enc) {
  this.update(this._pad());
  assert(this.pending === null);
  return this._digest(enc);
};

BlockHash.prototype._pad = function pad() {
  var len = this.pendingTotal;
  var bytes = this._delta8;
  var k = bytes - (len + this.padLength) % bytes;
  var res = new Array(k + this.padLength);
  res[0] = 0x80;

  for (var i = 1; i < k; i++) {
    res[i] = 0;
  } // Append length


  len <<= 3;

  if (this.endian === 'big') {
    for (var t = 8; t < this.padLength; t++) {
      res[i++] = 0;
    }

    res[i++] = 0;
    res[i++] = 0;
    res[i++] = 0;
    res[i++] = 0;
    res[i++] = len >>> 24 & 0xff;
    res[i++] = len >>> 16 & 0xff;
    res[i++] = len >>> 8 & 0xff;
    res[i++] = len & 0xff;
  } else {
    res[i++] = len & 0xff;
    res[i++] = len >>> 8 & 0xff;
    res[i++] = len >>> 16 & 0xff;
    res[i++] = len >>> 24 & 0xff;
    res[i++] = 0;
    res[i++] = 0;
    res[i++] = 0;
    res[i++] = 0;

    for (t = 8; t < this.padLength; t++) {
      res[i++] = 0;
    }
  }

  return res;
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/hmac.js":
/*!***********************************************!*\
  !*** ./node_modules/hash.js/lib/hash/hmac.js ***!
  \***********************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./utils */ "./node_modules/hash.js/lib/hash/utils.js");

var assert = __webpack_require__(/*! minimalistic-assert */ "./node_modules/minimalistic-assert/index.js");

function Hmac(hash, key, enc) {
  if (!(this instanceof Hmac)) return new Hmac(hash, key, enc);
  this.Hash = hash;
  this.blockSize = hash.blockSize / 8;
  this.outSize = hash.outSize / 8;
  this.inner = null;
  this.outer = null;

  this._init(utils.toArray(key, enc));
}

module.exports = Hmac;

Hmac.prototype._init = function init(key) {
  // Shorten key, if needed
  if (key.length > this.blockSize) key = new this.Hash().update(key).digest();
  assert(key.length <= this.blockSize); // Add padding to key

  for (var i = key.length; i < this.blockSize; i++) {
    key.push(0);
  }

  for (i = 0; i < key.length; i++) {
    key[i] ^= 0x36;
  }

  this.inner = new this.Hash().update(key); // 0x36 ^ 0x5c = 0x6a

  for (i = 0; i < key.length; i++) {
    key[i] ^= 0x6a;
  }

  this.outer = new this.Hash().update(key);
};

Hmac.prototype.update = function update(msg, enc) {
  this.inner.update(msg, enc);
  return this;
};

Hmac.prototype.digest = function digest(enc) {
  this.outer.update(this.inner.digest());
  return this.outer.digest(enc);
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/ripemd.js":
/*!*************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/ripemd.js ***!
  \*************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ./utils */ "./node_modules/hash.js/lib/hash/utils.js");

var common = __webpack_require__(/*! ./common */ "./node_modules/hash.js/lib/hash/common.js");

var rotl32 = utils.rotl32;
var sum32 = utils.sum32;
var sum32_3 = utils.sum32_3;
var sum32_4 = utils.sum32_4;
var BlockHash = common.BlockHash;

function RIPEMD160() {
  if (!(this instanceof RIPEMD160)) return new RIPEMD160();
  BlockHash.call(this);
  this.h = [0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476, 0xc3d2e1f0];
  this.endian = 'little';
}

utils.inherits(RIPEMD160, BlockHash);
exports.ripemd160 = RIPEMD160;
RIPEMD160.blockSize = 512;
RIPEMD160.outSize = 160;
RIPEMD160.hmacStrength = 192;
RIPEMD160.padLength = 64;

RIPEMD160.prototype._update = function update(msg, start) {
  var A = this.h[0];
  var B = this.h[1];
  var C = this.h[2];
  var D = this.h[3];
  var E = this.h[4];
  var Ah = A;
  var Bh = B;
  var Ch = C;
  var Dh = D;
  var Eh = E;

  for (var j = 0; j < 80; j++) {
    var T = sum32(rotl32(sum32_4(A, f(j, B, C, D), msg[r[j] + start], K(j)), s[j]), E);
    A = E;
    E = D;
    D = rotl32(C, 10);
    C = B;
    B = T;
    T = sum32(rotl32(sum32_4(Ah, f(79 - j, Bh, Ch, Dh), msg[rh[j] + start], Kh(j)), sh[j]), Eh);
    Ah = Eh;
    Eh = Dh;
    Dh = rotl32(Ch, 10);
    Ch = Bh;
    Bh = T;
  }

  T = sum32_3(this.h[1], C, Dh);
  this.h[1] = sum32_3(this.h[2], D, Eh);
  this.h[2] = sum32_3(this.h[3], E, Ah);
  this.h[3] = sum32_3(this.h[4], A, Bh);
  this.h[4] = sum32_3(this.h[0], B, Ch);
  this.h[0] = T;
};

RIPEMD160.prototype._digest = function digest(enc) {
  if (enc === 'hex') return utils.toHex32(this.h, 'little');else return utils.split32(this.h, 'little');
};

function f(j, x, y, z) {
  if (j <= 15) return x ^ y ^ z;else if (j <= 31) return x & y | ~x & z;else if (j <= 47) return (x | ~y) ^ z;else if (j <= 63) return x & z | y & ~z;else return x ^ (y | ~z);
}

function K(j) {
  if (j <= 15) return 0x00000000;else if (j <= 31) return 0x5a827999;else if (j <= 47) return 0x6ed9eba1;else if (j <= 63) return 0x8f1bbcdc;else return 0xa953fd4e;
}

function Kh(j) {
  if (j <= 15) return 0x50a28be6;else if (j <= 31) return 0x5c4dd124;else if (j <= 47) return 0x6d703ef3;else if (j <= 63) return 0x7a6d76e9;else return 0x00000000;
}

var r = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 7, 4, 13, 1, 10, 6, 15, 3, 12, 0, 9, 5, 2, 14, 11, 8, 3, 10, 14, 4, 9, 15, 8, 1, 2, 7, 0, 6, 13, 11, 5, 12, 1, 9, 11, 10, 0, 8, 12, 4, 13, 3, 7, 15, 14, 5, 6, 2, 4, 0, 5, 9, 7, 12, 2, 10, 14, 1, 3, 8, 11, 6, 15, 13];
var rh = [5, 14, 7, 0, 9, 2, 11, 4, 13, 6, 15, 8, 1, 10, 3, 12, 6, 11, 3, 7, 0, 13, 5, 10, 14, 15, 8, 12, 4, 9, 1, 2, 15, 5, 1, 3, 7, 14, 6, 9, 11, 8, 12, 2, 10, 0, 4, 13, 8, 6, 4, 1, 3, 11, 15, 0, 5, 12, 2, 13, 9, 7, 10, 14, 12, 15, 10, 4, 1, 5, 8, 7, 6, 2, 13, 14, 0, 3, 9, 11];
var s = [11, 14, 15, 12, 5, 8, 7, 9, 11, 13, 14, 15, 6, 7, 9, 8, 7, 6, 8, 13, 11, 9, 7, 15, 7, 12, 15, 9, 11, 7, 13, 12, 11, 13, 6, 7, 14, 9, 13, 15, 14, 8, 13, 6, 5, 12, 7, 5, 11, 12, 14, 15, 14, 15, 9, 8, 9, 14, 5, 6, 8, 6, 5, 12, 9, 15, 5, 11, 6, 8, 13, 12, 5, 12, 13, 14, 11, 8, 5, 6];
var sh = [8, 9, 9, 11, 13, 15, 15, 5, 7, 7, 8, 11, 14, 14, 12, 6, 9, 13, 15, 7, 12, 8, 9, 11, 7, 7, 12, 7, 6, 15, 13, 11, 9, 7, 15, 11, 8, 6, 6, 14, 12, 13, 5, 14, 13, 13, 7, 5, 15, 5, 8, 11, 14, 14, 6, 14, 6, 9, 12, 9, 12, 5, 15, 8, 8, 5, 12, 9, 12, 5, 14, 6, 8, 13, 6, 5, 15, 13, 11, 11];

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha.js":
/*!**********************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha.js ***!
  \**********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";


exports.sha1 = __webpack_require__(/*! ./sha/1 */ "./node_modules/hash.js/lib/hash/sha/1.js");
exports.sha224 = __webpack_require__(/*! ./sha/224 */ "./node_modules/hash.js/lib/hash/sha/224.js");
exports.sha256 = __webpack_require__(/*! ./sha/256 */ "./node_modules/hash.js/lib/hash/sha/256.js");
exports.sha384 = __webpack_require__(/*! ./sha/384 */ "./node_modules/hash.js/lib/hash/sha/384.js");
exports.sha512 = __webpack_require__(/*! ./sha/512 */ "./node_modules/hash.js/lib/hash/sha/512.js");

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/1.js":
/*!************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/1.js ***!
  \************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var common = __webpack_require__(/*! ../common */ "./node_modules/hash.js/lib/hash/common.js");

var shaCommon = __webpack_require__(/*! ./common */ "./node_modules/hash.js/lib/hash/sha/common.js");

var rotl32 = utils.rotl32;
var sum32 = utils.sum32;
var sum32_5 = utils.sum32_5;
var ft_1 = shaCommon.ft_1;
var BlockHash = common.BlockHash;
var sha1_K = [0x5A827999, 0x6ED9EBA1, 0x8F1BBCDC, 0xCA62C1D6];

function SHA1() {
  if (!(this instanceof SHA1)) return new SHA1();
  BlockHash.call(this);
  this.h = [0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476, 0xc3d2e1f0];
  this.W = new Array(80);
}

utils.inherits(SHA1, BlockHash);
module.exports = SHA1;
SHA1.blockSize = 512;
SHA1.outSize = 160;
SHA1.hmacStrength = 80;
SHA1.padLength = 64;

SHA1.prototype._update = function _update(msg, start) {
  var W = this.W;

  for (var i = 0; i < 16; i++) {
    W[i] = msg[start + i];
  }

  for (; i < W.length; i++) {
    W[i] = rotl32(W[i - 3] ^ W[i - 8] ^ W[i - 14] ^ W[i - 16], 1);
  }

  var a = this.h[0];
  var b = this.h[1];
  var c = this.h[2];
  var d = this.h[3];
  var e = this.h[4];

  for (i = 0; i < W.length; i++) {
    var s = ~~(i / 20);
    var t = sum32_5(rotl32(a, 5), ft_1(s, b, c, d), e, W[i], sha1_K[s]);
    e = d;
    d = c;
    c = rotl32(b, 30);
    b = a;
    a = t;
  }

  this.h[0] = sum32(this.h[0], a);
  this.h[1] = sum32(this.h[1], b);
  this.h[2] = sum32(this.h[2], c);
  this.h[3] = sum32(this.h[3], d);
  this.h[4] = sum32(this.h[4], e);
};

SHA1.prototype._digest = function digest(enc) {
  if (enc === 'hex') return utils.toHex32(this.h, 'big');else return utils.split32(this.h, 'big');
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/224.js":
/*!**************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/224.js ***!
  \**************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var SHA256 = __webpack_require__(/*! ./256 */ "./node_modules/hash.js/lib/hash/sha/256.js");

function SHA224() {
  if (!(this instanceof SHA224)) return new SHA224();
  SHA256.call(this);
  this.h = [0xc1059ed8, 0x367cd507, 0x3070dd17, 0xf70e5939, 0xffc00b31, 0x68581511, 0x64f98fa7, 0xbefa4fa4];
}

utils.inherits(SHA224, SHA256);
module.exports = SHA224;
SHA224.blockSize = 512;
SHA224.outSize = 224;
SHA224.hmacStrength = 192;
SHA224.padLength = 64;

SHA224.prototype._digest = function digest(enc) {
  // Just truncate output
  if (enc === 'hex') return utils.toHex32(this.h.slice(0, 7), 'big');else return utils.split32(this.h.slice(0, 7), 'big');
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/256.js":
/*!**************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/256.js ***!
  \**************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var common = __webpack_require__(/*! ../common */ "./node_modules/hash.js/lib/hash/common.js");

var shaCommon = __webpack_require__(/*! ./common */ "./node_modules/hash.js/lib/hash/sha/common.js");

var assert = __webpack_require__(/*! minimalistic-assert */ "./node_modules/minimalistic-assert/index.js");

var sum32 = utils.sum32;
var sum32_4 = utils.sum32_4;
var sum32_5 = utils.sum32_5;
var ch32 = shaCommon.ch32;
var maj32 = shaCommon.maj32;
var s0_256 = shaCommon.s0_256;
var s1_256 = shaCommon.s1_256;
var g0_256 = shaCommon.g0_256;
var g1_256 = shaCommon.g1_256;
var BlockHash = common.BlockHash;
var sha256_K = [0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5, 0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5, 0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3, 0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174, 0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc, 0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da, 0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7, 0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967, 0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13, 0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85, 0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3, 0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070, 0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5, 0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3, 0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208, 0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2];

function SHA256() {
  if (!(this instanceof SHA256)) return new SHA256();
  BlockHash.call(this);
  this.h = [0x6a09e667, 0xbb67ae85, 0x3c6ef372, 0xa54ff53a, 0x510e527f, 0x9b05688c, 0x1f83d9ab, 0x5be0cd19];
  this.k = sha256_K;
  this.W = new Array(64);
}

utils.inherits(SHA256, BlockHash);
module.exports = SHA256;
SHA256.blockSize = 512;
SHA256.outSize = 256;
SHA256.hmacStrength = 192;
SHA256.padLength = 64;

SHA256.prototype._update = function _update(msg, start) {
  var W = this.W;

  for (var i = 0; i < 16; i++) {
    W[i] = msg[start + i];
  }

  for (; i < W.length; i++) {
    W[i] = sum32_4(g1_256(W[i - 2]), W[i - 7], g0_256(W[i - 15]), W[i - 16]);
  }

  var a = this.h[0];
  var b = this.h[1];
  var c = this.h[2];
  var d = this.h[3];
  var e = this.h[4];
  var f = this.h[5];
  var g = this.h[6];
  var h = this.h[7];
  assert(this.k.length === W.length);

  for (i = 0; i < W.length; i++) {
    var T1 = sum32_5(h, s1_256(e), ch32(e, f, g), this.k[i], W[i]);
    var T2 = sum32(s0_256(a), maj32(a, b, c));
    h = g;
    g = f;
    f = e;
    e = sum32(d, T1);
    d = c;
    c = b;
    b = a;
    a = sum32(T1, T2);
  }

  this.h[0] = sum32(this.h[0], a);
  this.h[1] = sum32(this.h[1], b);
  this.h[2] = sum32(this.h[2], c);
  this.h[3] = sum32(this.h[3], d);
  this.h[4] = sum32(this.h[4], e);
  this.h[5] = sum32(this.h[5], f);
  this.h[6] = sum32(this.h[6], g);
  this.h[7] = sum32(this.h[7], h);
};

SHA256.prototype._digest = function digest(enc) {
  if (enc === 'hex') return utils.toHex32(this.h, 'big');else return utils.split32(this.h, 'big');
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/384.js":
/*!**************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/384.js ***!
  \**************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var SHA512 = __webpack_require__(/*! ./512 */ "./node_modules/hash.js/lib/hash/sha/512.js");

function SHA384() {
  if (!(this instanceof SHA384)) return new SHA384();
  SHA512.call(this);
  this.h = [0xcbbb9d5d, 0xc1059ed8, 0x629a292a, 0x367cd507, 0x9159015a, 0x3070dd17, 0x152fecd8, 0xf70e5939, 0x67332667, 0xffc00b31, 0x8eb44a87, 0x68581511, 0xdb0c2e0d, 0x64f98fa7, 0x47b5481d, 0xbefa4fa4];
}

utils.inherits(SHA384, SHA512);
module.exports = SHA384;
SHA384.blockSize = 1024;
SHA384.outSize = 384;
SHA384.hmacStrength = 192;
SHA384.padLength = 128;

SHA384.prototype._digest = function digest(enc) {
  if (enc === 'hex') return utils.toHex32(this.h.slice(0, 12), 'big');else return utils.split32(this.h.slice(0, 12), 'big');
};

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/512.js":
/*!**************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/512.js ***!
  \**************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var common = __webpack_require__(/*! ../common */ "./node_modules/hash.js/lib/hash/common.js");

var assert = __webpack_require__(/*! minimalistic-assert */ "./node_modules/minimalistic-assert/index.js");

var rotr64_hi = utils.rotr64_hi;
var rotr64_lo = utils.rotr64_lo;
var shr64_hi = utils.shr64_hi;
var shr64_lo = utils.shr64_lo;
var sum64 = utils.sum64;
var sum64_hi = utils.sum64_hi;
var sum64_lo = utils.sum64_lo;
var sum64_4_hi = utils.sum64_4_hi;
var sum64_4_lo = utils.sum64_4_lo;
var sum64_5_hi = utils.sum64_5_hi;
var sum64_5_lo = utils.sum64_5_lo;
var BlockHash = common.BlockHash;
var sha512_K = [0x428a2f98, 0xd728ae22, 0x71374491, 0x23ef65cd, 0xb5c0fbcf, 0xec4d3b2f, 0xe9b5dba5, 0x8189dbbc, 0x3956c25b, 0xf348b538, 0x59f111f1, 0xb605d019, 0x923f82a4, 0xaf194f9b, 0xab1c5ed5, 0xda6d8118, 0xd807aa98, 0xa3030242, 0x12835b01, 0x45706fbe, 0x243185be, 0x4ee4b28c, 0x550c7dc3, 0xd5ffb4e2, 0x72be5d74, 0xf27b896f, 0x80deb1fe, 0x3b1696b1, 0x9bdc06a7, 0x25c71235, 0xc19bf174, 0xcf692694, 0xe49b69c1, 0x9ef14ad2, 0xefbe4786, 0x384f25e3, 0x0fc19dc6, 0x8b8cd5b5, 0x240ca1cc, 0x77ac9c65, 0x2de92c6f, 0x592b0275, 0x4a7484aa, 0x6ea6e483, 0x5cb0a9dc, 0xbd41fbd4, 0x76f988da, 0x831153b5, 0x983e5152, 0xee66dfab, 0xa831c66d, 0x2db43210, 0xb00327c8, 0x98fb213f, 0xbf597fc7, 0xbeef0ee4, 0xc6e00bf3, 0x3da88fc2, 0xd5a79147, 0x930aa725, 0x06ca6351, 0xe003826f, 0x14292967, 0x0a0e6e70, 0x27b70a85, 0x46d22ffc, 0x2e1b2138, 0x5c26c926, 0x4d2c6dfc, 0x5ac42aed, 0x53380d13, 0x9d95b3df, 0x650a7354, 0x8baf63de, 0x766a0abb, 0x3c77b2a8, 0x81c2c92e, 0x47edaee6, 0x92722c85, 0x1482353b, 0xa2bfe8a1, 0x4cf10364, 0xa81a664b, 0xbc423001, 0xc24b8b70, 0xd0f89791, 0xc76c51a3, 0x0654be30, 0xd192e819, 0xd6ef5218, 0xd6990624, 0x5565a910, 0xf40e3585, 0x5771202a, 0x106aa070, 0x32bbd1b8, 0x19a4c116, 0xb8d2d0c8, 0x1e376c08, 0x5141ab53, 0x2748774c, 0xdf8eeb99, 0x34b0bcb5, 0xe19b48a8, 0x391c0cb3, 0xc5c95a63, 0x4ed8aa4a, 0xe3418acb, 0x5b9cca4f, 0x7763e373, 0x682e6ff3, 0xd6b2b8a3, 0x748f82ee, 0x5defb2fc, 0x78a5636f, 0x43172f60, 0x84c87814, 0xa1f0ab72, 0x8cc70208, 0x1a6439ec, 0x90befffa, 0x23631e28, 0xa4506ceb, 0xde82bde9, 0xbef9a3f7, 0xb2c67915, 0xc67178f2, 0xe372532b, 0xca273ece, 0xea26619c, 0xd186b8c7, 0x21c0c207, 0xeada7dd6, 0xcde0eb1e, 0xf57d4f7f, 0xee6ed178, 0x06f067aa, 0x72176fba, 0x0a637dc5, 0xa2c898a6, 0x113f9804, 0xbef90dae, 0x1b710b35, 0x131c471b, 0x28db77f5, 0x23047d84, 0x32caab7b, 0x40c72493, 0x3c9ebe0a, 0x15c9bebc, 0x431d67c4, 0x9c100d4c, 0x4cc5d4be, 0xcb3e42b6, 0x597f299c, 0xfc657e2a, 0x5fcb6fab, 0x3ad6faec, 0x6c44198c, 0x4a475817];

function SHA512() {
  if (!(this instanceof SHA512)) return new SHA512();
  BlockHash.call(this);
  this.h = [0x6a09e667, 0xf3bcc908, 0xbb67ae85, 0x84caa73b, 0x3c6ef372, 0xfe94f82b, 0xa54ff53a, 0x5f1d36f1, 0x510e527f, 0xade682d1, 0x9b05688c, 0x2b3e6c1f, 0x1f83d9ab, 0xfb41bd6b, 0x5be0cd19, 0x137e2179];
  this.k = sha512_K;
  this.W = new Array(160);
}

utils.inherits(SHA512, BlockHash);
module.exports = SHA512;
SHA512.blockSize = 1024;
SHA512.outSize = 512;
SHA512.hmacStrength = 192;
SHA512.padLength = 128;

SHA512.prototype._prepareBlock = function _prepareBlock(msg, start) {
  var W = this.W; // 32 x 32bit words

  for (var i = 0; i < 32; i++) {
    W[i] = msg[start + i];
  }

  for (; i < W.length; i += 2) {
    var c0_hi = g1_512_hi(W[i - 4], W[i - 3]); // i - 2

    var c0_lo = g1_512_lo(W[i - 4], W[i - 3]);
    var c1_hi = W[i - 14]; // i - 7

    var c1_lo = W[i - 13];
    var c2_hi = g0_512_hi(W[i - 30], W[i - 29]); // i - 15

    var c2_lo = g0_512_lo(W[i - 30], W[i - 29]);
    var c3_hi = W[i - 32]; // i - 16

    var c3_lo = W[i - 31];
    W[i] = sum64_4_hi(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo);
    W[i + 1] = sum64_4_lo(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo);
  }
};

SHA512.prototype._update = function _update(msg, start) {
  this._prepareBlock(msg, start);

  var W = this.W;
  var ah = this.h[0];
  var al = this.h[1];
  var bh = this.h[2];
  var bl = this.h[3];
  var ch = this.h[4];
  var cl = this.h[5];
  var dh = this.h[6];
  var dl = this.h[7];
  var eh = this.h[8];
  var el = this.h[9];
  var fh = this.h[10];
  var fl = this.h[11];
  var gh = this.h[12];
  var gl = this.h[13];
  var hh = this.h[14];
  var hl = this.h[15];
  assert(this.k.length === W.length);

  for (var i = 0; i < W.length; i += 2) {
    var c0_hi = hh;
    var c0_lo = hl;
    var c1_hi = s1_512_hi(eh, el);
    var c1_lo = s1_512_lo(eh, el);
    var c2_hi = ch64_hi(eh, el, fh, fl, gh, gl);
    var c2_lo = ch64_lo(eh, el, fh, fl, gh, gl);
    var c3_hi = this.k[i];
    var c3_lo = this.k[i + 1];
    var c4_hi = W[i];
    var c4_lo = W[i + 1];
    var T1_hi = sum64_5_hi(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo, c4_hi, c4_lo);
    var T1_lo = sum64_5_lo(c0_hi, c0_lo, c1_hi, c1_lo, c2_hi, c2_lo, c3_hi, c3_lo, c4_hi, c4_lo);
    c0_hi = s0_512_hi(ah, al);
    c0_lo = s0_512_lo(ah, al);
    c1_hi = maj64_hi(ah, al, bh, bl, ch, cl);
    c1_lo = maj64_lo(ah, al, bh, bl, ch, cl);
    var T2_hi = sum64_hi(c0_hi, c0_lo, c1_hi, c1_lo);
    var T2_lo = sum64_lo(c0_hi, c0_lo, c1_hi, c1_lo);
    hh = gh;
    hl = gl;
    gh = fh;
    gl = fl;
    fh = eh;
    fl = el;
    eh = sum64_hi(dh, dl, T1_hi, T1_lo);
    el = sum64_lo(dl, dl, T1_hi, T1_lo);
    dh = ch;
    dl = cl;
    ch = bh;
    cl = bl;
    bh = ah;
    bl = al;
    ah = sum64_hi(T1_hi, T1_lo, T2_hi, T2_lo);
    al = sum64_lo(T1_hi, T1_lo, T2_hi, T2_lo);
  }

  sum64(this.h, 0, ah, al);
  sum64(this.h, 2, bh, bl);
  sum64(this.h, 4, ch, cl);
  sum64(this.h, 6, dh, dl);
  sum64(this.h, 8, eh, el);
  sum64(this.h, 10, fh, fl);
  sum64(this.h, 12, gh, gl);
  sum64(this.h, 14, hh, hl);
};

SHA512.prototype._digest = function digest(enc) {
  if (enc === 'hex') return utils.toHex32(this.h, 'big');else return utils.split32(this.h, 'big');
};

function ch64_hi(xh, xl, yh, yl, zh) {
  var r = xh & yh ^ ~xh & zh;
  if (r < 0) r += 0x100000000;
  return r;
}

function ch64_lo(xh, xl, yh, yl, zh, zl) {
  var r = xl & yl ^ ~xl & zl;
  if (r < 0) r += 0x100000000;
  return r;
}

function maj64_hi(xh, xl, yh, yl, zh) {
  var r = xh & yh ^ xh & zh ^ yh & zh;
  if (r < 0) r += 0x100000000;
  return r;
}

function maj64_lo(xh, xl, yh, yl, zh, zl) {
  var r = xl & yl ^ xl & zl ^ yl & zl;
  if (r < 0) r += 0x100000000;
  return r;
}

function s0_512_hi(xh, xl) {
  var c0_hi = rotr64_hi(xh, xl, 28);
  var c1_hi = rotr64_hi(xl, xh, 2); // 34

  var c2_hi = rotr64_hi(xl, xh, 7); // 39

  var r = c0_hi ^ c1_hi ^ c2_hi;
  if (r < 0) r += 0x100000000;
  return r;
}

function s0_512_lo(xh, xl) {
  var c0_lo = rotr64_lo(xh, xl, 28);
  var c1_lo = rotr64_lo(xl, xh, 2); // 34

  var c2_lo = rotr64_lo(xl, xh, 7); // 39

  var r = c0_lo ^ c1_lo ^ c2_lo;
  if (r < 0) r += 0x100000000;
  return r;
}

function s1_512_hi(xh, xl) {
  var c0_hi = rotr64_hi(xh, xl, 14);
  var c1_hi = rotr64_hi(xh, xl, 18);
  var c2_hi = rotr64_hi(xl, xh, 9); // 41

  var r = c0_hi ^ c1_hi ^ c2_hi;
  if (r < 0) r += 0x100000000;
  return r;
}

function s1_512_lo(xh, xl) {
  var c0_lo = rotr64_lo(xh, xl, 14);
  var c1_lo = rotr64_lo(xh, xl, 18);
  var c2_lo = rotr64_lo(xl, xh, 9); // 41

  var r = c0_lo ^ c1_lo ^ c2_lo;
  if (r < 0) r += 0x100000000;
  return r;
}

function g0_512_hi(xh, xl) {
  var c0_hi = rotr64_hi(xh, xl, 1);
  var c1_hi = rotr64_hi(xh, xl, 8);
  var c2_hi = shr64_hi(xh, xl, 7);
  var r = c0_hi ^ c1_hi ^ c2_hi;
  if (r < 0) r += 0x100000000;
  return r;
}

function g0_512_lo(xh, xl) {
  var c0_lo = rotr64_lo(xh, xl, 1);
  var c1_lo = rotr64_lo(xh, xl, 8);
  var c2_lo = shr64_lo(xh, xl, 7);
  var r = c0_lo ^ c1_lo ^ c2_lo;
  if (r < 0) r += 0x100000000;
  return r;
}

function g1_512_hi(xh, xl) {
  var c0_hi = rotr64_hi(xh, xl, 19);
  var c1_hi = rotr64_hi(xl, xh, 29); // 61

  var c2_hi = shr64_hi(xh, xl, 6);
  var r = c0_hi ^ c1_hi ^ c2_hi;
  if (r < 0) r += 0x100000000;
  return r;
}

function g1_512_lo(xh, xl) {
  var c0_lo = rotr64_lo(xh, xl, 19);
  var c1_lo = rotr64_lo(xl, xh, 29); // 61

  var c2_lo = shr64_lo(xh, xl, 6);
  var r = c0_lo ^ c1_lo ^ c2_lo;
  if (r < 0) r += 0x100000000;
  return r;
}

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/sha/common.js":
/*!*****************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/sha/common.js ***!
  \*****************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";


var utils = __webpack_require__(/*! ../utils */ "./node_modules/hash.js/lib/hash/utils.js");

var rotr32 = utils.rotr32;

function ft_1(s, x, y, z) {
  if (s === 0) return ch32(x, y, z);
  if (s === 1 || s === 3) return p32(x, y, z);
  if (s === 2) return maj32(x, y, z);
}

exports.ft_1 = ft_1;

function ch32(x, y, z) {
  return x & y ^ ~x & z;
}

exports.ch32 = ch32;

function maj32(x, y, z) {
  return x & y ^ x & z ^ y & z;
}

exports.maj32 = maj32;

function p32(x, y, z) {
  return x ^ y ^ z;
}

exports.p32 = p32;

function s0_256(x) {
  return rotr32(x, 2) ^ rotr32(x, 13) ^ rotr32(x, 22);
}

exports.s0_256 = s0_256;

function s1_256(x) {
  return rotr32(x, 6) ^ rotr32(x, 11) ^ rotr32(x, 25);
}

exports.s1_256 = s1_256;

function g0_256(x) {
  return rotr32(x, 7) ^ rotr32(x, 18) ^ x >>> 3;
}

exports.g0_256 = g0_256;

function g1_256(x) {
  return rotr32(x, 17) ^ rotr32(x, 19) ^ x >>> 10;
}

exports.g1_256 = g1_256;

/***/ }),

/***/ "./node_modules/hash.js/lib/hash/utils.js":
/*!************************************************!*\
  !*** ./node_modules/hash.js/lib/hash/utils.js ***!
  \************************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";


var assert = __webpack_require__(/*! minimalistic-assert */ "./node_modules/minimalistic-assert/index.js");

var inherits = __webpack_require__(/*! inherits */ "./node_modules/inherits/inherits_browser.js");

exports.inherits = inherits;

function isSurrogatePair(msg, i) {
  if ((msg.charCodeAt(i) & 0xFC00) !== 0xD800) {
    return false;
  }

  if (i < 0 || i + 1 >= msg.length) {
    return false;
  }

  return (msg.charCodeAt(i + 1) & 0xFC00) === 0xDC00;
}

function toArray(msg, enc) {
  if (Array.isArray(msg)) return msg.slice();
  if (!msg) return [];
  var res = [];

  if (typeof msg === 'string') {
    if (!enc) {
      // Inspired by stringToUtf8ByteArray() in closure-library by Google
      // https://github.com/google/closure-library/blob/8598d87242af59aac233270742c8984e2b2bdbe0/closure/goog/crypt/crypt.js#L117-L143
      // Apache License 2.0
      // https://github.com/google/closure-library/blob/master/LICENSE
      var p = 0;

      for (var i = 0; i < msg.length; i++) {
        var c = msg.charCodeAt(i);

        if (c < 128) {
          res[p++] = c;
        } else if (c < 2048) {
          res[p++] = c >> 6 | 192;
          res[p++] = c & 63 | 128;
        } else if (isSurrogatePair(msg, i)) {
          c = 0x10000 + ((c & 0x03FF) << 10) + (msg.charCodeAt(++i) & 0x03FF);
          res[p++] = c >> 18 | 240;
          res[p++] = c >> 12 & 63 | 128;
          res[p++] = c >> 6 & 63 | 128;
          res[p++] = c & 63 | 128;
        } else {
          res[p++] = c >> 12 | 224;
          res[p++] = c >> 6 & 63 | 128;
          res[p++] = c & 63 | 128;
        }
      }
    } else if (enc === 'hex') {
      msg = msg.replace(/[^a-z0-9]+/ig, '');
      if (msg.length % 2 !== 0) msg = '0' + msg;

      for (i = 0; i < msg.length; i += 2) {
        res.push(parseInt(msg[i] + msg[i + 1], 16));
      }
    }
  } else {
    for (i = 0; i < msg.length; i++) {
      res[i] = msg[i] | 0;
    }
  }

  return res;
}

exports.toArray = toArray;

function toHex(msg) {
  var res = '';

  for (var i = 0; i < msg.length; i++) {
    res += zero2(msg[i].toString(16));
  }

  return res;
}

exports.toHex = toHex;

function htonl(w) {
  var res = w >>> 24 | w >>> 8 & 0xff00 | w << 8 & 0xff0000 | (w & 0xff) << 24;
  return res >>> 0;
}

exports.htonl = htonl;

function toHex32(msg, endian) {
  var res = '';

  for (var i = 0; i < msg.length; i++) {
    var w = msg[i];
    if (endian === 'little') w = htonl(w);
    res += zero8(w.toString(16));
  }

  return res;
}

exports.toHex32 = toHex32;

function zero2(word) {
  if (word.length === 1) return '0' + word;else return word;
}

exports.zero2 = zero2;

function zero8(word) {
  if (word.length === 7) return '0' + word;else if (word.length === 6) return '00' + word;else if (word.length === 5) return '000' + word;else if (word.length === 4) return '0000' + word;else if (word.length === 3) return '00000' + word;else if (word.length === 2) return '000000' + word;else if (word.length === 1) return '0000000' + word;else return word;
}

exports.zero8 = zero8;

function join32(msg, start, end, endian) {
  var len = end - start;
  assert(len % 4 === 0);
  var res = new Array(len / 4);

  for (var i = 0, k = start; i < res.length; i++, k += 4) {
    var w;
    if (endian === 'big') w = msg[k] << 24 | msg[k + 1] << 16 | msg[k + 2] << 8 | msg[k + 3];else w = msg[k + 3] << 24 | msg[k + 2] << 16 | msg[k + 1] << 8 | msg[k];
    res[i] = w >>> 0;
  }

  return res;
}

exports.join32 = join32;

function split32(msg, endian) {
  var res = new Array(msg.length * 4);

  for (var i = 0, k = 0; i < msg.length; i++, k += 4) {
    var m = msg[i];

    if (endian === 'big') {
      res[k] = m >>> 24;
      res[k + 1] = m >>> 16 & 0xff;
      res[k + 2] = m >>> 8 & 0xff;
      res[k + 3] = m & 0xff;
    } else {
      res[k + 3] = m >>> 24;
      res[k + 2] = m >>> 16 & 0xff;
      res[k + 1] = m >>> 8 & 0xff;
      res[k] = m & 0xff;
    }
  }

  return res;
}

exports.split32 = split32;

function rotr32(w, b) {
  return w >>> b | w << 32 - b;
}

exports.rotr32 = rotr32;

function rotl32(w, b) {
  return w << b | w >>> 32 - b;
}

exports.rotl32 = rotl32;

function sum32(a, b) {
  return a + b >>> 0;
}

exports.sum32 = sum32;

function sum32_3(a, b, c) {
  return a + b + c >>> 0;
}

exports.sum32_3 = sum32_3;

function sum32_4(a, b, c, d) {
  return a + b + c + d >>> 0;
}

exports.sum32_4 = sum32_4;

function sum32_5(a, b, c, d, e) {
  return a + b + c + d + e >>> 0;
}

exports.sum32_5 = sum32_5;

function sum64(buf, pos, ah, al) {
  var bh = buf[pos];
  var bl = buf[pos + 1];
  var lo = al + bl >>> 0;
  var hi = (lo < al ? 1 : 0) + ah + bh;
  buf[pos] = hi >>> 0;
  buf[pos + 1] = lo;
}

exports.sum64 = sum64;

function sum64_hi(ah, al, bh, bl) {
  var lo = al + bl >>> 0;
  var hi = (lo < al ? 1 : 0) + ah + bh;
  return hi >>> 0;
}

exports.sum64_hi = sum64_hi;

function sum64_lo(ah, al, bh, bl) {
  var lo = al + bl;
  return lo >>> 0;
}

exports.sum64_lo = sum64_lo;

function sum64_4_hi(ah, al, bh, bl, ch, cl, dh, dl) {
  var carry = 0;
  var lo = al;
  lo = lo + bl >>> 0;
  carry += lo < al ? 1 : 0;
  lo = lo + cl >>> 0;
  carry += lo < cl ? 1 : 0;
  lo = lo + dl >>> 0;
  carry += lo < dl ? 1 : 0;
  var hi = ah + bh + ch + dh + carry;
  return hi >>> 0;
}

exports.sum64_4_hi = sum64_4_hi;

function sum64_4_lo(ah, al, bh, bl, ch, cl, dh, dl) {
  var lo = al + bl + cl + dl;
  return lo >>> 0;
}

exports.sum64_4_lo = sum64_4_lo;

function sum64_5_hi(ah, al, bh, bl, ch, cl, dh, dl, eh, el) {
  var carry = 0;
  var lo = al;
  lo = lo + bl >>> 0;
  carry += lo < al ? 1 : 0;
  lo = lo + cl >>> 0;
  carry += lo < cl ? 1 : 0;
  lo = lo + dl >>> 0;
  carry += lo < dl ? 1 : 0;
  lo = lo + el >>> 0;
  carry += lo < el ? 1 : 0;
  var hi = ah + bh + ch + dh + eh + carry;
  return hi >>> 0;
}

exports.sum64_5_hi = sum64_5_hi;

function sum64_5_lo(ah, al, bh, bl, ch, cl, dh, dl, eh, el) {
  var lo = al + bl + cl + dl + el;
  return lo >>> 0;
}

exports.sum64_5_lo = sum64_5_lo;

function rotr64_hi(ah, al, num) {
  var r = al << 32 - num | ah >>> num;
  return r >>> 0;
}

exports.rotr64_hi = rotr64_hi;

function rotr64_lo(ah, al, num) {
  var r = ah << 32 - num | al >>> num;
  return r >>> 0;
}

exports.rotr64_lo = rotr64_lo;

function shr64_hi(ah, al, num) {
  return ah >>> num;
}

exports.shr64_hi = shr64_hi;

function shr64_lo(ah, al, num) {
  var r = ah << 32 - num | al >>> num;
  return r >>> 0;
}

exports.shr64_lo = shr64_lo;

/***/ }),

/***/ "./node_modules/inherits/inherits_browser.js":
/*!***************************************************!*\
  !*** ./node_modules/inherits/inherits_browser.js ***!
  \***************************************************/
/***/ (function(module) {

if (typeof Object.create === 'function') {
  // implementation from standard node.js 'util' module
  module.exports = function inherits(ctor, superCtor) {
    if (superCtor) {
      ctor.super_ = superCtor;
      ctor.prototype = Object.create(superCtor.prototype, {
        constructor: {
          value: ctor,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
    }
  };
} else {
  // old school shim for old browsers
  module.exports = function inherits(ctor, superCtor) {
    if (superCtor) {
      ctor.super_ = superCtor;

      var TempCtor = function TempCtor() {};

      TempCtor.prototype = superCtor.prototype;
      ctor.prototype = new TempCtor();
      ctor.prototype.constructor = ctor;
    }
  };
}

/***/ }),

/***/ "./node_modules/minimalistic-assert/index.js":
/*!***************************************************!*\
  !*** ./node_modules/minimalistic-assert/index.js ***!
  \***************************************************/
/***/ (function(module) {

module.exports = assert;

function assert(val, msg) {
  if (!val) throw new Error(msg || 'Assertion failed');
}

assert.equal = function assertEqual(l, r, msg) {
  if (l != r) throw new Error(msg || 'Assertion failed: ' + l + ' != ' + r);
};

/***/ }),

/***/ "./node_modules/regenerator-runtime/runtime.js":
/*!*****************************************************!*\
  !*** ./node_modules/regenerator-runtime/runtime.js ***!
  \*****************************************************/
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {

/* module decorator */ module = __webpack_require__.nmd(module);
function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var runtime = function (exports) {
  "use strict";

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined; // More compressible than void 0.

  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }

  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function define(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []); // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.

    generator._invoke = makeInvokeMethod(innerFn, self, context);
    return generator;
  }

  exports.wrap = wrap; // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed"; // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.

  var ContinueSentinel = {}; // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {} // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.


  var IteratorPrototype = {};

  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));

  if (NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"); // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function (genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor ? ctor === GeneratorFunction || // For the native GeneratorFunction constructor, the best we can
    // do is to check its .name property.
    (ctor.displayName || ctor.name) === "GeneratorFunction" : false;
  };

  exports.mark = function (genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }

    genFun.prototype = Object.create(Gp);
    return genFun;
  }; // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.


  exports.awrap = function (arg) {
    return {
      __await: arg
    };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;

        if (value && _typeof(value) === "object" && hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function (value) {
            invoke("next", value, resolve, reject);
          }, function (err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function (unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function (error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = // If enqueue has been called before, then we want to wait until
      // all previous Promises have been resolved before calling invoke,
      // so that results are always delivered in the correct order. If
      // enqueue has not been called before, then it is important to
      // call invoke immediately, without waiting on a callback to fire,
      // so that the async generator function has the opportunity to do
      // any necessary setup in a predictable way. This predictability
      // is why the Promise constructor synchronously invokes its
      // executor callback, and why async functions synchronously
      // execute code before the first await. Since we implement simple
      // async functions in terms of async generators, it is especially
      // important to get this right, even though it requires care.
      previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, // Avoid propagating failures to Promises returned by later
      // invocations of the iterator.
      callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    } // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).


    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);

  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };

  exports.AsyncIterator = AsyncIterator; // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.

  exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter // If outerFn is a generator, return the full iterator.
    : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;
    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        } // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume


        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;

        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);

          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;
        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);
        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;
        var record = tryCatch(innerFn, self, context);

        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done ? GenStateCompleted : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };
        } else if (record.type === "throw") {
          state = GenStateCompleted; // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.

          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  } // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.


  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (method === undefined) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (!info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value; // Resume execution at the desired location (see delegateYield).

      context.next = delegate.nextLoc; // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.

      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined;
      }
    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    } // The delegate iterator is finished, so forget it and continue with
    // the outer generator.


    context.delegate = null;
    return ContinueSentinel;
  } // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.


  defineIteratorMethods(Gp);
  define(Gp, toStringTagSymbol, "Generator"); // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.

  Gp[iteratorSymbol] = function () {
    return this;
  };

  Gp.toString = function () {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{
      tryLoc: "root"
    }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function (object) {
    var keys = [];

    for (var key in object) {
      keys.push(key);
    }

    keys.reverse(); // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.

    return function next() {
      while (keys.length) {
        var key = keys.pop();

        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      } // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.


      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];

      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined;
          next.done = true;
          return next;
        };

        return next.next = next;
      }
    } // Return an iterator with no values.


    return {
      next: doneResult
    };
  }

  exports.values = values;

  function doneResult() {
    return {
      value: undefined,
      done: true
    };
  }

  Context.prototype = {
    constructor: Context,
    reset: function reset(skipTempReset) {
      this.prev = 0;
      this.next = 0; // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.

      this.sent = this._sent = undefined;
      this.done = false;
      this.delegate = null;
      this.method = "next";
      this.arg = undefined;
      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" && hasOwn.call(this, name) && !isNaN(+name.slice(1))) {
            this[name] = undefined;
          }
        }
      }
    },
    stop: function stop() {
      this.done = true;
      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;

      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },
    dispatchException: function dispatchException(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;

      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined;
        }

        return !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }
          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }
          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },
    abrupt: function abrupt(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry && (type === "break" || type === "continue") && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },
    complete: function complete(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" || record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },
    finish: function finish(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },
    "catch": function _catch(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      } // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.


      throw new Error("illegal catch attempt");
    },
    delegateYield: function delegateYield(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined;
      }

      return ContinueSentinel;
    }
  }; // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.

  return exports;
}( // If this script is executing as a CommonJS module, use module.exports
// as the regeneratorRuntime namespace. Otherwise create a new empty
// object. Either way, the resulting object will be used to initialize
// the regeneratorRuntime variable at the top of this file.
( false ? 0 : _typeof(module)) === "object" ? module.exports : {});

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}

/***/ }),

/***/ "./node_modules/rfc4648/lib/index.js":
/*!*******************************************!*\
  !*** ./node_modules/rfc4648/lib/index.js ***!
  \*******************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "base16": function() { return /* binding */ base16; },
/* harmony export */   "base32": function() { return /* binding */ base32; },
/* harmony export */   "base32hex": function() { return /* binding */ base32hex; },
/* harmony export */   "base64": function() { return /* binding */ base64; },
/* harmony export */   "base64url": function() { return /* binding */ base64url; },
/* harmony export */   "codec": function() { return /* binding */ codec; }
/* harmony export */ });
/* eslint-disable @typescript-eslint/strict-boolean-expressions */
function parse(string, encoding, opts) {
  if (opts === void 0) {
    opts = {};
  } // Build the character lookup table:


  if (!encoding.codes) {
    encoding.codes = {};

    for (var i = 0; i < encoding.chars.length; ++i) {
      encoding.codes[encoding.chars[i]] = i;
    }
  } // The string must have a whole number of bytes:


  if (!opts.loose && string.length * encoding.bits & 7) {
    throw new SyntaxError('Invalid padding');
  } // Count the padding bytes:


  var end = string.length;

  while (string[end - 1] === '=') {
    --end; // If we get a whole number of bytes, there is too much padding:

    if (!opts.loose && !((string.length - end) * encoding.bits & 7)) {
      throw new SyntaxError('Invalid padding');
    }
  } // Allocate the output:


  var out = new (opts.out || Uint8Array)(end * encoding.bits / 8 | 0); // Parse the data:

  var bits = 0; // Number of bits currently in the buffer

  var buffer = 0; // Bits waiting to be written out, MSB first

  var written = 0; // Next byte to write

  for (var _i = 0; _i < end; ++_i) {
    // Read one character from the string:
    var value = encoding.codes[string[_i]];

    if (value === undefined) {
      throw new SyntaxError('Invalid character ' + string[_i]);
    } // Append the bits to the buffer:


    buffer = buffer << encoding.bits | value;
    bits += encoding.bits; // Write out some bits if the buffer has a byte's worth:

    if (bits >= 8) {
      bits -= 8;
      out[written++] = 0xff & buffer >> bits;
    }
  } // Verify that we have received just enough bits:


  if (bits >= encoding.bits || 0xff & buffer << 8 - bits) {
    throw new SyntaxError('Unexpected end of data');
  }

  return out;
}

function stringify(data, encoding, opts) {
  if (opts === void 0) {
    opts = {};
  }

  var _opts = opts,
      _opts$pad = _opts.pad,
      pad = _opts$pad === void 0 ? true : _opts$pad;
  var mask = (1 << encoding.bits) - 1;
  var out = '';
  var bits = 0; // Number of bits currently in the buffer

  var buffer = 0; // Bits waiting to be written out, MSB first

  for (var i = 0; i < data.length; ++i) {
    // Slurp data into the buffer:
    buffer = buffer << 8 | 0xff & data[i];
    bits += 8; // Write out as much as we can:

    while (bits > encoding.bits) {
      bits -= encoding.bits;
      out += encoding.chars[mask & buffer >> bits];
    }
  } // Partial character:


  if (bits) {
    out += encoding.chars[mask & buffer << encoding.bits - bits];
  } // Add padding characters until we hit a byte boundary:


  if (pad) {
    while (out.length * encoding.bits & 7) {
      out += '=';
    }
  }

  return out;
}
/* eslint-disable @typescript-eslint/strict-boolean-expressions */


var base16Encoding = {
  chars: '0123456789ABCDEF',
  bits: 4
};
var base32Encoding = {
  chars: 'ABCDEFGHIJKLMNOPQRSTUVWXYZ234567',
  bits: 5
};
var base32HexEncoding = {
  chars: '0123456789ABCDEFGHIJKLMNOPQRSTUV',
  bits: 5
};
var base64Encoding = {
  chars: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/',
  bits: 6
};
var base64UrlEncoding = {
  chars: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_',
  bits: 6
};
var base16 = {
  parse: function parse$1(string, opts) {
    return parse(string.toUpperCase(), base16Encoding, opts);
  },
  stringify: function stringify$1(data, opts) {
    return stringify(data, base16Encoding, opts);
  }
};
var base32 = {
  parse: function parse$1(string, opts) {
    if (opts === void 0) {
      opts = {};
    }

    return parse(opts.loose ? string.toUpperCase().replace(/0/g, 'O').replace(/1/g, 'L').replace(/8/g, 'B') : string, base32Encoding, opts);
  },
  stringify: function stringify$1(data, opts) {
    return stringify(data, base32Encoding, opts);
  }
};
var base32hex = {
  parse: function parse$1(string, opts) {
    return parse(string, base32HexEncoding, opts);
  },
  stringify: function stringify$1(data, opts) {
    return stringify(data, base32HexEncoding, opts);
  }
};
var base64 = {
  parse: function parse$1(string, opts) {
    return parse(string, base64Encoding, opts);
  },
  stringify: function stringify$1(data, opts) {
    return stringify(data, base64Encoding, opts);
  }
};
var base64url = {
  parse: function parse$1(string, opts) {
    return parse(string, base64UrlEncoding, opts);
  },
  stringify: function stringify$1(data, opts) {
    return stringify(data, base64UrlEncoding, opts);
  }
};
var codec = {
  parse: parse,
  stringify: stringify
};


/***/ }),

/***/ "./node_modules/utf8/utf8.js":
/*!***********************************!*\
  !*** ./node_modules/utf8/utf8.js ***!
  \***********************************/
/***/ (function(__unused_webpack_module, exports) {

/*! https://mths.be/utf8js v3.0.0 by @mathias */
;

(function (root) {
  var stringFromCharCode = String.fromCharCode; // Taken from https://mths.be/punycode

  function ucs2decode(string) {
    var output = [];
    var counter = 0;
    var length = string.length;
    var value;
    var extra;

    while (counter < length) {
      value = string.charCodeAt(counter++);

      if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
        // high surrogate, and there is a next character
        extra = string.charCodeAt(counter++);

        if ((extra & 0xFC00) == 0xDC00) {
          // low surrogate
          output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
        } else {
          // unmatched surrogate; only append this code unit, in case the next
          // code unit is the high surrogate of a surrogate pair
          output.push(value);
          counter--;
        }
      } else {
        output.push(value);
      }
    }

    return output;
  } // Taken from https://mths.be/punycode


  function ucs2encode(array) {
    var length = array.length;
    var index = -1;
    var value;
    var output = '';

    while (++index < length) {
      value = array[index];

      if (value > 0xFFFF) {
        value -= 0x10000;
        output += stringFromCharCode(value >>> 10 & 0x3FF | 0xD800);
        value = 0xDC00 | value & 0x3FF;
      }

      output += stringFromCharCode(value);
    }

    return output;
  }

  function checkScalarValue(codePoint) {
    if (codePoint >= 0xD800 && codePoint <= 0xDFFF) {
      throw Error('Lone surrogate U+' + codePoint.toString(16).toUpperCase() + ' is not a scalar value');
    }
  }
  /*--------------------------------------------------------------------------*/


  function createByte(codePoint, shift) {
    return stringFromCharCode(codePoint >> shift & 0x3F | 0x80);
  }

  function encodeCodePoint(codePoint) {
    if ((codePoint & 0xFFFFFF80) == 0) {
      // 1-byte sequence
      return stringFromCharCode(codePoint);
    }

    var symbol = '';

    if ((codePoint & 0xFFFFF800) == 0) {
      // 2-byte sequence
      symbol = stringFromCharCode(codePoint >> 6 & 0x1F | 0xC0);
    } else if ((codePoint & 0xFFFF0000) == 0) {
      // 3-byte sequence
      checkScalarValue(codePoint);
      symbol = stringFromCharCode(codePoint >> 12 & 0x0F | 0xE0);
      symbol += createByte(codePoint, 6);
    } else if ((codePoint & 0xFFE00000) == 0) {
      // 4-byte sequence
      symbol = stringFromCharCode(codePoint >> 18 & 0x07 | 0xF0);
      symbol += createByte(codePoint, 12);
      symbol += createByte(codePoint, 6);
    }

    symbol += stringFromCharCode(codePoint & 0x3F | 0x80);
    return symbol;
  }

  function utf8encode(string) {
    var codePoints = ucs2decode(string);
    var length = codePoints.length;
    var index = -1;
    var codePoint;
    var byteString = '';

    while (++index < length) {
      codePoint = codePoints[index];
      byteString += encodeCodePoint(codePoint);
    }

    return byteString;
  }
  /*--------------------------------------------------------------------------*/


  function readContinuationByte() {
    if (byteIndex >= byteCount) {
      throw Error('Invalid byte index');
    }

    var continuationByte = byteArray[byteIndex] & 0xFF;
    byteIndex++;

    if ((continuationByte & 0xC0) == 0x80) {
      return continuationByte & 0x3F;
    } // If we end up here, it’s not a continuation byte


    throw Error('Invalid continuation byte');
  }

  function decodeSymbol() {
    var byte1;
    var byte2;
    var byte3;
    var byte4;
    var codePoint;

    if (byteIndex > byteCount) {
      throw Error('Invalid byte index');
    }

    if (byteIndex == byteCount) {
      return false;
    } // Read first byte


    byte1 = byteArray[byteIndex] & 0xFF;
    byteIndex++; // 1-byte sequence (no continuation bytes)

    if ((byte1 & 0x80) == 0) {
      return byte1;
    } // 2-byte sequence


    if ((byte1 & 0xE0) == 0xC0) {
      byte2 = readContinuationByte();
      codePoint = (byte1 & 0x1F) << 6 | byte2;

      if (codePoint >= 0x80) {
        return codePoint;
      } else {
        throw Error('Invalid continuation byte');
      }
    } // 3-byte sequence (may include unpaired surrogates)


    if ((byte1 & 0xF0) == 0xE0) {
      byte2 = readContinuationByte();
      byte3 = readContinuationByte();
      codePoint = (byte1 & 0x0F) << 12 | byte2 << 6 | byte3;

      if (codePoint >= 0x0800) {
        checkScalarValue(codePoint);
        return codePoint;
      } else {
        throw Error('Invalid continuation byte');
      }
    } // 4-byte sequence


    if ((byte1 & 0xF8) == 0xF0) {
      byte2 = readContinuationByte();
      byte3 = readContinuationByte();
      byte4 = readContinuationByte();
      codePoint = (byte1 & 0x07) << 0x12 | byte2 << 0x0C | byte3 << 0x06 | byte4;

      if (codePoint >= 0x010000 && codePoint <= 0x10FFFF) {
        return codePoint;
      }
    }

    throw Error('Invalid UTF-8 detected');
  }

  var byteArray;
  var byteCount;
  var byteIndex;

  function utf8decode(byteString) {
    byteArray = ucs2decode(byteString);
    byteCount = byteArray.length;
    byteIndex = 0;
    var codePoints = [];
    var tmp;

    while ((tmp = decodeSymbol()) !== false) {
      codePoints.push(tmp);
    }

    return ucs2encode(codePoints);
  }
  /*--------------------------------------------------------------------------*/


  root.version = '3.0.0';
  root.encode = utf8encode;
  root.decode = utf8decode;
})( false ? 0 : exports);

/***/ }),

/***/ "./src/index.js":
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _rate_bitmax_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./rate/bitmax.js */ "./src/rate/bitmax.js");
/* harmony import */ var _rate_coinbase_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./rate/coinbase.js */ "./src/rate/coinbase.js");
/* harmony import */ var _rate_coincap_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./rate/coincap.js */ "./src/rate/coincap.js");
/* harmony import */ var _rate_coingecko_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./rate/coingecko.js */ "./src/rate/coingecko.js");
/* harmony import */ var _rate_coinmonitor_js__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./rate/coinmonitor.js */ "./src/rate/coinmonitor.js");
/* harmony import */ var _rate_compound_js__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./rate/compound.js */ "./src/rate/compound.js");
/* harmony import */ var _rate_constantRate_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./rate/constantRate.js */ "./src/rate/constantRate.js");
/* harmony import */ var _rate_currencyconverterapi_js__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./rate/currencyconverterapi.js */ "./src/rate/currencyconverterapi.js");
/* harmony import */ var _rate_edgeRates_js__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./rate/edgeRates.js */ "./src/rate/edgeRates.js");
/* harmony import */ var _rate_nomics_js__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./rate/nomics.js */ "./src/rate/nomics.js");
/* harmony import */ var _rate_wazirx__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./rate/wazirx */ "./src/rate/wazirx.js");
/* harmony import */ var _swap_changelly_js__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./swap/changelly.js */ "./src/swap/changelly.js");
/* harmony import */ var _swap_changenow_js__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./swap/changenow.js */ "./src/swap/changenow.js");
/* harmony import */ var _swap_exolix_js__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./swap/exolix.js */ "./src/swap/exolix.js");
/* harmony import */ var _swap_foxExchange_js__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./swap/foxExchange.js */ "./src/swap/foxExchange.js");
/* harmony import */ var _swap_godex_js__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./swap/godex.js */ "./src/swap/godex.js");
/* harmony import */ var _swap_sideshift_js__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./swap/sideshift.js */ "./src/swap/sideshift.js");
/* harmony import */ var _swap_switchain_js__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./swap/switchain.js */ "./src/swap/switchain.js");
/* harmony import */ var _swap_transfer_js__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./swap/transfer.js */ "./src/swap/transfer.js");



















var edgeCorePlugins = {
  // Rate plugins:
  bitmax: _rate_bitmax_js__WEBPACK_IMPORTED_MODULE_0__.makeBitMaxPlugin,
  coinbase: _rate_coinbase_js__WEBPACK_IMPORTED_MODULE_1__.makeCoinbasePlugin,
  coincap: _rate_coincap_js__WEBPACK_IMPORTED_MODULE_2__.makeCoincapPlugin,
  coingecko: _rate_coingecko_js__WEBPACK_IMPORTED_MODULE_3__.makeCoinGeckoPlugin,
  coinmonitor: _rate_coinmonitor_js__WEBPACK_IMPORTED_MODULE_4__.makeCoinmonitorPlugin,
  compound: _rate_compound_js__WEBPACK_IMPORTED_MODULE_5__.makeCompoundPlugin,
  constantRate: _rate_constantRate_js__WEBPACK_IMPORTED_MODULE_6__.makeConstantRatePlugin,
  currencyconverterapi: _rate_currencyconverterapi_js__WEBPACK_IMPORTED_MODULE_7__.makeCurrencyconverterapiPlugin,
  edgeRates: _rate_edgeRates_js__WEBPACK_IMPORTED_MODULE_8__.makeEdgeRatesPlugin,
  nomics: _rate_nomics_js__WEBPACK_IMPORTED_MODULE_9__.makeNomicsPlugin,
  wazirx: _rate_wazirx__WEBPACK_IMPORTED_MODULE_10__.makeWazirxPlugin,
  // Swap plugins:
  changelly: _swap_changelly_js__WEBPACK_IMPORTED_MODULE_11__.makeChangellyPlugin,
  changenow: _swap_changenow_js__WEBPACK_IMPORTED_MODULE_12__.makeChangeNowPlugin,
  exolix: _swap_exolix_js__WEBPACK_IMPORTED_MODULE_13__.makeExolixPlugin,
  foxExchange: _swap_foxExchange_js__WEBPACK_IMPORTED_MODULE_14__.makeFoxExchangePlugin,
  godex: _swap_godex_js__WEBPACK_IMPORTED_MODULE_15__.makeGodexPlugin,
  sideshift: _swap_sideshift_js__WEBPACK_IMPORTED_MODULE_16__.makeSideshiftPlugin,
  switchain: _swap_switchain_js__WEBPACK_IMPORTED_MODULE_17__.makeSwitchainPlugin,
  transfer: _swap_transfer_js__WEBPACK_IMPORTED_MODULE_18__.makeTransferPlugin
};

if (typeof window !== 'undefined' && typeof window.addEdgeCorePlugins === 'function') {
  window.addEdgeCorePlugins(edgeCorePlugins);
}

/* harmony default export */ __webpack_exports__["default"] = (edgeCorePlugins);

/***/ }),

/***/ "./src/rate/bitmax.js":
/*!****************************!*\
  !*** ./src/rate/bitmax.js ***!
  \****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeBitMaxPlugin": function() { return /* binding */ makeBitMaxPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asBitMaxTickerResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  data: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
    close: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
  })
});
function makeBitMaxPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;
  return {
    rateInfo: {
      pluginId: 'bitmax',
      displayName: 'BitMax'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _i2, pair, response, json, rate;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _i2 = 0;

              case 1:
                if (!(_i2 < pairsHint.length)) {
                  _context.next = 25;
                  break;
                }

                pair = pairsHint[_i2];

                if (!(pair.fromCurrency !== 'FIO')) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt("continue", 22);

              case 5:
                _context.prev = 5;
                _context.next = 8;
                return fetchCors('https://ascendex.com/api/pro/v1/ticker?symbol=FIO/USDT');

              case 8:
                response = _context.sent;
                _context.next = 11;
                return response.json();

              case 11:
                json = _context.sent;

                if (!(!response.ok || json.reason === 'DATA_NOT_AVAILABLE')) {
                  _context.next = 14;
                  break;
                }

                return _context.abrupt("break", 25);

              case 14:
                rate = Number(asBitMaxTickerResponse(json).data.close);
                return _context.abrupt("return", [{
                  fromCurrency: 'FIO',
                  toCurrency: 'USDT',
                  rate: rate
                }]);

              case 18:
                _context.prev = 18;
                _context.t0 = _context["catch"](5);
                log.warn("Issue with Bitmax rate data structure ".concat(_context.t0));
                return _context.abrupt("break", 25);

              case 22:
                _i2++;
                _context.next = 1;
                break;

              case 25:
                return _context.abrupt("return", []);

              case 26:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[5, 18]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/coinbase.js":
/*!******************************!*\
  !*** ./src/rate/coinbase.js ***!
  \******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCoinbasePlugin": function() { return /* binding */ makeCoinbasePlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asCoinbaseResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  data: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
    rates: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asMap)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asString)
  })
});
function makeCoinbasePlugin(opts) {
  var io = opts.io,
      log = opts.log;
  return {
    rateInfo: {
      pluginId: 'coinbase',
      displayName: 'Coinbase'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, reply, json, cleanJson, _i2, pair, cc, rate;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = [];
                _context.prev = 1;
                _context.next = 4;
                return io.fetch('https://api.coinbase.com/v2/exchange-rates');

              case 4:
                reply = _context.sent;
                _context.next = 7;
                return reply.json();

              case 7:
                json = _context.sent;
                cleanJson = asCoinbaseResponse(json);
                _i2 = 0;

              case 10:
                if (!(_i2 < pairsHint.length)) {
                  _context.next = 20;
                  break;
                }

                pair = pairsHint[_i2];
                cc = pair.fromCurrency;

                if (cleanJson.data.rates[cc]) {
                  _context.next = 15;
                  break;
                }

                return _context.abrupt("continue", 17);

              case 15:
                rate = Number(cleanJson.data.rates[cc]);
                pairs.push({
                  fromCurrency: 'iso:USD',
                  toCurrency: cc,
                  rate: rate
                });

              case 17:
                _i2++;
                _context.next = 10;
                break;

              case 20:
                _context.next = 25;
                break;

              case 22:
                _context.prev = 22;
                _context.t0 = _context["catch"](1);
                log.warn("Issue with Coinbase rate data structure ".concat(_context.t0));

              case 25:
                return _context.abrupt("return", pairs);

              case 26:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[1, 22]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/coincap.js":
/*!*****************************!*\
  !*** ./src/rate/coincap.js ***!
  \*****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCoincapPlugin": function() { return /* binding */ makeCoincapPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asCoincapResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  data: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asArray)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
    symbol: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
    priceUsd: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
  }))
});
var asCoincapError = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  error: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asString),
  timestamp: cleaners__WEBPACK_IMPORTED_MODULE_0__.asNumber
});
var asCoincapAssets = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asArray)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  id: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  symbol: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}));
var currencyMap = {};
function makeCoincapPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var fetch = io.fetchCors || io.fetch;
  return {
    rateInfo: {
      pluginId: 'coincap',
      displayName: 'Coincap'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, assets, assetsJson, assetIds, queryStrings, filteredPairs, _loop, i, _ret, _i2, query, reply, json, _asCoincapError, error;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = []; // Create unique ID map

                if (!(Object.keys(currencyMap).length === 0)) {
                  _context.next = 10;
                  break;
                }

                _context.next = 4;
                return fetch("https://api.coincap.io/v2/assets/");

              case 4:
                assets = _context.sent;
                _context.next = 7;
                return assets.json();

              case 7:
                assetsJson = _context.sent;
                assetIds = asCoincapAssets(assetsJson.data);
                assetIds.forEach(function (code) {
                  return currencyMap[code.symbol] = code.id;
                });

              case 10:
                // Create query strings
                queryStrings = [];
                filteredPairs = [];

                _loop = function _loop(i) {
                  if (!currencyMap[pairsHint[i].fromCurrency]) return "continue";
                  if (pairsHint[i].fromCurrency.indexOf('iso:') >= 0) return "continue";
                  if (filteredPairs.some(function (cc) {
                    return cc === currencyMap[pairsHint[i].fromCurrency];
                  })) return "continue";
                  filteredPairs.push(currencyMap[pairsHint[i].fromCurrency]);

                  if (filteredPairs.length === 100 || i === pairsHint.length - 1) {
                    queryStrings.push(filteredPairs.join(','));
                    filteredPairs = [];
                  }
                };

                i = 0;

              case 14:
                if (!(i < pairsHint.length)) {
                  _context.next = 21;
                  break;
                }

                _ret = _loop(i);

                if (!(_ret === "continue")) {
                  _context.next = 18;
                  break;
                }

                return _context.abrupt("continue", 18);

              case 18:
                i++;
                _context.next = 14;
                break;

              case 21:
                _i2 = 0;

              case 22:
                if (!(_i2 < queryStrings.length)) {
                  _context.next = 43;
                  break;
                }

                query = queryStrings[_i2];
                _context.prev = 24;
                _context.next = 27;
                return fetch("https://api.coincap.io/v2/assets?ids=".concat(query));

              case 27:
                reply = _context.sent;
                _context.next = 30;
                return reply.json();

              case 30:
                json = _context.sent;
                _asCoincapError = asCoincapError(json), error = _asCoincapError.error;

                if (!(error != null && error !== '' || reply.ok === false)) {
                  _context.next = 34;
                  break;
                }

                throw new Error("CoincapHistorical returned code ".concat(JSON.stringify(error !== null && error !== void 0 ? error : reply.status)));

              case 34:
                asCoincapResponse(json).data.forEach(function (rate) {
                  return pairs.push({
                    fromCurrency: rate.symbol,
                    toCurrency: 'iso:USD',
                    rate: Number(rate.priceUsd)
                  });
                });
                _context.next = 40;
                break;

              case 37:
                _context.prev = 37;
                _context.t0 = _context["catch"](24);
                log.warn("Issue with Coincap rate data structure ".concat(_context.t0));

              case 40:
                _i2++;
                _context.next = 22;
                break;

              case 43:
                return _context.abrupt("return", pairs);

              case 44:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[24, 37]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/coingecko.js":
/*!*******************************!*\
  !*** ./src/rate/coingecko.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCoinGeckoPlugin": function() { return /* binding */ makeCoinGeckoPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asGeckoBulkUsdReply = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asMap)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  usd: cleaners__WEBPACK_IMPORTED_MODULE_0__.asNumber
}));
var coinGeckoMap = {
  TLOS: 'telos',
  FIRO: 'zcoin',
  ANT: 'aragon',
  TBTC: 'tbtc',
  FIO: 'fio-protocol',
  VTC: 'vertcoin',
  SMART: 'smartcash',
  GRS: 'groestlcoin',
  FUN: 'funfair',
  BADGER: 'badger-dao',
  CREAM: 'cream-2',
  CVP: 'concentrated-voting-power',
  DOUGH: 'piedao-dough-v2',
  ETHBNT: 'ethbnt',
  SUSD: 'nusd',
  USDS: 'stableusd',
  TUSD: 'true-usd',
  GUSD: 'gemini-dollar',
  YETI: 'yearn-ecosystem-token-index',
  PAX: 'paxos-standard',
  RBTC: 'rootstock',
  RIF: 'rif-token',
  FTC: 'feathercoin',
  GLM: 'golem',
  GNO: 'gnosis',
  STORJ: 'storj',
  BTC: 'bitcoin',
  ETH: 'ethereum',
  BCH: 'bitcoin-cash',
  BNB: 'binancecoin',
  EOS: 'eos',
  ETC: 'ethereum-classic',
  XLM: 'stellar',
  XTZ: 'tezos',
  XRP: 'ripple',
  BTG: 'bitcoin-gold',
  BSV: 'bitcoin-cash-sv',
  DASH: 'dash',
  DGB: 'digibyte',
  DOGE: 'dogecoin',
  EBST: 'eboost',
  LTC: 'litecoin',
  QTUM: 'qtum',
  RVN: 'ravencoin',
  UFO: 'ufocoin',
  XMR: 'monero',
  REP: 'augur',
  DAI: 'dai',
  SAI: 'sai',
  WINGS: 'wings',
  USDT: 'tether',
  IND: 'indorse',
  HUR: 'hurify',
  BAT: 'basic-attention-token',
  BNT: 'bounty0x',
  KNC: 'kyber-network',
  POLY: 'polymath-network',
  USDC: 'usd-coin',
  ZRX: '0x',
  OMG: 'omisego',
  NMR: 'numeraire',
  MKR: 'maker',
  SALT: 'salt',
  MANA: 'decentraland',
  NEXO: 'nexo',
  KIN: 'kin',
  LINK: 'chainlink',
  BRZ: 'brz',
  CREP: 'compound-augur',
  CUSDC: 'compound-usd-coin',
  CETH: 'compound-ether',
  CBAT: 'compound-basic-attention-token',
  CZRX: 'compound-0x',
  CWBTC: 'compound-wrapped-btc',
  CSAI: 'compound-sai',
  CDAI: 'cdai',
  OXT: 'orchid-protocol',
  COMP: 'compound-governance-token',
  MET: 'metronome',
  SNX: 'havven',
  SBTC: 'sbtc',
  AAVE: 'aave',
  WBTC: 'wrapped-bitcoin',
  YFI: 'yearn-finance',
  CRV: 'curve-dao-token',
  BAL: 'balancer',
  SUSHI: 'sushi',
  UMA: 'uma',
  IDLE: 'idle',
  NXM: 'nxm',
  PICKLE: 'pickle-finance',
  ROOK: 'rook',
  INDEX: 'index-cooperative',
  WETH: 'weth',
  RENBTC: 'renbtc',
  RENBCH: 'renbch',
  RENZEC: 'renzec',
  DPI: 'defipulse-index',
  BAND: 'band-protocol',
  REN: 'republic-protocol',
  AMPL: 'ampleforth',
  HBAR: 'hedera-hashgraph',
  OCEAN: 'ocean-protocol'
};
function makeCoinGeckoPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  return {
    rateInfo: {
      displayName: 'Coingecko',
      pluginId: 'coingecko'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, query, _i2, pair, reply, json, rates;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = [];
                query = [];

                for (_i2 = 0; _i2 < pairsHint.length; _i2++) {
                  pair = pairsHint[_i2];
                  // Coingecko is only used to query specific currencies
                  if (coinGeckoMap[pair.fromCurrency]) query.push(coinGeckoMap[pair.fromCurrency]);
                }

                _context.prev = 3;
                _context.next = 6;
                return io.fetch("https://api.coingecko.com/api/v3/simple/price?ids=".concat(query.join(','), "&vs_currencies=usd"));

              case 6:
                reply = _context.sent;
                _context.next = 9;
                return reply.json();

              case 9:
                json = _context.sent;
                rates = asGeckoBulkUsdReply(json);
                Object.keys(rates).forEach(function (rate) {
                  var fromCurrency = Object.keys(coinGeckoMap).find(function (key) {
                    return typeof key === 'string' && coinGeckoMap[key] === rate;
                  });
                  if (fromCurrency) pairs.push({
                    fromCurrency: fromCurrency,
                    toCurrency: 'iso:USD',
                    rate: rates[rate].usd
                  });
                });
                _context.next = 17;
                break;

              case 14:
                _context.prev = 14;
                _context.t0 = _context["catch"](3);
                log.warn("Issue with Coingecko rate data structure ".concat(_context.t0));

              case 17:
                return _context.abrupt("return", pairs);

              case 18:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[3, 14]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/coinmonitor.js":
/*!*********************************!*\
  !*** ./src/rate/coinmonitor.js ***!
  \*********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCoinmonitorPlugin": function() { return /* binding */ makeCoinmonitorPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asCoinmonitorTickerResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  mediana_prom: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
});
function makeCoinmonitorPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;
  return {
    rateInfo: {
      pluginId: 'coinmonitor',
      displayName: 'coinmonitor'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, _i2, pair, response, json, rate;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = [];
                _i2 = 0;

              case 2:
                if (!(_i2 < pairsHint.length)) {
                  _context.next = 23;
                  break;
                }

                pair = pairsHint[_i2];

                if (!(pair.fromCurrency === 'BTC' && pair.toCurrency === 'iso:ARS')) {
                  _context.next = 20;
                  break;
                }

                _context.prev = 5;
                _context.next = 8;
                return fetchCors('https://ar.coinmonitor.info/api/v3/btc_ars');

              case 8:
                response = _context.sent;
                _context.next = 11;
                return response.json();

              case 11:
                json = _context.sent;
                rate = Number(asCoinmonitorTickerResponse(json).mediana_prom);
                pairs.push({
                  fromCurrency: 'BTC',
                  toCurrency: 'iso:ARS',
                  rate: rate
                });
                _context.next = 19;
                break;

              case 16:
                _context.prev = 16;
                _context.t0 = _context["catch"](5);
                log.warn("Issue with Coinmonitor rate data structure ".concat(_context.t0));

              case 19:
                return _context.abrupt("break", 23);

              case 20:
                _i2++;
                _context.next = 2;
                break;

              case 23:
                return _context.abrupt("return", pairs);

              case 24:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[5, 16]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/compound.js":
/*!******************************!*\
  !*** ./src/rate/compound.js ***!
  \******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCompoundPlugin": function() { return /* binding */ makeCompoundPlugin; }
/* harmony export */ });
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function fixCurrency(currencyCode) {
  return currencyCode.toUpperCase();
}

function makeCompoundPlugin(opts) {
  var io = opts.io;
  return {
    rateInfo: {
      pluginId: 'compound',
      displayName: 'Compound'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var reply, json, pairs, _i2, _json$cToken2, rateInfo, rate, toCurrency, fromCurrency;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return io.fetch('https://api.compound.finance/api/v2/ctoken');

              case 2:
                reply = _context.sent;
                _context.next = 5;
                return reply.json();

              case 5:
                json = _context.sent;

                if (!(!json || !json.cToken)) {
                  _context.next = 8;
                  break;
                }

                return _context.abrupt("return", []);

              case 8:
                pairs = [];

                for (_i2 = 0, _json$cToken2 = json.cToken; _i2 < _json$cToken2.length; _i2++) {
                  rateInfo = _json$cToken2[_i2];
                  rate = Number(rateInfo.exchange_rate.value);
                  toCurrency = fixCurrency(rateInfo.underlying_symbol);
                  fromCurrency = fixCurrency(rateInfo.symbol);
                  pairs.push({
                    fromCurrency: fromCurrency,
                    toCurrency: toCurrency,
                    rate: rate
                  });
                }

                return _context.abrupt("return", pairs);

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/constantRate.js":
/*!**********************************!*\
  !*** ./src/rate/constantRate.js ***!
  \**********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeConstantRatePlugin": function() { return /* binding */ makeConstantRatePlugin; }
/* harmony export */ });
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function makeConstantRatePlugin(opts) {
  return {
    rateInfo: {
      pluginId: 'constantRate',
      displayName: 'ConstantRate'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                // Grab all the pairs which are in USD:
                pairs = [{
                  fromCurrency: 'TESTBTC',
                  toCurrency: 'iso:USD',
                  rate: 0.01
                }, {
                  fromCurrency: 'WETH',
                  toCurrency: 'ETH',
                  rate: 1
                }, {
                  fromCurrency: 'iso:BRL',
                  toCurrency: 'BRZ',
                  rate: 1
                }, {
                  fromCurrency: 'WBTC',
                  toCurrency: 'BTC',
                  rate: 1
                }, {
                  fromCurrency: 'AYFI',
                  toCurrency: 'YFI',
                  rate: 1
                }, {
                  fromCurrency: 'ALINK',
                  toCurrency: 'LINK',
                  rate: 1
                }, {
                  fromCurrency: 'ADAI',
                  toCurrency: 'DAI',
                  rate: 1
                }, {
                  fromCurrency: 'ABAT',
                  toCurrency: 'BAT',
                  rate: 1
                }, {
                  fromCurrency: 'AWETH',
                  toCurrency: 'WETH',
                  rate: 1
                }, {
                  fromCurrency: 'AWBTC',
                  toCurrency: 'WBTC',
                  rate: 1
                }, {
                  fromCurrency: 'ASNX',
                  toCurrency: 'SNX',
                  rate: 1
                }, {
                  fromCurrency: 'AREN',
                  toCurrency: 'REN',
                  rate: 1
                }, {
                  fromCurrency: 'AUSDT',
                  toCurrency: 'USDT',
                  rate: 1
                }, {
                  fromCurrency: 'AMKR',
                  toCurrency: 'MKR',
                  rate: 1
                }, {
                  fromCurrency: 'AMANA',
                  toCurrency: 'MANA',
                  rate: 1
                }, {
                  fromCurrency: 'AZRX',
                  toCurrency: 'ZRX',
                  rate: 1
                }, {
                  fromCurrency: 'AKNC',
                  toCurrency: 'KNC',
                  rate: 1
                }, {
                  fromCurrency: 'AUSDC',
                  toCurrency: 'USDC',
                  rate: 1
                }, {
                  fromCurrency: 'ASUSD',
                  toCurrency: 'SUSD',
                  rate: 1
                }, {
                  fromCurrency: 'AUNI',
                  toCurrency: 'UNI',
                  rate: 1
                }, {
                  fromCurrency: 'ANT',
                  toCurrency: 'ANTV1',
                  rate: 1
                }, {
                  fromCurrency: 'REPV2',
                  toCurrency: 'REP',
                  rate: 1
                }, {
                  fromCurrency: 'FUSDT',
                  toCurrency: 'USDT',
                  rate: 1
                }];
                return _context.abrupt("return", pairs);

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/currencyconverterapi.js":
/*!******************************************!*\
  !*** ./src/rate/currencyconverterapi.js ***!
  \******************************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeCurrencyconverterapiPlugin": function() { return /* binding */ makeCurrencyconverterapiPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asRates = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asNumber);
var asCurrencyConverterResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  status: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asNumber),
  error: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asString)
}).withRest;

var checkAndPush = function checkAndPush(isoCc, ccArray) {
  if (isoCc !== 'iso:USD' && isoCc.slice(0, 4) === 'iso:') {
    var cc = isoCc.slice(4).toUpperCase();

    if (!ccArray.includes("USD_".concat(cc))) {
      ccArray.push("USD_".concat(cc));
    }
  }
};

function makeCurrencyconverterapiPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;
  var apiKey = opts.initOptions.apiKey;

  if (apiKey == null) {
    throw new Error('No currencyconverterapi apiKey provided');
  }

  return {
    rateInfo: {
      pluginId: 'currencyconverterapi',
      displayName: 'CurrencyConverterAPI'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var isoCodesWanted, _i2, _pairsHint2, pair, pairs, query, response, _asCurrencyConverterR, status, error, rates, _i4, _Object$keys2, rate;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairsHint = pairsHint.concat([{
                  fromCurrency: 'iso:USD',
                  toCurrency: 'iso:IMP'
                }, {
                  fromCurrency: 'iso:USD',
                  toCurrency: 'iso:IRR'
                }]);
                isoCodesWanted = [];

                for (_i2 = 0, _pairsHint2 = pairsHint; _i2 < _pairsHint2.length; _i2++) {
                  pair = _pairsHint2[_i2];
                  checkAndPush(pair.fromCurrency, isoCodesWanted);
                  checkAndPush(pair.toCurrency, isoCodesWanted);
                }

                pairs = [];
                query = isoCodesWanted.join(',');
                _context.prev = 5;
                _context.next = 8;
                return fetchCors("https://api.currconv.com/api/v7/convert?q=".concat(query, "&compact=ultra&apiKey=").concat(apiKey));

              case 8:
                response = _context.sent;
                _context.t0 = asCurrencyConverterResponse;
                _context.next = 12;
                return response.json();

              case 12:
                _context.t1 = _context.sent;
                _asCurrencyConverterR = (0, _context.t0)(_context.t1);
                status = _asCurrencyConverterR.status;
                error = _asCurrencyConverterR.error;
                rates = _objectWithoutProperties(_asCurrencyConverterR, ["status", "error"]);

                if (!(status != null && status !== 200 || error != null && error !== '' || response.ok === false)) {
                  _context.next = 19;
                  break;
                }

                throw new Error("CurrencyConvertor returned with status: ".concat(JSON.stringify(status !== null && status !== void 0 ? status : response.status), " and error: ").concat(JSON.stringify(error)));

              case 19:
                for (_i4 = 0, _Object$keys2 = Object.keys(asRates(rates)); _i4 < _Object$keys2.length; _i4++) {
                  rate = _Object$keys2[_i4];
                  pairs.push({
                    fromCurrency: 'iso:USD',
                    toCurrency: "iso:".concat(rate.split('_')[1]),
                    rate: rates[rate]
                  });
                }

                _context.next = 25;
                break;

              case 22:
                _context.prev = 22;
                _context.t2 = _context["catch"](5);
                log.warn("Failed to get ".concat(query, " from currencyconverterapi.com"), _context.t2.message);

              case 25:
                return _context.abrupt("return", pairs);

              case 26:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[5, 22]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/edgeRates.js":
/*!*******************************!*\
  !*** ./src/rate/edgeRates.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeEdgeRatesPlugin": function() { return /* binding */ makeEdgeRatesPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asEdgeRatesResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  exchangeRate: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
});

function checkIfFiat(code) {
  if (code.indexOf('iso:') >= 0) return true;
  return false;
}

function makeEdgeRatesPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var fetch = io.fetch;
  return {
    rateInfo: {
      pluginId: 'edgeRates',
      displayName: 'EdgeRates'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, _i2, pair, fiatFrom, fiatTo, reply, jsonData, rate;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = [];
                _i2 = 0;

              case 2:
                if (!(_i2 < pairsHint.length)) {
                  _context.next = 25;
                  break;
                }

                pair = pairsHint[_i2];

                if (!(!checkIfFiat(pair.fromCurrency) || !checkIfFiat(pair.toCurrency))) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt("continue", 22);

              case 6:
                fiatFrom = pair.fromCurrency.split(':');
                fiatTo = pair.toCurrency.split(':');
                _context.prev = 8;
                _context.next = 11;
                return fetch("https://rates1.edge.app/v1/exchangeRate?currency_pair=".concat(fiatFrom[1], "_").concat(fiatTo[1]));

              case 11:
                reply = _context.sent;
                _context.next = 14;
                return reply.json();

              case 14:
                jsonData = _context.sent;
                rate = Number(asEdgeRatesResponse(jsonData).exchangeRate);
                pairs.push({
                  fromCurrency: pair.fromCurrency,
                  toCurrency: pair.toCurrency,
                  rate: rate
                });
                _context.next = 22;
                break;

              case 19:
                _context.prev = 19;
                _context.t0 = _context["catch"](8);
                log.warn("Issue with EdgeRates rate data structure for ".concat(pair.fromCurrency, "/").concat(pair.toCurrency, " pair. Error: ").concat(_context.t0));

              case 22:
                _i2++;
                _context.next = 2;
                break;

              case 25:
                return _context.abrupt("return", pairs);

              case 26:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[8, 19]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/nomics.js":
/*!****************************!*\
  !*** ./src/rate/nomics.js ***!
  \****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeNomicsPlugin": function() { return /* binding */ makeNomicsPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asNomicsResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asArray)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  price: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asString),
  symbol: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}));
function makeNomicsPlugin(opts) {
  var io = opts.io,
      initOptions = opts.initOptions,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;
  var apiKey = initOptions.apiKey;

  if (apiKey == null) {
    throw new Error('No Nomics exchange rates API key provided');
  }

  return {
    rateInfo: {
      pluginId: 'nomics',
      displayName: 'Nomics'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, queryStrings, filteredPairs, _loop, i, _ret, _i2, query, reply, _e$message;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = []; // Create query strings

                queryStrings = [];
                filteredPairs = [];

                _loop = function _loop(i) {
                  if (pairsHint[i].fromCurrency.indexOf('iso:') >= 0) return "continue";
                  if (filteredPairs.some(function (cc) {
                    return cc === pairsHint[i].fromCurrency;
                  })) return "continue";
                  filteredPairs.push(pairsHint[i].fromCurrency);

                  if (filteredPairs.length === 100 || i === pairsHint.length - 1) {
                    queryStrings.push(filteredPairs.join(','));
                    filteredPairs = [];
                  }
                };

                i = 0;

              case 5:
                if (!(i < pairsHint.length)) {
                  _context.next = 12;
                  break;
                }

                _ret = _loop(i);

                if (!(_ret === "continue")) {
                  _context.next = 9;
                  break;
                }

                return _context.abrupt("continue", 9);

              case 9:
                i++;
                _context.next = 5;
                break;

              case 12:
                _i2 = 0;

              case 13:
                if (!(_i2 < queryStrings.length)) {
                  _context.next = 34;
                  break;
                }

                query = queryStrings[_i2];
                _context.prev = 15;
                _context.next = 18;
                return fetchCors("https://api.nomics.com/v1/currencies/ticker?key=".concat(apiKey, "&ids=").concat(query, "&convert=USD"));

              case 18:
                reply = _context.sent;

                if (!(reply.status === 429 || reply.status === 401 || reply.ok === false)) {
                  _context.next = 21;
                  break;
                }

                throw new Error("Nomics returned with status: ".concat(reply.status));

              case 21:
                _context.t0 = asNomicsResponse;
                _context.next = 24;
                return reply.json();

              case 24:
                _context.t1 = _context.sent;
                (0, _context.t0)(_context.t1).forEach(function (rate) {
                  // When Nomics considers a coin "dead" they don't return a price
                  if (rate.price) pairs.push({
                    fromCurrency: rate.symbol,
                    toCurrency: 'iso:USD',
                    rate: Number(rate.price)
                  });
                });
                _context.next = 31;
                break;

              case 28:
                _context.prev = 28;
                _context.t2 = _context["catch"](15);
                log.warn("Issue with Nomics rate data structure. Error: ".concat((_e$message = _context.t2.message) !== null && _e$message !== void 0 ? _e$message : ''));

              case 31:
                _i2++;
                _context.next = 13;
                break;

              case 34:
                return _context.abrupt("return", pairs);

              case 35:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[15, 28]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/rate/wazirx.js":
/*!****************************!*\
  !*** ./src/rate/wazirx.js ***!
  \****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeWazirxPlugin": function() { return /* binding */ makeWazirxPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


var asWazirxResponse = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asMap)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  last: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}));

function fixCurrency(currencyCode) {
  currencyCode = currencyCode.toUpperCase();
  if (currencyCode === 'BCHABC') currencyCode = 'BCH';
  return currencyCode;
}

function makeWazirxPlugin(opts) {
  var io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;
  return {
    rateInfo: {
      pluginId: 'wazirx',
      displayName: 'WazirX'
    },
    fetchRates: function fetchRates(pairsHint) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var pairs, rates, _i2, pair, reply, json, cc, currencyPair;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                pairs = [];
                _i2 = 0;

              case 2:
                if (!(_i2 < pairsHint.length)) {
                  _context.next = 26;
                  break;
                }

                pair = pairsHint[_i2];

                if (!(pair.toCurrency !== 'iso:INR')) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt("continue", 23);

              case 6:
                _context.prev = 6;

                if (!(rates === undefined)) {
                  _context.next = 15;
                  break;
                }

                _context.next = 10;
                return fetchCors('https://api.wazirx.com/api/v2/tickers');

              case 10:
                reply = _context.sent;
                _context.next = 13;
                return reply.json();

              case 13:
                json = _context.sent;
                rates = asWazirxResponse(json);

              case 15:
                cc = fixCurrency(pair.fromCurrency).toLowerCase();
                currencyPair = "".concat(cc, "inr");

                if (rates && rates[currencyPair]) {
                  pairs.push({
                    fromCurrency: pair.fromCurrency,
                    toCurrency: 'iso:INR',
                    rate: Number(rates[currencyPair].last)
                  });
                }

                _context.next = 23;
                break;

              case 20:
                _context.prev = 20;
                _context.t0 = _context["catch"](6);
                log.warn("Issue with Wazirx rate data structure ".concat(_context.t0));

              case 23:
                _i2++;
                _context.next = 2;
                break;

              case 26:
                return _context.abrupt("return", pairs);

              case 27:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[6, 20]]);
      }))();
    }
  };
}

/***/ }),

/***/ "./src/swap-helpers.js":
/*!*****************************!*\
  !*** ./src/swap-helpers.js ***!
  \*****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "ensureInFuture": function() { return /* binding */ ensureInFuture; },
/* harmony export */   "makeSwapPluginQuote": function() { return /* binding */ makeSwapPluginQuote; },
/* harmony export */   "checkInvalidCodes": function() { return /* binding */ checkInvalidCodes; },
/* harmony export */   "safeCurrencyCodes": function() { return /* binding */ safeCurrencyCodes; }
/* harmony export */ });
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__);
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }


/**
 * Ensures that a date is in the future by at least the given amount.
 */

function ensureInFuture(date) {
  var marginSeconds = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 30;
  if (date == null) return;
  var target = Date.now() + marginSeconds * 1000;
  return target < date.valueOf() ? date : new Date(target);
}
function makeSwapPluginQuote(request, fromNativeAmount, toNativeAmount, tx, destinationAddress, pluginId) {
  var isEstimate = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : false;
  var expirationDate = arguments.length > 7 ? arguments[7] : undefined;
  var quoteId = arguments.length > 8 ? arguments[8] : undefined;
  var fromWallet = request.fromWallet;
  var out = {
    fromNativeAmount: fromNativeAmount,
    toNativeAmount: toNativeAmount,
    networkFee: {
      currencyCode: fromWallet.currencyInfo.currencyCode,
      nativeAmount: tx.parentNetworkFee != null ? tx.parentNetworkFee : tx.networkFee
    },
    destinationAddress: destinationAddress,
    pluginId: pluginId,
    expirationDate: expirationDate,
    quoteId: quoteId,
    isEstimate: isEstimate,
    approve: function approve() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var signedTransaction, broadcastedTransaction;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return fromWallet.signTx(tx);

              case 2:
                signedTransaction = _context.sent;
                _context.next = 5;
                return fromWallet.broadcastTx(signedTransaction);

              case 5:
                broadcastedTransaction = _context.sent;
                _context.next = 8;
                return fromWallet.saveTx(signedTransaction);

              case 8:
                return _context.abrupt("return", {
                  transaction: broadcastedTransaction,
                  orderId: quoteId,
                  destinationAddress: destinationAddress
                });

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    close: function close() {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }))();
    }
  };
  return out;
}

var getCodes = function getCodes(request) {
  return {
    fromMainnetCode: request.fromWallet.currencyInfo.currencyCode,
    toMainnetCode: request.toWallet.currencyInfo.currencyCode,
    fromCurrencyCode: request.fromCurrencyCode,
    toCurrencyCode: request.toCurrencyCode
  };
};

/**
 * Throws if either currency code has been disabled by the plugin
 */
function checkInvalidCodes(invalidCodes, request, swapInfo) {
  var _getCodes = getCodes(request),
      fromMainnetCode = _getCodes.fromMainnetCode,
      toMainnetCode = _getCodes.toMainnetCode,
      fromCurrencyCode = _getCodes.fromCurrencyCode,
      toCurrencyCode = _getCodes.toCurrencyCode;

  function check(direction, main, token) {
    switch (invalidCodes[direction][main]) {
      case undefined:
        return false;

      case 'allCodes':
        return true;

      case 'allTokens':
        return main !== token;

      default:
        return invalidCodes[direction][main].some(function (code) {
          return code === token;
        });
    }
  }

  if (check('from', fromMainnetCode, fromCurrencyCode) || check('to', toMainnetCode, toCurrencyCode)) throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);
}

/**
 * Transcribes requested currency codes into plugin compatible unique IDs
 */
function safeCurrencyCodes(transcriptionMap, request) {
  var _transcriptionMap$fro, _transcriptionMap$toM;

  var _getCodes2 = getCodes(request),
      fromMainnetCode = _getCodes2.fromMainnetCode,
      toMainnetCode = _getCodes2.toMainnetCode,
      fromCurrencyCode = _getCodes2.fromCurrencyCode,
      toCurrencyCode = _getCodes2.toCurrencyCode;

  var out = {
    safeFromCurrencyCode: fromCurrencyCode,
    safeToCurrencyCode: toCurrencyCode
  };

  if ((_transcriptionMap$fro = transcriptionMap[fromMainnetCode]) !== null && _transcriptionMap$fro !== void 0 && _transcriptionMap$fro[request.fromCurrencyCode]) {
    out.safeFromCurrencyCode = transcriptionMap[fromMainnetCode][request.fromCurrencyCode];
  }

  if ((_transcriptionMap$toM = transcriptionMap[toMainnetCode]) !== null && _transcriptionMap$toM !== void 0 && _transcriptionMap$toM[request.toCurrencyCode]) {
    out.safeToCurrencyCode = transcriptionMap[toMainnetCode][request.toCurrencyCode];
  }

  return out;
}

/***/ }),

/***/ "./src/swap/changelly.js":
/*!*******************************!*\
  !*** ./src/swap/changelly.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeChangellyPlugin": function() { return /* binding */ makeChangellyPlugin; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var hash_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! hash.js */ "./node_modules/hash.js/lib/hash.js");
/* harmony import */ var hash_js__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(hash_js__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var rfc4648__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! rfc4648 */ "./node_modules/rfc4648/lib/index.js");
/* harmony import */ var utf8__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! utf8 */ "./node_modules/utf8/utf8.js");
/* harmony import */ var utf8__WEBPACK_IMPORTED_MODULE_5___default = /*#__PURE__*/__webpack_require__.n(utf8__WEBPACK_IMPORTED_MODULE_5__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }








var INVALID_CURRENCY_CODES = {
  from: {
    ETH: ['FTM', 'MATIC'],
    MATIC: 'allTokens',
    FTM: 'allCodes'
  },
  to: {
    ETH: ['FTM', 'MATIC'],
    MATIC: 'allTokens',
    FTM: 'allCodes',
    ZEC: ['ZEC']
  }
}; // Invalid currency codes should *not* have transcribed codes
// because currency codes with transcribed versions are NOT invalid

var CURRENCY_CODE_TRANSCRIPTION = {
  ETH: {
    USDT: 'USDT20'
  }
};

function hmacSha512(data, key) {
  var hmac = hash_js__WEBPACK_IMPORTED_MODULE_3___default().hmac((hash_js__WEBPACK_IMPORTED_MODULE_3___default().sha512), key);
  return hmac.update(data).digest();
}

function parseUtf8(text) {
  var byteString = utf8__WEBPACK_IMPORTED_MODULE_5___default().encode(text);
  var out = new Uint8Array(byteString.length);

  for (var i = 0; i < byteString.length; ++i) {
    out[i] = byteString.charCodeAt(i);
  }

  return out;
}

var pluginId = 'changelly';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Changelly',
  supportEmail: 'support@changelly.com'
};
var orderUri = 'https://changelly.com/transaction/';
var uri = 'https://api.changelly.com';
var expirationMs = 1000 * 60 * 20;
var expirationFixedMs = 1000 * 60 * 5;
var asFixedRateQuote = (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
  result: (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
    id: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString
  })
});
var dontUseLegacy = {
  DGB: true
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context5.sent;
            return _context5.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _getAddress.apply(this, arguments);
}

function checkReply(reply, request) {
  if (reply.error != null) {
    if (reply.error.code === -32602 || /Invalid currency:/.test(reply.error.message)) {
      throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);
    }

    throw new Error('Changelly error: ' + JSON.stringify(reply.error));
  }
}

function makeChangellyPlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;

  if (initOptions.apiKey == null || initOptions.secret == null) {
    throw new Error('No Changelly apiKey or secret provided.');
  }

  var apiKey = initOptions.apiKey;
  var secret = parseUtf8(initOptions.secret);

  function call(_x3, _x4) {
    return _call.apply(this, arguments);
  }

  function _call() {
    _call = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(json, promoCode) {
      var body, sign, headers, response;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              body = JSON.stringify(json);
              sign = rfc4648__WEBPACK_IMPORTED_MODULE_4__.base16.stringify(hmacSha512(parseUtf8(body), secret)).toLowerCase();
              headers = {
                'Content-Type': 'application/json',
                'api-key': apiKey,
                sign: sign
              };
              if (promoCode != null) headers['X-Promo-Code'] = promoCode;
              _context4.next = 6;
              return fetchCors(uri, {
                method: 'POST',
                body: body,
                headers: headers
              });

            case 6:
              response = _context4.sent;

              if (response.ok) {
                _context4.next = 9;
                break;
              }

              throw new Error("Changelly returned error code ".concat(response.status));

            case 9:
              return _context4.abrupt("return", response.json());

            case 10:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));
    return _call.apply(this, arguments);
  }

  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      var _this = this;

      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var fixedPromise, fixedResult;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_6__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo);
                fixedPromise = _this.getFixedQuote(request, userSettings, opts); // FIXME: Estimated swaps are temporarily disabled

                _context.next = 4;
                return fixedPromise;

              case 4:
                fixedResult = _context.sent;
                return _context.abrupt("return", fixedResult);

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    getFixedQuote: function getFixedQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var promoCode, _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, quoteAmount, _safeCurrencyCodes, safeFromCurrencyCode, safeToCurrencyCode, fixedRateQuoteResponse, fixedRateQuote, params, sendReply, quoteInfo, spendInfoAmount, amountExpectedFromNative, amountExpectedToTo, spendInfo, tx;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                promoCode = opts.promoCode;
                _context2.next = 3;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 3:
                _yield$Promise$all = _context2.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];

                if (!(request.quoteFor === 'from')) {
                  _context2.next = 13;
                  break;
                }

                _context2.next = 10;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 10:
                _context2.t0 = _context2.sent;
                _context2.next = 16;
                break;

              case 13:
                _context2.next = 15;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 15:
                _context2.t0 = _context2.sent;

              case 16:
                quoteAmount = _context2.t0;
                _safeCurrencyCodes = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_6__.safeCurrencyCodes)(CURRENCY_CODE_TRANSCRIPTION, request), safeFromCurrencyCode = _safeCurrencyCodes.safeFromCurrencyCode, safeToCurrencyCode = _safeCurrencyCodes.safeToCurrencyCode;
                _context2.next = 20;
                return call({
                  jsonrpc: '2.0',
                  id: 'one',
                  method: 'getFixRateForAmount',
                  params: {
                    from: safeFromCurrencyCode,
                    to: safeToCurrencyCode,
                    amountFrom: quoteAmount
                  }
                });

              case 20:
                fixedRateQuoteResponse = _context2.sent;
                fixedRateQuote = asFixedRateQuote(fixedRateQuoteResponse);
                params = request.quoteFor === 'from' ? {
                  amount: quoteAmount,
                  from: safeFromCurrencyCode,
                  to: safeToCurrencyCode,
                  address: toAddress,
                  extraId: null,
                  refundAddress: fromAddress,
                  refundExtraId: null,
                  rateId: fixedRateQuote.result.id
                } : {
                  amountTo: quoteAmount,
                  from: safeFromCurrencyCode,
                  to: safeToCurrencyCode,
                  address: toAddress,
                  extraId: null,
                  refundAddress: fromAddress,
                  refundExtraId: null,
                  rateId: fixedRateQuote.result.id
                };
                _context2.next = 25;
                return call({
                  jsonrpc: '2.0',
                  id: 2,
                  method: 'createFixTransaction',
                  params: params
                }, promoCode);

              case 25:
                sendReply = _context2.sent;
                checkReply(sendReply, request);
                quoteInfo = sendReply.result;
                _context2.next = 30;
                return request.fromWallet.denominationToNative(quoteInfo.amountExpectedFrom, // need to verify that this is okay
                // why use currencyCode from quoteInfo in the first place?
                request.fromCurrencyCode.toUpperCase());

              case 30:
                spendInfoAmount = _context2.sent;
                _context2.next = 33;
                return request.fromWallet.denominationToNative(sendReply.result.amountExpectedFrom, request.fromCurrencyCode);

              case 33:
                amountExpectedFromNative = _context2.sent;
                _context2.next = 36;
                return request.fromWallet.denominationToNative(sendReply.result.amountExpectedTo, request.toCurrencyCode);

              case 36:
                amountExpectedToTo = _context2.sent;
                spendInfo = {
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: spendInfoAmount,
                    publicAddress: quoteInfo.payinAddress,
                    uniqueIdentifier: quoteInfo.payinExtraId || undefined
                  }],
                  networkFeeOption: request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                  swapData: {
                    orderId: quoteInfo.id,
                    orderUri: orderUri + quoteInfo.id,
                    isEstimate: false,
                    payoutAddress: toAddress,
                    payoutCurrencyCode: request.toCurrencyCode,
                    payoutNativeAmount: amountExpectedToTo,
                    payoutWalletId: request.toWallet.id,
                    plugin: _objectSpread({}, swapInfo),
                    refundAddress: fromAddress
                  }
                };
                _context2.next = 40;
                return request.fromWallet.makeSpend(spendInfo);

              case 40:
                tx = _context2.sent;
                return _context2.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_6__.makeSwapPluginQuote)(request, amountExpectedFromNative, amountExpectedToTo, tx, toAddress, 'changelly', false, new Date(Date.now() + expirationFixedMs), quoteInfo.id));

              case 42:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }))();
    },
    getEstimate: function getEstimate(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var promoCode, _yield$Promise$all3, _yield$Promise$all4, fromAddress, toAddress, quoteAmount, safeFromCurrencyCode, safeToCurrencyCode, quoteParams, quoteReplies, nativeMin, fromAmount, fromNativeAmount, toNativeAmount, sendReply, quoteInfo, spendInfo, tx;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                promoCode = opts.promoCode; // Grab addresses:

                _context3.next = 3;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 3:
                _yield$Promise$all3 = _context3.sent;
                _yield$Promise$all4 = _slicedToArray(_yield$Promise$all3, 2);
                fromAddress = _yield$Promise$all4[0];
                toAddress = _yield$Promise$all4[1];

                if (!(request.quoteFor === 'from')) {
                  _context3.next = 13;
                  break;
                }

                _context3.next = 10;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 10:
                _context3.t0 = _context3.sent;
                _context3.next = 16;
                break;

              case 13:
                _context3.next = 15;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 15:
                _context3.t0 = _context3.sent;

              case 16:
                quoteAmount = _context3.t0;
                safeFromCurrencyCode = request.fromCurrencyCode;
                safeToCurrencyCode = request.toCurrencyCode;

                if (CURRENCY_CODE_TRANSCRIPTION[request.fromCurrencyCode]) {
                  safeFromCurrencyCode = CURRENCY_CODE_TRANSCRIPTION[request.fromCurrencyCode];
                }

                if (CURRENCY_CODE_TRANSCRIPTION[request.toCurrencyCode]) {
                  safeToCurrencyCode = CURRENCY_CODE_TRANSCRIPTION[request.toCurrencyCode];
                } // Swap the currencies if we need a reverse quote:


                quoteParams = request.quoteFor === 'from' ? {
                  from: safeFromCurrencyCode,
                  to: safeToCurrencyCode,
                  amount: quoteAmount
                } : {
                  from: safeToCurrencyCode,
                  to: safeFromCurrencyCode,
                  amount: quoteAmount
                }; // Get the estimate from the server:

                _context3.next = 24;
                return Promise.all([call({
                  jsonrpc: '2.0',
                  id: 'one',
                  method: 'getMinAmount',
                  params: {
                    from: safeFromCurrencyCode,
                    to: safeToCurrencyCode
                  }
                }), call({
                  jsonrpc: '2.0',
                  id: 'two',
                  method: 'getExchangeAmount',
                  params: quoteParams
                })]);

              case 24:
                quoteReplies = _context3.sent;
                checkReply(quoteReplies[0], request); // Check the minimum:

                _context3.next = 28;
                return request.fromWallet.denominationToNative(quoteReplies[0].result, request.fromCurrencyCode);

              case 28:
                nativeMin = _context3.sent;

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(request.nativeAmount, nativeMin)) {
                  _context3.next = 31;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapBelowLimitError(swapInfo, nativeMin);

              case 31:
                checkReply(quoteReplies[1], request); // Calculate the amounts:

                if (!(request.quoteFor === 'from')) {
                  _context3.next = 40;
                  break;
                }

                fromAmount = quoteAmount;
                fromNativeAmount = request.nativeAmount;
                _context3.next = 37;
                return request.toWallet.denominationToNative(quoteReplies[1].result, request.toCurrencyCode);

              case 37:
                toNativeAmount = _context3.sent;
                _context3.next = 45;
                break;

              case 40:
                fromAmount = (0,biggystring__WEBPACK_IMPORTED_MODULE_0__.mul)(quoteReplies[1].result, '1.02');
                _context3.next = 43;
                return request.fromWallet.denominationToNative(fromAmount, request.fromCurrencyCode);

              case 43:
                fromNativeAmount = _context3.sent;
                toNativeAmount = request.nativeAmount;

              case 45:
                _context3.next = 47;
                return call({
                  jsonrpc: '2.0',
                  id: 3,
                  method: 'createTransaction',
                  params: {
                    amount: fromAmount,
                    from: safeFromCurrencyCode,
                    to: safeToCurrencyCode,
                    address: toAddress,
                    extraId: null,
                    // TODO: Do we need this for Monero?
                    refundAddress: fromAddress,
                    refundExtraId: null
                  }
                }, promoCode);

              case 47:
                sendReply = _context3.sent;
                checkReply(sendReply, request);
                quoteInfo = sendReply.result; // Make the transaction:

                spendInfo = {
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: fromNativeAmount,
                    publicAddress: quoteInfo.payinAddress,
                    uniqueIdentifier: quoteInfo.payinExtraId || undefined
                  }],
                  swapData: {
                    orderId: quoteInfo.id,
                    orderUri: orderUri + quoteInfo.id,
                    isEstimate: true,
                    payoutAddress: toAddress,
                    payoutCurrencyCode: request.toCurrencyCode,
                    payoutNativeAmount: toNativeAmount,
                    payoutWalletId: request.toWallet.id,
                    plugin: _objectSpread({}, swapInfo),
                    refundAddress: fromAddress
                  }
                };
                log('spendInfo', spendInfo);
                _context3.next = 54;
                return request.fromWallet.makeSpend(spendInfo);

              case 54:
                tx = _context3.sent;
                return _context3.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_6__.makeSwapPluginQuote)(request, fromNativeAmount, toNativeAmount, tx, toAddress, 'changelly', true, new Date(Date.now() + expirationMs), quoteInfo.id));

              case 56:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/changenow.js":
/*!*******************************!*\
  !*** ./src/swap/changenow.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeChangeNowPlugin": function() { return /* binding */ makeChangeNowPlugin; },
/* harmony export */   "asOptionalBlank": function() { return /* binding */ asOptionalBlank; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }





var pluginId = 'changenow';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Change NOW',
  supportEmail: 'support@changenow.io'
};
var orderUri = 'https://changenow.io/exchange/txs/';
var uri = 'https://changenow.io/api/v1/';
var dontUseLegacy = {
  DGB: true
};
var CURRENCY_CODE_TRANSCRIPTION = {
  ETH: {
    USDT: 'USDTERC20'
  },
  FTM: {
    FTM: 'FTMMAINNET'
  }
}; // Invalid currency codes should *not* have transcribed codes
// because currency codes with transcribed versions are NOT invalid

var INVALID_CURRENCY_CODES = {
  from: {
    ETH: ['MATIC'],
    MATIC: 'allTokens'
  },
  to: {
    ETH: ['MATIC'],
    MATIC: 'allTokens',
    ZEC: ['ZEC']
  }
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context4.sent;
            return _context4.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _getAddress.apply(this, arguments);
}

function makeChangeNowPlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io,
      log = opts.log;
  var fetch = io.fetch;

  if (initOptions.apiKey == null) {
    throw new Error('No ChangeNow apiKey provided.');
  }

  var apiKey = initOptions.apiKey;

  function get(_x3) {
    return _get.apply(this, arguments);
  }

  function _get() {
    _get = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(route) {
      var response;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return fetch(uri + route);

            case 2:
              response = _context2.sent;
              return _context2.abrupt("return", response.json());

            case 4:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return _get.apply(this, arguments);
  }

  function post(_x4, _x5) {
    return _post.apply(this, arguments);
  }

  function _post() {
    _post = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(route, body) {
      var response, out;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              log('call fixed:', route, body);
              _context3.next = 3;
              return fetch(uri + route, {
                method: 'POST',
                body: JSON.stringify(body),
                headers: {
                  'Content-Type': 'application/json'
                }
              });

            case 3:
              response = _context3.sent;

              if (response.ok) {
                _context3.next = 6;
                break;
              }

              throw new Error("ChangeNow call returned error code ".concat(response.status));

            case 6:
              _context3.next = 8;
              return response.json();

            case 8:
              out = _context3.sent;
              log('fixed reply:', out);
              return _context3.abrupt("return", out);

            case 11:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return _post.apply(this, arguments);
  }

  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var promoCode, _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, _safeCurrencyCodes, safeFromCurrencyCode, safeToCurrencyCode, availablePairs, fixedMarket, quoteAmount, quoteParams, pairsToUse, fromAmount, fromNativeAmount, pairItem, quoteReplyKeep, i, obj, meetsFixedRateRange, j, item, _quoteReply, _sendReply, _toAmount, _spendInfo, _tx, min, _yield$Promise$all3, _yield$Promise$all4, nativeMin, quoteReply, sendReply, toAmount, spendInfo, tx;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                promoCode = opts.promoCode;
                (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo); // Grab addresses:

                _context.next = 4;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 4:
                _yield$Promise$all = _context.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];
                // transcribe currencyCodes if necessary
                _safeCurrencyCodes = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.safeCurrencyCodes)(CURRENCY_CODE_TRANSCRIPTION, request), safeFromCurrencyCode = _safeCurrencyCodes.safeFromCurrencyCode, safeToCurrencyCode = _safeCurrencyCodes.safeToCurrencyCode; // get the markets

                _context.next = 11;
                return get("currencies-to/".concat(safeFromCurrencyCode));

              case 11:
                availablePairs = _context.sent;
                _context.t0 = asFixedMarketReply;
                _context.next = 15;
                return get("market-info/fixed-rate/".concat(apiKey) + (promoCode != null ? "?promo=".concat(promoCode) : ''));

              case 15:
                _context.t1 = _context.sent;
                fixedMarket = (0, _context.t0)(_context.t1);

                if (!(request.quoteFor === 'from')) {
                  _context.next = 23;
                  break;
                }

                _context.next = 20;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 20:
                _context.t2 = _context.sent;
                _context.next = 26;
                break;

              case 23:
                _context.next = 25;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 25:
                _context.t2 = _context.sent;

              case 26:
                quoteAmount = _context.t2;
                // Swap the currencies if we need a reverse quote:
                quoteParams = request.quoteFor === 'from' ? {
                  from: safeFromCurrencyCode.toLowerCase(),
                  to: safeToCurrencyCode.toLowerCase(),
                  amount: quoteAmount
                } : {
                  from: safeToCurrencyCode.toLowerCase(),
                  to: safeFromCurrencyCode.toLowerCase(),
                  amount: quoteAmount
                };
                pairsToUse = [];
                quoteReplyKeep = {
                  estimatedAmount: '0'
                };
                i = 0;

              case 31:
                if (!(i < availablePairs.length)) {
                  _context.next = 81;
                  break;
                }

                obj = availablePairs[i];

                if (!(safeToCurrencyCode.toLowerCase() === obj.ticker)) {
                  _context.next = 78;
                  break;
                }

                pairsToUse.push(obj);

                if (!obj.supportsFixedRate) {
                  _context.next = 78;
                  break;
                }

                meetsFixedRateRange = true;
                j = 0;

              case 38:
                if (!(j < fixedMarket.length)) {
                  _context.next = 54;
                  break;
                }

                item = fixedMarket[j];

                if (!(item.from === quoteParams.from && item.to === quoteParams.to)) {
                  _context.next = 51;
                  break;
                }

                pairItem = item; // lets get the quoteObject here

                _context.next = 44;
                return get("exchange-amount/fixed-rate/".concat(quoteParams.amount, "/").concat(quoteParams.from, "_").concat(quoteParams.to, "?api_key=").concat(apiKey) + (promoCode != null ? "&promo=".concat(promoCode) : ''));

              case 44:
                _quoteReply = _context.sent;

                if (!(_quoteReply.error === 'out_of_range')) {
                  _context.next = 48;
                  break;
                }

                meetsFixedRateRange = false;
                return _context.abrupt("break", 54);

              case 48:
                if (!_quoteReply.error) {
                  _context.next = 50;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

              case 50:
                quoteReplyKeep = _quoteReply;

              case 51:
                j++;
                _context.next = 38;
                break;

              case 54:
                if (!(pairItem && meetsFixedRateRange)) {
                  _context.next = 78;
                  break;
                }

                if (!(request.quoteFor === 'from')) {
                  _context.next = 60;
                  break;
                }

                fromAmount = quoteAmount;
                fromNativeAmount = request.nativeAmount;
                _context.next = 64;
                break;

              case 60:
                fromAmount = (0,biggystring__WEBPACK_IMPORTED_MODULE_0__.mul)(quoteReplyKeep.estimatedAmount.toString(), '1.02');
                _context.next = 63;
                return request.fromWallet.denominationToNative(fromAmount, request.fromCurrencyCode);

              case 63:
                fromNativeAmount = _context.sent;

              case 64:
                _context.t3 = asCreateOrderReply;
                _context.next = 67;
                return post("transactions/fixed-rate/".concat(apiKey), {
                  amount: fromAmount,
                  from: safeFromCurrencyCode,
                  to: safeToCurrencyCode,
                  address: toAddress,
                  extraId: null,
                  // TODO: Do we need this for Monero?
                  refundAddress: fromAddress,
                  payload: {
                    promoCode: promoCode
                  }
                });

              case 67:
                _context.t4 = _context.sent;
                _sendReply = (0, _context.t3)(_context.t4);
                _context.next = 71;
                return request.toWallet.denominationToNative(_sendReply.amount.toString(), request.toCurrencyCode);

              case 71:
                _toAmount = _context.sent;
                _spendInfo = {
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: fromNativeAmount,
                    publicAddress: _sendReply.payinAddress,
                    uniqueIdentifier: _sendReply.payinExtraId
                  }],
                  networkFeeOption: request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                  swapData: {
                    orderId: _sendReply.id,
                    orderUri: orderUri + _sendReply.id,
                    isEstimate: false,
                    payoutAddress: toAddress,
                    payoutCurrencyCode: request.toCurrencyCode,
                    payoutNativeAmount: _toAmount,
                    payoutWalletId: request.toWallet.id,
                    plugin: _objectSpread({}, swapInfo),
                    refundAddress: fromAddress
                  }
                };
                log('spendInfo', _spendInfo);
                _context.next = 76;
                return request.fromWallet.makeSpend(_spendInfo);

              case 76:
                _tx = _context.sent;
                return _context.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.makeSwapPluginQuote)(request, fromNativeAmount, _toAmount, _tx, toAddress, pluginId, false, (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.ensureInFuture)(_sendReply.validUntil), _sendReply.id));

              case 78:
                i++;
                _context.next = 31;
                break;

              case 81:
                if (!(pairsToUse.length === 0)) {
                  _context.next = 83;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

              case 83:
                _context.next = 85;
                return get("min-amount/".concat(quoteParams.from, "_").concat(quoteParams.to));

              case 85:
                min = _context.sent;

                if (!(min.minAmount == null)) {
                  _context.next = 88;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

              case 88:
                _context.next = 90;
                return Promise.all([request.fromWallet.denominationToNative(min.minAmount.toString(), request.fromCurrencyCode)]);

              case 90:
                _yield$Promise$all3 = _context.sent;
                _yield$Promise$all4 = _slicedToArray(_yield$Promise$all3, 1);
                nativeMin = _yield$Promise$all4[0];
                _context.next = 95;
                return get("exchange-amount/".concat(quoteParams.amount, "/").concat(quoteParams.from, "_").concat(quoteParams.to));

              case 95:
                quoteReply = _context.sent;

                if (!quoteReply.error) {
                  _context.next = 100;
                  break;
                }

                log('reply error ', quoteReply.error);

                if (!(quoteReply.error === 'deposit_too_small')) {
                  _context.next = 100;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapBelowLimitError(swapInfo, nativeMin);

              case 100:
                log('got reply  ', quoteReply);

                if (!(request.quoteFor === 'from')) {
                  _context.next = 106;
                  break;
                }

                fromAmount = quoteAmount;
                fromNativeAmount = request.nativeAmount;
                _context.next = 110;
                break;

              case 106:
                fromAmount = (0,biggystring__WEBPACK_IMPORTED_MODULE_0__.mul)(quoteReply.estimatedAmount.toString(), '1.02');
                _context.next = 109;
                return request.fromWallet.denominationToNative(fromAmount, request.fromCurrencyCode);

              case 109:
                fromNativeAmount = _context.sent;

              case 110:
                log('estQuery quoteReply  ', quoteReply);

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(fromNativeAmount, nativeMin)) {
                  _context.next = 113;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_2__.SwapBelowLimitError(swapInfo, nativeMin);

              case 113:
                _context.t5 = asCreateOrderReply;
                _context.next = 116;
                return post("transactions/".concat(apiKey), {
                  amount: fromAmount,
                  from: safeFromCurrencyCode.toLowerCase(),
                  to: safeToCurrencyCode.toLowerCase(),
                  address: toAddress,
                  extraId: null,
                  // TODO: Do we need this for Monero?
                  refundAddress: fromAddress,
                  payload: {
                    promoCode: promoCode
                  }
                });

              case 116:
                _context.t6 = _context.sent;
                sendReply = (0, _context.t5)(_context.t6);
                _context.next = 120;
                return request.toWallet.denominationToNative(sendReply.amount.toString(), request.toCurrencyCode);

              case 120:
                toAmount = _context.sent;
                // Make the transaction:
                spendInfo = {
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: fromNativeAmount,
                    publicAddress: sendReply.payinAddress,
                    uniqueIdentifier: sendReply.payinExtraId
                  }],
                  networkFeeOption: request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                  swapData: {
                    orderId: sendReply.id,
                    orderUri: orderUri + sendReply.id,
                    isEstimate: true,
                    payoutAddress: toAddress,
                    payoutCurrencyCode: request.toCurrencyCode,
                    payoutNativeAmount: toAmount,
                    payoutWalletId: request.toWallet.id,
                    plugin: _objectSpread({}, swapInfo),
                    refundAddress: fromAddress
                  }
                };
                log('spendInfo', spendInfo);
                _context.next = 125;
                return request.fromWallet.makeSpend(spendInfo);

              case 125:
                tx = _context.sent;
                return _context.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_3__.makeSwapPluginQuote)(request, fromNativeAmount, toAmount, tx, toAddress, pluginId, true, new Date(Date.now() + 1000 * 60 * 20), sendReply.id));

              case 127:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }
  };
  return out;
}
/**
 * An optional value, where a blank string means undefined.
 */

function asOptionalBlank(cleaner) {
  return function asIgnoredBlank(raw) {
    if (raw == null || raw === '') return;
    return cleaner(raw);
  };
}
var asFixedMarketReply = (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asArray)((0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
  from: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  to: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  min: cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber,
  max: cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber,
  rate: cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber,
  minerFee: cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber
}));
var asCreateOrderReply = (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asObject)({
  amount: cleaners__WEBPACK_IMPORTED_MODULE_1__.asNumber,
  fromCurrency: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  toCurrency: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  id: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  payinAddress: cleaners__WEBPACK_IMPORTED_MODULE_1__.asString,
  payinExtraId: asOptionalBlank(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  payoutAddress: asOptionalBlank(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  payoutExtraId: asOptionalBlank(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  refundAddress: asOptionalBlank(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  refundExtraId: asOptionalBlank(cleaners__WEBPACK_IMPORTED_MODULE_1__.asString),
  validUntil: (0,cleaners__WEBPACK_IMPORTED_MODULE_1__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_1__.asDate)
});

/***/ }),

/***/ "./src/swap/exolix.js":
/*!****************************!*\
  !*** ./src/swap/exolix.js ***!
  \****************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeExolixPlugin": function() { return /* binding */ makeExolixPlugin; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }




var INVALID_CURRENCY_CODES = {
  from: {
    ETH: ['MATIC'],
    MATIC: 'allTokens',
    FTM: 'allCodes'
  },
  to: {
    ETH: ['MATIC'],
    MATIC: 'allTokens',
    FTM: 'allCodes',
    ZEC: ['ZEC']
  }
}; // Invalid currency codes should *not* have transcribed codes
// because currency codes with transcribed versions are NOT invalid

var CURRENCY_CODE_TRANSCRIPTION = {
  // Edge currencyCode: exchangeCurrencyCode
  ETH: {
    USDT: 'USDT20'
  }
};
var pluginId = 'exolix';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Exolix',
  supportEmail: 'support@exolix.com'
};
var orderUri = 'https://exolix.com/transaction/';
var uri = 'https://exolix.com/api/';
var expirationMs = 1000 * 60 * 60;
var dontUseLegacy = {
  DGB: true
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context4.sent;
            return _context4.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _getAddress.apply(this, arguments);
}

function makeExolixPlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;

  if (initOptions.apiKey == null) {
    throw new Error('No Exolix apiKey provided.');
  }

  var apiKey = initOptions.apiKey;

  function call(_x3, _x4) {
    return _call.apply(this, arguments);
  }

  function _call() {
    _call = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(route, params) {
      var body, headers, response;
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              body = JSON.stringify(params);
              headers = {
                Accept: 'application/json',
                'Content-Type': 'application/json',
                Authorization: "".concat(apiKey)
              };
              _context3.next = 4;
              return fetchCors(uri + route, {
                method: 'POST',
                body: body,
                headers: headers
              });

            case 4:
              response = _context3.sent;

              if (response.ok) {
                _context3.next = 9;
                break;
              }

              if (!(response.status === 422)) {
                _context3.next = 8;
                break;
              }

              throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapCurrencyError(swapInfo, params.coin_from, params.coin_to);

            case 8:
              throw new Error("Exolix returned error code ".concat(response.status));

            case 9:
              return _context3.abrupt("return", response.json());

            case 10:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return _call.apply(this, arguments);
  }

  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings) {
      var _this = this;

      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var fixedPromise, fixedResult;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo);
                fixedPromise = _this.getFixedQuote(request, userSettings);
                _context.next = 4;
                return fixedPromise;

              case 4:
                fixedResult = _context.sent;
                return _context.abrupt("return", fixedResult);

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    getFixedQuote: function getFixedQuote(request, userSettings) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
        var _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, quoteAmount, _safeCurrencyCodes, safeFromCurrencyCode, safeToCurrencyCode, quoteParams, rateResponse, nativeMin, exchangeParams, quoteInfo, fromNativeAmount, toNativeAmount, spendInfo, tx;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 2:
                _yield$Promise$all = _context2.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];

                if (!(request.quoteFor === 'from')) {
                  _context2.next = 12;
                  break;
                }

                _context2.next = 9;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 9:
                _context2.t0 = _context2.sent;
                _context2.next = 15;
                break;

              case 12:
                _context2.next = 14;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 14:
                _context2.t0 = _context2.sent;

              case 15:
                quoteAmount = _context2.t0;
                _safeCurrencyCodes = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.safeCurrencyCodes)(CURRENCY_CODE_TRANSCRIPTION, request), safeFromCurrencyCode = _safeCurrencyCodes.safeFromCurrencyCode, safeToCurrencyCode = _safeCurrencyCodes.safeToCurrencyCode; // Swap the currencies if we need a reverse quote:

                quoteParams = request.quoteFor === 'from' ? {
                  coin_from: safeFromCurrencyCode,
                  coin_to: safeToCurrencyCode,
                  deposit_amount: quoteAmount,
                  rate_type: 'fixed'
                } : {
                  coin_from: safeToCurrencyCode,
                  coin_to: safeFromCurrencyCode,
                  deposit_amount: quoteAmount,
                  rate_type: 'fixed'
                }; // Get Rate

                _context2.next = 20;
                return call('rate', quoteParams);

              case 20:
                rateResponse = _context2.sent;
                _context2.next = 23;
                return request.fromWallet.denominationToNative(rateResponse.min_amount, request.fromCurrencyCode);

              case 23:
                nativeMin = _context2.sent;

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(request.nativeAmount, nativeMin)) {
                  _context2.next = 26;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapBelowLimitError(swapInfo, nativeMin);

              case 26:
                // Make the transaction:
                exchangeParams = {
                  coin_from: quoteParams.coin_from,
                  coin_to: quoteParams.coin_to,
                  deposit_amount: quoteAmount,
                  destination_address: toAddress,
                  destination_extra: '',
                  refund_address: fromAddress,
                  refund_extra: '',
                  rate_type: 'fixed'
                };
                _context2.next = 29;
                return call('exchange', exchangeParams);

              case 29:
                quoteInfo = _context2.sent;
                _context2.next = 32;
                return request.fromWallet.denominationToNative(quoteInfo.amount_from.toString(), request.fromCurrencyCode);

              case 32:
                fromNativeAmount = _context2.sent;
                _context2.next = 35;
                return request.fromWallet.denominationToNative(quoteInfo.amount_to.toString(), request.toCurrencyCode);

              case 35:
                toNativeAmount = _context2.sent;
                spendInfo = {
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: fromNativeAmount,
                    publicAddress: quoteInfo.deposit_address,
                    uniqueIdentifier: quoteInfo.deposit_extra || undefined
                  }],
                  networkFeeOption: request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                  swapData: {
                    orderId: quoteInfo.id,
                    orderUri: orderUri + quoteInfo.id,
                    isEstimate: false,
                    payoutAddress: toAddress,
                    payoutCurrencyCode: request.toCurrencyCode,
                    payoutNativeAmount: toNativeAmount,
                    payoutWalletId: request.toWallet.id,
                    plugin: _objectSpread({}, swapInfo),
                    refundAddress: fromAddress
                  }
                };
                _context2.next = 39;
                return request.fromWallet.makeSpend(spendInfo);

              case 39:
                tx = _context2.sent;
                return _context2.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.makeSwapPluginQuote)(request, fromNativeAmount, toNativeAmount, tx, toAddress, pluginId, false, new Date(Date.now() + expirationMs), quoteInfo.id));

              case 41:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/foxExchange.js":
/*!*********************************!*\
  !*** ./src/swap/foxExchange.js ***!
  \*********************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeFoxExchangePlugin": function() { return /* binding */ makeFoxExchangePlugin; }
/* harmony export */ });
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _swap_helpers__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../swap-helpers */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }



var pluginId = 'foxExchange';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Fox Exchange',
  supportEmail: 'support@fox.exchange'
};
var orderUri = 'https://fox.exchange/tx/';
var uri = 'https://fox.exchange/api/cs';
var expirationMs = 1000 * 60 * 20;
var INVALID_CURRENCY_CODES = {
  from: {
    ETH: ['MATIC'],
    FTM: 'allCodes',
    MATIC: 'allTokens'
  },
  to: {
    ETH: ['MATIC'],
    FTM: 'allCodes',
    MATIC: 'allTokens',
    ZEC: ['ZEC']
  }
};
var dontUseLegacy = {
  DGB: true,
  LTC: true,
  BCH: true
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context5.sent;
            return _context5.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _getAddress.apply(this, arguments);
}

function makeFoxExchangePlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;

  if (initOptions.apiKey == null) {
    throw new Error('No fox.exchange apiKey provided.');
  }

  var apiKey = initOptions.apiKey;
  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        var post, _post, rateReq, rateResp, sourceAmount, targetAmount, dummyAddress, dummyTx, destinationAddress, quote;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _post = function _post3() {
                  _post = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(path, data) {
                    var body, response, json;
                    return regeneratorRuntime.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            log("request to ".concat(path), data);
                            body = JSON.stringify(data);
                            _context3.next = 4;
                            return fetchCors("".concat(uri).concat(path), {
                              method: 'POST',
                              body: body,
                              headers: {
                                'Content-Type': 'application/json',
                                Accept: 'application/json',
                                'X-API-Key': apiKey,
                                'X-User-IP': 'same_as_requester'
                              }
                            });

                          case 4:
                            response = _context3.sent;
                            _context3.next = 7;
                            return response.json();

                          case 7:
                            json = _context3.sent;
                            log("reply to ".concat(path, " (").concat(response.status, ")"), json);

                            if (json) {
                              _context3.next = 13;
                              break;
                            }

                            throw new Error("fox returned error code ".concat(response.status));

                          case 13:
                            if (json.success) {
                              _context3.next = 30;
                              break;
                            }

                            if (!(json.code === 'invalid_symbol' || json.code === 'trade_pair_disabled')) {
                              _context3.next = 18;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

                          case 18:
                            if (!(json.code === 'region_lock')) {
                              _context3.next = 22;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapPermissionError(swapInfo, 'geoRestriction');

                          case 22:
                            if (!(json.code === 'min_limit_breached')) {
                              _context3.next = 26;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapBelowLimitError(swapInfo, request.nativeAmount);

                          case 26:
                            if (!(json.code === 'max_limit_breached')) {
                              _context3.next = 28;
                              break;
                            }

                            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapAboveLimitError(swapInfo, request.nativeAmount);

                          case 28:
                            log.error('error:', json);
                            throw new Error('fox.exchange replied: ' + json.error || 0);

                          case 30:
                            return _context3.abrupt("return", json.data);

                          case 31:
                          case "end":
                            return _context3.stop();
                        }
                      }
                    }, _callee3);
                  }));
                  return _post.apply(this, arguments);
                };

                post = function _post2(_x3, _x4) {
                  return _post.apply(this, arguments);
                };

                (0,_swap_helpers__WEBPACK_IMPORTED_MODULE_1__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo);
                _context4.prev = 3;
                rateReq = {
                  depositCoin: request.fromCurrencyCode,
                  destinationCoin: request.toCurrencyCode,
                  requestFixed: true,
                  requestDummyAddress: true
                };

                if (!(request.quoteFor === 'from')) {
                  _context4.next = 13;
                  break;
                }

                _context4.t0 = Number;
                _context4.next = 9;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 9:
                _context4.t1 = _context4.sent;
                rateReq.depositCoinAmount = (0, _context4.t0)(_context4.t1);
                _context4.next = 18;
                break;

              case 13:
                _context4.t2 = Number;
                _context4.next = 16;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 16:
                _context4.t3 = _context4.sent;
                rateReq.destinationCoinAmount = (0, _context4.t2)(_context4.t3);

              case 18:
                _context4.next = 20;
                return post('/rate', rateReq);

              case 20:
                rateResp = _context4.sent;

                if (!(request.quoteFor === 'from')) {
                  _context4.next = 47;
                  break;
                }

                if (!rateResp.destinationCoinAmount) {
                  _context4.next = 26;
                  break;
                }

                targetAmount = rateResp.destinationCoinAmount;
                _context4.next = 45;
                break;

              case 26:
                if (!(rateReq.depositCoinAmount && rateResp.limitMinDepositCoin && rateReq.depositCoinAmount < rateResp.limitMinDepositCoin)) {
                  _context4.next = 35;
                  break;
                }

                _context4.t4 = edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapBelowLimitError;
                _context4.t5 = swapInfo;
                _context4.next = 31;
                return request.fromWallet.denominationToNative(String(rateResp.limitMinDepositCoin), request.fromCurrencyCode);

              case 31:
                _context4.t6 = _context4.sent;
                throw new _context4.t4(_context4.t5, _context4.t6);

              case 35:
                if (!(rateReq.depositCoinAmount && rateResp.limitMaxDepositCoin && rateReq.depositCoinAmount > rateResp.limitMaxDepositCoin)) {
                  _context4.next = 44;
                  break;
                }

                _context4.t7 = edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapAboveLimitError;
                _context4.t8 = swapInfo;
                _context4.next = 40;
                return request.fromWallet.denominationToNative(String(rateResp.limitMaxDepositCoin), request.fromCurrencyCode);

              case 40:
                _context4.t9 = _context4.sent;
                throw new _context4.t7(_context4.t8, _context4.t9);

              case 44:
                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

              case 45:
                _context4.next = 70;
                break;

              case 47:
                if (!rateResp.depositCoinAmount) {
                  _context4.next = 51;
                  break;
                }

                sourceAmount = rateResp.depositCoinAmount;
                _context4.next = 70;
                break;

              case 51:
                if (!(rateReq.destinationCoinAmount && rateResp.limitMinDestinationCoin && rateReq.destinationCoinAmount < rateResp.limitMinDestinationCoin)) {
                  _context4.next = 60;
                  break;
                }

                _context4.t10 = edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapBelowLimitError;
                _context4.t11 = swapInfo;
                _context4.next = 56;
                return request.toWallet.denominationToNative(String(rateResp.limitMinDestinationCoin), request.toCurrencyCode);

              case 56:
                _context4.t12 = _context4.sent;
                throw new _context4.t10(_context4.t11, _context4.t12);

              case 60:
                if (!(rateReq.destinationCoinAmount && rateResp.limitMaxDestinationCoin && rateReq.destinationCoinAmount > rateResp.limitMaxDestinationCoin)) {
                  _context4.next = 69;
                  break;
                }

                _context4.t13 = edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapAboveLimitError;
                _context4.t14 = swapInfo;
                _context4.next = 65;
                return request.toWallet.denominationToNative(String(rateResp.limitMaxDestinationCoin), request.toCurrencyCode);

              case 65:
                _context4.t15 = _context4.sent;
                throw new _context4.t13(_context4.t14, _context4.t15);

              case 69:
                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

              case 70:
                _context4.t16 = rateResp.dummyAddress;

                if (_context4.t16) {
                  _context4.next = 80;
                  break;
                }

                if (!(request.fromCurrencyCode === 'ETH')) {
                  _context4.next = 76;
                  break;
                }

                _context4.t17 = '0x0000000000000000000000000000000000000000';
                _context4.next = 79;
                break;

              case 76:
                _context4.next = 78;
                return getAddress(request.fromWallet, request.fromCurrencyCode);

              case 78:
                _context4.t17 = _context4.sent;

              case 79:
                _context4.t16 = _context4.t17;

              case 80:
                dummyAddress = _context4.t16;
                _context4.t18 = request.fromWallet;
                _context4.t19 = request.fromCurrencyCode;

                if (!(request.quoteFor === 'from')) {
                  _context4.next = 87;
                  break;
                }

                _context4.t20 = request.nativeAmount;
                _context4.next = 90;
                break;

              case 87:
                _context4.next = 89;
                return request.fromWallet.denominationToNative(String(sourceAmount), request.fromCurrencyCode);

              case 89:
                _context4.t20 = _context4.sent;

              case 90:
                _context4.t21 = _context4.t20;
                _context4.t22 = dummyAddress;
                _context4.t23 = {
                  nativeAmount: _context4.t21,
                  publicAddress: _context4.t22
                };
                _context4.t24 = [_context4.t23];
                _context4.t25 = request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard';
                _context4.t26 = {
                  currencyCode: _context4.t19,
                  spendTargets: _context4.t24,
                  networkFeeOption: _context4.t25
                };
                _context4.next = 98;
                return _context4.t18.makeSpend.call(_context4.t18, _context4.t26);

              case 98:
                dummyTx = _context4.sent;
                _context4.next = 101;
                return getAddress(request.toWallet, request.toCurrencyCode);

              case 101:
                destinationAddress = _context4.sent;

                if (!(request.quoteFor === 'from')) {
                  _context4.next = 106;
                  break;
                }

                _context4.t27 = request.nativeAmount;
                _context4.next = 109;
                break;

              case 106:
                _context4.next = 108;
                return request.fromWallet.denominationToNative(String(sourceAmount), request.fromCurrencyCode);

              case 108:
                _context4.t27 = _context4.sent;

              case 109:
                _context4.t28 = _context4.t27;

                if (!(request.quoteFor === 'from')) {
                  _context4.next = 116;
                  break;
                }

                _context4.next = 113;
                return request.toWallet.denominationToNative(String(targetAmount), request.toCurrencyCode);

              case 113:
                _context4.t29 = _context4.sent;
                _context4.next = 117;
                break;

              case 116:
                _context4.t29 = request.nativeAmount;

              case 117:
                _context4.t30 = _context4.t29;
                _context4.t31 = {
                  currencyCode: request.fromWallet.currencyInfo.currencyCode,
                  nativeAmount: dummyTx.parentNetworkFee != null ? dummyTx.parentNetworkFee : dummyTx.networkFee
                };
                _context4.t32 = destinationAddress;
                _context4.t33 = pluginId;
                _context4.t34 = new Date(rateResp.validTill || Date.now() + expirationMs);
                _context4.t35 = rateResp.futureOrderId;
                _context4.t36 = !rateResp.quoteToken;

                _context4.t37 = function approve() {
                  return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                    var orderResp, tx, signedTransaction, broadcastedTransaction;
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            _context.next = 2;
                            return post('/order', {
                              depositCoin: request.fromCurrencyCode,
                              destinationCoin: request.toCurrencyCode,
                              depositCoinAmount: rateReq.depositCoinAmount || rateResp.depositCoinAmount,
                              destinationAddress: {
                                address: destinationAddress,
                                tag: null
                              },
                              futureOrderId: rateResp.futureOrderId,
                              quoteToken: rateResp.quoteToken
                            });

                          case 2:
                            orderResp = _context.sent;
                            log("transaction ID: ".concat(orderResp.orderId));
                            _context.t0 = request.fromWallet;
                            _context.t1 = request.fromCurrencyCode;
                            _context.next = 8;
                            return request.fromWallet.denominationToNative(String(orderResp.expectedDepositCoinAmount), request.fromCurrencyCode);

                          case 8:
                            _context.t2 = _context.sent;
                            _context.t3 = orderResp.exchangeAddress.address;
                            _context.t4 = orderResp.exchangeAddress.tag || undefined;
                            _context.t5 = {
                              nativeAmount: _context.t2,
                              publicAddress: _context.t3,
                              uniqueIdentifier: _context.t4
                            };
                            _context.t6 = [_context.t5];
                            _context.t7 = request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard';
                            _context.t8 = {
                              orderId: rateResp.futureOrderId,
                              orderUri: orderUri + rateResp.futureOrderId,
                              isEstimate: !rateResp.quoteToken,
                              payoutAddress: destinationAddress,
                              payoutCurrencyCode: request.toCurrencyCode,
                              payoutNativeAmount: quote.toNativeAmount,
                              payoutWalletId: request.toWallet.id,
                              plugin: _objectSpread({}, swapInfo),
                              refundAddress: undefined
                            };
                            _context.t9 = {
                              currencyCode: _context.t1,
                              spendTargets: _context.t6,
                              networkFeeOption: _context.t7,
                              swapData: _context.t8
                            };
                            _context.next = 18;
                            return _context.t0.makeSpend.call(_context.t0, _context.t9);

                          case 18:
                            tx = _context.sent;
                            _context.next = 21;
                            return request.fromWallet.signTx(tx);

                          case 21:
                            signedTransaction = _context.sent;
                            _context.next = 24;
                            return request.fromWallet.broadcastTx(signedTransaction);

                          case 24:
                            broadcastedTransaction = _context.sent;
                            _context.next = 27;
                            return request.fromWallet.saveTx(signedTransaction);

                          case 27:
                            return _context.abrupt("return", {
                              transaction: broadcastedTransaction,
                              orderId: rateResp.futureOrderId,
                              destinationAddress: destinationAddress
                            });

                          case 28:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee);
                  }))();
                };

                _context4.t38 = function close() {
                  return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                    return regeneratorRuntime.wrap(function _callee2$(_context2) {
                      while (1) {
                        switch (_context2.prev = _context2.next) {
                          case 0:
                            _context2.prev = 0;
                            _context2.next = 3;
                            return post('/cancelQuote', {
                              futureOrderId: rateResp.futureOrderId,
                              quoteToken: rateResp.quoteToken
                            });

                          case 3:
                            _context2.next = 7;
                            break;

                          case 5:
                            _context2.prev = 5;
                            _context2.t0 = _context2["catch"](0);

                          case 7:
                          case "end":
                            return _context2.stop();
                        }
                      }
                    }, _callee2, null, [[0, 5]]);
                  }))();
                };

                quote = {
                  fromNativeAmount: _context4.t28,
                  toNativeAmount: _context4.t30,
                  networkFee: _context4.t31,
                  destinationAddress: _context4.t32,
                  pluginId: _context4.t33,
                  expirationDate: _context4.t34,
                  quoteId: _context4.t35,
                  isEstimate: _context4.t36,
                  approve: _context4.t37,
                  close: _context4.t38
                };
                return _context4.abrupt("return", quote);

              case 130:
                _context4.prev = 130;
                _context4.t39 = _context4["catch"](3);
                log("exception", _context4.t39);
                throw _context4.t39;

              case 134:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, null, [[3, 130]]);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/godex.js":
/*!***************************!*\
  !*** ./src/swap/godex.js ***!
  \***************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeGodexPlugin": function() { return /* binding */ makeGodexPlugin; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }




var pluginId = 'godex';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Godex',
  supportEmail: 'support@godex.io'
};
var orderUri = 'https://godex.io/exchange/waiting/';
var uri = 'https://api.godex.io/api/v1/';
var expirationMs = 1000 * 60 * 20;
var dontUseLegacy = {
  DGB: true
};
var INVALID_CURRENCY_CODES = {
  from: {
    ETH: ['MATIC'],
    FTM: 'allCodes',
    MATIC: 'allTokens'
  },
  to: {
    ETH: ['MATIC'],
    FTM: 'allCodes',
    MATIC: 'allTokens',
    ZEC: ['ZEC']
  }
}; // Network names that don't match parent network currency code

var networks = {
  RBTC: 'RSK'
};

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(wallet, currencyCode) {
    var addressInfo;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context3.sent;
            return _context3.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _getAddress.apply(this, arguments);
}

function makeGodexPlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io,
      log = opts.log;
  var _io$fetchCors = io.fetchCors,
      fetchCors = _io$fetchCors === void 0 ? io.fetch : _io$fetchCors;

  function call(_x3, _x4, _x5) {
    return _call.apply(this, arguments);
  }

  function _call() {
    _call = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(url, request, data) {
      var body, headers, response;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              body = JSON.stringify(data.params);
              headers = {
                'Content-Type': 'application/json',
                Accept: 'application/json'
              };
              _context2.next = 4;
              return fetchCors(url, {
                method: 'POST',
                body: body,
                headers: headers
              });

            case 4:
              response = _context2.sent;

              if (response.ok) {
                _context2.next = 9;
                break;
              }

              if (!(response.status === 422)) {
                _context2.next = 8;
                break;
              }

              throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

            case 8:
              throw new Error("godex returned error code ".concat(response.status));

            case 9:
              return _context2.abrupt("return", response.json());

            case 10:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));
    return _call.apply(this, arguments);
  }

  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _networks$request$fro, _networks$request$toW;

        var _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, quoteAmount, quoteParams, fromAmount, fromNativeAmount, toNativeAmount, reply, nativeMin, promoCode, sendReply, quoteInfo, spendInfo, tx;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo); // Grab addresses:

                _context.next = 3;
                return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

              case 3:
                _yield$Promise$all = _context.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];

                if (!(request.quoteFor === 'from')) {
                  _context.next = 13;
                  break;
                }

                _context.next = 10;
                return request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode);

              case 10:
                _context.t0 = _context.sent;
                _context.next = 16;
                break;

              case 13:
                _context.next = 15;
                return request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

              case 15:
                _context.t0 = _context.sent;

              case 16:
                quoteAmount = _context.t0;
                // Swap the currencies if we need a reverse quote:
                quoteParams = {
                  from: request.fromCurrencyCode,
                  to: request.toCurrencyCode,
                  amount: quoteAmount
                };
                log('quoteParams:', quoteParams); // Calculate the amounts:

                if (!(request.quoteFor === 'from')) {
                  _context.next = 30;
                  break;
                }

                _context.next = 22;
                return call(uri + 'info', request, {
                  params: quoteParams
                });

              case 22:
                reply = _context.sent;
                fromAmount = quoteAmount;
                fromNativeAmount = request.nativeAmount;
                _context.next = 27;
                return request.toWallet.denominationToNative(reply.amount.toString(), request.toCurrencyCode);

              case 27:
                toNativeAmount = _context.sent;
                _context.next = 38;
                break;

              case 30:
                _context.next = 32;
                return call(uri + 'info-revert', request, {
                  params: quoteParams
                });

              case 32:
                reply = _context.sent;
                fromAmount = reply.amount;
                _context.next = 36;
                return request.fromWallet.denominationToNative(fromAmount.toString(), request.fromCurrencyCode);

              case 36:
                fromNativeAmount = _context.sent;
                toNativeAmount = request.nativeAmount;

              case 38:
                log('fromNativeAmount' + fromNativeAmount);
                log('toNativeAmount' + toNativeAmount); // Check the minimum:

                _context.next = 42;
                return request.fromWallet.denominationToNative(reply.min_amount, request.fromCurrencyCode);

              case 42:
                nativeMin = _context.sent;

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(fromNativeAmount, nativeMin)) {
                  _context.next = 45;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapBelowLimitError(swapInfo, nativeMin);

              case 45:
                promoCode = opts.promoCode;
                _context.next = 48;
                return call(uri + 'transaction' + (promoCode != null ? "?promo=".concat(promoCode) : ''), request, {
                  params: {
                    deposit_amount: fromAmount,
                    coin_from: request.fromCurrencyCode,
                    coin_to: request.toCurrencyCode,
                    withdrawal: toAddress,
                    "return": fromAddress,
                    // return_extra_id: 'empty',
                    // withdrawal_extra_id: 'empty',
                    return_extra_id: null,
                    withdrawal_extra_id: null,
                    affiliate_id: initOptions.apiKey,
                    type: 'edge',
                    isEstimate: false,
                    coin_from_network: (_networks$request$fro = networks[request.fromWallet.currencyInfo.currencyCode]) !== null && _networks$request$fro !== void 0 ? _networks$request$fro : request.fromWallet.currencyInfo.currencyCode,
                    coin_to_network: (_networks$request$toW = networks[request.toWallet.currencyInfo.currencyCode]) !== null && _networks$request$toW !== void 0 ? _networks$request$toW : request.toWallet.currencyInfo.currencyCode
                  }
                });

              case 48:
                sendReply = _context.sent;
                log('sendReply' + sendReply);
                quoteInfo = sendReply; // Make the transaction:

                spendInfo = {
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: fromNativeAmount,
                    publicAddress: quoteInfo.deposit,
                    uniqueIdentifier: quoteInfo.deposit_extra_id
                  }],
                  networkFeeOption: request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                  swapData: {
                    orderId: quoteInfo.transaction_id,
                    orderUri: orderUri + quoteInfo.transaction_id,
                    isEstimate: false,
                    payoutAddress: toAddress,
                    payoutCurrencyCode: request.toCurrencyCode,
                    payoutNativeAmount: toNativeAmount,
                    payoutWalletId: request.toWallet.id,
                    plugin: _objectSpread({}, swapInfo),
                    refundAddress: fromAddress
                  }
                };
                log('spendInfo', spendInfo);
                _context.next = 55;
                return request.fromWallet.makeSpend(spendInfo);

              case 55:
                tx = _context.sent;
                return _context.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.makeSwapPluginQuote)(request, fromNativeAmount, toNativeAmount, tx, toAddress, 'godex', false, // isEstimate, correct?
                new Date(Date.now() + expirationMs), quoteInfo.transaction_id));

              case 57:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/sideshift.js":
/*!*******************************!*\
  !*** ./src/swap/sideshift.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeSideshiftPlugin": function() { return /* binding */ makeSideshiftPlugin; }
/* harmony export */ });
/* harmony import */ var cleaners__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! cleaners */ "./node_modules/cleaners/lib/index.mjs");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }



 // Invalid currency codes should *not* have transcribed codes
// because currency codes with transcribed versions are NOT invalid

var CURRENCY_CODE_TRANSCRIPTION = {
  // Edge currencyCode: exchangeCurrencyCode
  ETH: {
    USDT: 'usdtErc20'
  },
  ZEC: {
    ZEC: 'zaddr'
  }
};
var INVALID_CURRENCY_CODES = {
  from: {
    ETH: ['FTM', 'MATIC'],
    FTM: 'allCodes',
    MATIC: 'allTokens'
  },
  to: {
    ETH: ['FTM', 'MATIC'],
    FTM: 'allCodes',
    MATIC: 'allTokens'
  }
};
var SIDESHIFT_BASE_URL = 'https://sideshift.ai/api/v1';
var pluginId = 'sideshift';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'SideShift.ai',
  supportEmail: 'help@sideshift.ai'
};
var ORDER_STATUS_URL = 'https://sideshift.ai/orders/';

function getAddress(_x, _x2) {
  return _getAddress.apply(this, arguments);
}

function _getAddress() {
  _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(wallet, currencyCode) {
    var _addressInfo$segwitAd;

    var addressInfo;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return wallet.getReceiveAddress({
              currencyCode: currencyCode
            });

          case 2:
            addressInfo = _context3.sent;
            return _context3.abrupt("return", (_addressInfo$segwitAd = addressInfo.segwitAddress) !== null && _addressInfo$segwitAd !== void 0 ? _addressInfo$segwitAd : addressInfo.publicAddress);

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _getAddress.apply(this, arguments);
}

function checkQuoteError(_x3, _x4, _x5) {
  return _checkQuoteError.apply(this, arguments);
}

function _checkQuoteError() {
  _checkQuoteError = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(rate, request, quoteErrorMessage) {
    var fromCurrencyCode, fromWallet, toCurrencyCode, nativeMin, nativeMax;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            fromCurrencyCode = request.fromCurrencyCode, fromWallet = request.fromWallet, toCurrencyCode = request.toCurrencyCode;

            if (!(quoteErrorMessage === 'Amount too low')) {
              _context4.next = 6;
              break;
            }

            _context4.next = 4;
            return fromWallet.denominationToNative(rate.min, fromCurrencyCode);

          case 4:
            nativeMin = _context4.sent;
            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapBelowLimitError(swapInfo, nativeMin);

          case 6:
            if (!(quoteErrorMessage === 'Amount too high')) {
              _context4.next = 11;
              break;
            }

            _context4.next = 9;
            return fromWallet.denominationToNative(rate.max, fromCurrencyCode);

          case 9:
            nativeMax = _context4.sent;
            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapAboveLimitError(swapInfo, nativeMax);

          case 11:
            if (!(/method/i.test(quoteErrorMessage) && /disabled/i.test(quoteErrorMessage))) {
              _context4.next = 13;
              break;
            }

            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapCurrencyError(swapInfo, fromCurrencyCode, toCurrencyCode);

          case 13:
            if (!/country-blocked/i.test(quoteErrorMessage)) {
              _context4.next = 15;
              break;
            }

            throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapPermissionError(swapInfo, 'geoRestriction');

          case 15:
            throw new Error("SideShift.ai error ".concat(quoteErrorMessage));

          case 16:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _checkQuoteError.apply(this, arguments);
}

var createSideshiftApi = function createSideshiftApi(baseUrl, fetch) {
  function request(_x6, _x7, _x8) {
    return _request.apply(this, arguments);
  }

  function _request() {
    _request = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(method, path, body) {
      var url, reply;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              url = "".concat(baseUrl).concat(path);
              _context.next = 3;
              return method === 'GET' ? fetch(url) : fetch(url, {
                method: method,
                headers: {
                  'Content-Type': 'application/json'
                },
                body: JSON.stringify(body)
              });

            case 3:
              reply = _context.sent;
              _context.prev = 4;
              _context.next = 7;
              return reply.json();

            case 7:
              return _context.abrupt("return", _context.sent);

            case 10:
              _context.prev = 10;
              _context.t0 = _context["catch"](4);
              throw new Error("SideShift.ai returned error code ".concat(reply.status));

            case 13:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[4, 10]]);
    }));
    return _request.apply(this, arguments);
  }

  return {
    get: function get(path) {
      return request('GET', path);
    },
    post: function post(path, body) {
      return request('POST', path, body);
    }
  };
};

var createFetchSwapQuote = function createFetchSwapQuote(api, affiliateId) {
  return /*#__PURE__*/function () {
    var _fetchSwapQuote = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(request) {
      var _order$depositAddress;

      var _yield$Promise$all, _yield$Promise$all2, depositAddress, settleAddress, _safeCurrencyCodes, safeFromCurrencyCode, safeToCurrencyCode, rate, permissions, quoteAmount, depositAmount, fixedQuoteRequest, fixedQuote, orderRequest, order, spendInfoAmount, amountExpectedFromNative, amountExpectedToNative, isEstimate, destinationTag, spendInfo, tx;

      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo);
              _context2.next = 3;
              return Promise.all([getAddress(request.fromWallet, request.fromCurrencyCode), getAddress(request.toWallet, request.toCurrencyCode)]);

            case 3:
              _yield$Promise$all = _context2.sent;
              _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
              depositAddress = _yield$Promise$all2[0];
              settleAddress = _yield$Promise$all2[1];
              _safeCurrencyCodes = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.safeCurrencyCodes)(CURRENCY_CODE_TRANSCRIPTION, request), safeFromCurrencyCode = _safeCurrencyCodes.safeFromCurrencyCode, safeToCurrencyCode = _safeCurrencyCodes.safeToCurrencyCode;
              _context2.t0 = asRate;
              _context2.next = 11;
              return api.get("/pairs/".concat(safeFromCurrencyCode, "/").concat(safeToCurrencyCode));

            case 11:
              _context2.t1 = _context2.sent;
              rate = (0, _context2.t0)(_context2.t1);

              if (!rate.error) {
                _context2.next = 15;
                break;
              }

              throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

            case 15:
              _context2.t2 = asPermissions;
              _context2.next = 18;
              return api.get('/permissions');

            case 18:
              _context2.t3 = _context2.sent;
              permissions = (0, _context2.t2)(_context2.t3);

              if (!(!permissions.createOrder || !permissions.createQuote)) {
                _context2.next = 22;
                break;
              }

              throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapPermissionError(swapInfo, 'geoRestriction');

            case 22:
              _context2.next = 24;
              return request.quoteFor === 'from' ? request.fromWallet.nativeToDenomination(request.nativeAmount, request.fromCurrencyCode) : request.toWallet.nativeToDenomination(request.nativeAmount, request.toCurrencyCode);

            case 24:
              quoteAmount = _context2.sent;
              depositAmount = request.quoteFor === 'from' ? quoteAmount : (parseFloat(quoteAmount) / parseFloat(rate.rate)).toFixed(8).toString();
              fixedQuoteRequest = asFixedQuoteRequest({
                depositMethod: safeFromCurrencyCode,
                settleMethod: safeToCurrencyCode,
                depositAmount: depositAmount
              });
              _context2.t4 = asFixedQuote;
              _context2.next = 30;
              return api.post('/quotes', fixedQuoteRequest);

            case 30:
              _context2.t5 = _context2.sent;
              fixedQuote = (0, _context2.t4)(_context2.t5);

              if (!fixedQuote.error) {
                _context2.next = 36;
                break;
              }

              _context2.next = 35;
              return checkQuoteError(rate, request, fixedQuote.error.message);

            case 35:
              throw new Error("SideShift.ai error ".concat(fixedQuote.error.message));

            case 36:
              orderRequest = asOrderRequest({
                type: 'fixed',
                quoteId: fixedQuote.id,
                affiliateId: affiliateId,
                settleAddress: settleAddress,
                refundAddress: depositAddress
              });
              _context2.t6 = asOrder;
              _context2.next = 40;
              return api.post('/orders', orderRequest);

            case 40:
              _context2.t7 = _context2.sent;
              order = (0, _context2.t6)(_context2.t7);

              if (!order.error) {
                _context2.next = 46;
                break;
              }

              _context2.next = 45;
              return checkQuoteError(rate, request, order.error.message);

            case 45:
              throw new Error("SideShift.ai error ".concat(order.error.message));

            case 46:
              _context2.next = 48;
              return request.fromWallet.denominationToNative(order.depositAmount, request.fromCurrencyCode.toUpperCase());

            case 48:
              spendInfoAmount = _context2.sent;
              _context2.next = 51;
              return request.fromWallet.denominationToNative(order.depositAmount, request.fromCurrencyCode);

            case 51:
              amountExpectedFromNative = _context2.sent;
              _context2.next = 54;
              return request.fromWallet.denominationToNative(order.settleAmount, request.toCurrencyCode);

            case 54:
              amountExpectedToNative = _context2.sent;
              isEstimate = false;
              destinationTag = order.depositAddress.destinationTag != null ? "".concat(order.depositAddress.destinationTag) : undefined;
              spendInfo = {
                currencyCode: request.fromCurrencyCode,
                spendTargets: [{
                  nativeAmount: spendInfoAmount,
                  publicAddress: order.depositAddress.address,
                  uniqueIdentifier: (_order$depositAddress = order.depositAddress.memo) !== null && _order$depositAddress !== void 0 ? _order$depositAddress : destinationTag
                }],
                networkFeeOption: request.fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                swapData: {
                  orderId: order.orderId,
                  orderUri: ORDER_STATUS_URL + order.orderId,
                  isEstimate: isEstimate,
                  payoutAddress: settleAddress,
                  payoutCurrencyCode: request.toCurrencyCode,
                  payoutNativeAmount: amountExpectedToNative,
                  payoutWalletId: request.toWallet.id,
                  plugin: _objectSpread({}, swapInfo),
                  refundAddress: depositAddress
                }
              };
              _context2.next = 60;
              return request.fromWallet.makeSpend(spendInfo);

            case 60:
              tx = _context2.sent;
              return _context2.abrupt("return", (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.makeSwapPluginQuote)(request, amountExpectedFromNative, amountExpectedToNative, tx, settleAddress, pluginId, isEstimate, (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_2__.ensureInFuture)(new Date(order.expiresAtISO)), order.id));

            case 62:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    function fetchSwapQuote(_x9) {
      return _fetchSwapQuote.apply(this, arguments);
    }

    return fetchSwapQuote;
  }();
};

function makeSideshiftPlugin(opts) {
  var io = opts.io,
      initOptions = opts.initOptions;
  var api = createSideshiftApi(SIDESHIFT_BASE_URL, io.fetchCors || io.fetch);
  var fetchSwapQuote = createFetchSwapQuote(api, initOptions.affiliateId);
  return {
    swapInfo: swapInfo,
    fetchSwapQuote: fetchSwapQuote
  };
}
var asError = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  error: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
    message: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
  })
});
var asPermissions = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  createOrder: cleaners__WEBPACK_IMPORTED_MODULE_0__.asBoolean,
  createQuote: cleaners__WEBPACK_IMPORTED_MODULE_0__.asBoolean
});
var asRate = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asEither)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  rate: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  min: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  max: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}), asError);
var asFixedQuoteRequest = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  depositMethod: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  settleMethod: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  depositAmount: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
});
var asFixedQuote = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asEither)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  id: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}), asError);
var asOrderRequest = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  type: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  quoteId: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  affiliateId: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  settleAddress: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  refundAddress: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
});
var asOrder = (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asEither)((0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
  expiresAtISO: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  depositAddress: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asObject)({
    address: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
    memo: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asString),
    destinationTag: (0,cleaners__WEBPACK_IMPORTED_MODULE_0__.asOptional)(cleaners__WEBPACK_IMPORTED_MODULE_0__.asNumber)
  }),
  id: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  orderId: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  settleAmount: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString,
  depositAmount: cleaners__WEBPACK_IMPORTED_MODULE_0__.asString
}), asError);

/***/ }),

/***/ "./src/swap/switchain.js":
/*!*******************************!*\
  !*** ./src/swap/switchain.js ***!
  \*******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeSwitchainPlugin": function() { return /* binding */ makeSwitchainPlugin; }
/* harmony export */ });
/* harmony import */ var biggystring__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! biggystring */ "./node_modules/biggystring/lib/index.es.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _swap_helpers__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../swap-helpers */ "./src/swap-helpers.js");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }




var pluginId = 'switchain';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Switchain',
  supportEmail: 'help@switchain.com'
};
var apiUrl = 'https://api.switchain.com/rest/v1';
var orderUri = 'https://www.switchain.com/order-status/';
var INVALID_CURRENCY_CODES = {
  from: {
    ETH: ['MATIC'],
    FTM: 'allCodes',
    MATIC: 'allTokens'
  },
  to: {
    ETH: ['MATIC'],
    FTM: 'allCodes',
    MATIC: 'allTokens',
    ZEC: ['ZEC']
  }
};
var dontUseLegacy = {
  DGB: true,
  LTC: true
};
var dummyAddresses = {
  ETH: '0x0000000000000000000000000000000000000000',
  XRP: 'rEb8TK3gBgk5auZkwc6sHnwrGVJH8DuaLh',
  XLM: 'GAHK7EEG2WWHVKDNT4CEQFZGKF2LGDSW2IVM4S5DP42RBW3K6BTODB4A',
  BNB: 'bnb136ns6lfw4zs5hg4n85vdthaad7hq5m4gtkgf23',
  XTZ: 'tz1dD2rBsYYLnsZtijtGqT4tynCEVaEJ6DeL',
  EOS: 'binancecleos'
};
function makeSwitchainPlugin(opts) {
  var initOptions = opts.initOptions,
      io = opts.io;

  if (!initOptions.apiKey) {
    throw new Error('No Switchain API key provided.');
  }

  function getAddress(_x, _x2) {
    return _getAddress.apply(this, arguments);
  }

  function _getAddress() {
    _getAddress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(wallet, currencyCode) {
      var addressInfo;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return wallet.getReceiveAddress({
                currencyCode: currencyCode
              });

            case 2:
              addressInfo = _context4.sent;
              return _context4.abrupt("return", addressInfo.legacyAddress && !dontUseLegacy[currencyCode] ? addressInfo.legacyAddress : addressInfo.publicAddress);

            case 4:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));
    return _getAddress.apply(this, arguments);
  }

  function swHttpCall(_x3, _x4, _x5, _x6) {
    return _swHttpCall.apply(this, arguments);
  }

  function _swHttpCall() {
    _swHttpCall = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(path, method, body, query) {
      var requestOpts, queryParams, queryStringList, _i3, _Object$keys2, k, uri, reply, replyJson;

      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              requestOpts = {
                headers: {
                  'Content-Type': 'application/json',
                  Authorization: "Bearer ".concat(initOptions.apiKey)
                },
                method: method
              };

              if (body) {
                requestOpts = _objectSpread(_objectSpread({}, requestOpts), {}, {
                  body: JSON.stringify(body)
                });
              }

              queryParams = '';

              if (query) {
                queryStringList = [];

                for (_i3 = 0, _Object$keys2 = Object.keys(query); _i3 < _Object$keys2.length; _i3++) {
                  k = _Object$keys2[_i3];
                  queryStringList.push([k, query[k]]);
                }

                queryParams = "?".concat(new URLSearchParams(queryStringList).toString());
              }

              uri = "".concat(apiUrl).concat(path).concat(queryParams);
              _context5.next = 7;
              return io.fetch(uri, requestOpts);

            case 7:
              reply = _context5.sent;
              _context5.prev = 8;
              _context5.next = 11;
              return reply.json();

            case 11:
              replyJson = _context5.sent;
              _context5.next = 17;
              break;

            case 14:
              _context5.prev = 14;
              _context5.t0 = _context5["catch"](8);
              throw new Error("Switchain ".concat(uri, " returned error code ").concat(reply.status, " (no JSON)"));

            case 17:
              if (!(reply.status !== 200)) {
                _context5.next = 21;
                break;
              }

              if (!replyJson.reason) {
                _context5.next = 20;
                break;
              }

              throw new Error(replyJson.reason);

            case 20:
              throw new Error("Switchain ".concat(uri, " returned error code ").concat(replyJson.status, " with JSON ").concat(JSON.stringify(replyJson)));

            case 21:
              return _context5.abrupt("return", replyJson);

            case 22:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5, null, [[8, 14]]);
    }));
    return _swHttpCall.apply(this, arguments);
  }

  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings, opts) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
        var fromWallet, nativeAmount, quoteFor, toCurrencyCode, toWallet, fromCurrencyCode, promoCode, pair, _yield$Promise$all, _yield$Promise$all2, fromAddress, toAddress, queryParameters, json, maxLimit, minLimit, minerFee, quote, signature, expiryTs, orderId, _yield$Promise$all3, _yield$Promise$all4, nativeMax, nativeMin, _yield$Promise$all5, _yield$Promise$all6, fromAmount, toAmount, quoteForFrom, toAmountInFrom, quoteAmount, orderCreationBody, fromNativeAmount, toNativeAmount, expirationDate, spendInfo, preliminaryTx, out;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                fromWallet = request.fromWallet, nativeAmount = request.nativeAmount, quoteFor = request.quoteFor, toCurrencyCode = request.toCurrencyCode, toWallet = request.toWallet;
                fromCurrencyCode = request.fromCurrencyCode;
                promoCode = opts.promoCode;
                (0,_swap_helpers__WEBPACK_IMPORTED_MODULE_2__.checkInvalidCodes)(INVALID_CURRENCY_CODES, request, swapInfo);

                if (!(toCurrencyCode === fromCurrencyCode)) {
                  _context3.next = 6;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapCurrencyError(swapInfo, fromCurrencyCode, toCurrencyCode);

              case 6:
                // convert TBTC to BTC for testing purposes
                if (fromCurrencyCode.toUpperCase() === 'TESTBTC') {
                  fromCurrencyCode = 'BTC';
                  apiUrl = 'https://api-testnet.switchain.com/rest/v1';
                } else {
                  apiUrl = 'https://api.switchain.com/rest/v1';
                }

                pair = "".concat(fromCurrencyCode.toUpperCase(), "-").concat(toCurrencyCode.toUpperCase()); // get wallet addresses for exchange

                _context3.next = 10;
                return Promise.all([getAddress(fromWallet, fromCurrencyCode), getAddress(toWallet, toCurrencyCode)]);

              case 10:
                _yield$Promise$all = _context3.sent;
                _yield$Promise$all2 = _slicedToArray(_yield$Promise$all, 2);
                fromAddress = _yield$Promise$all2[0];
                toAddress = _yield$Promise$all2[1];
                // retrieve quote for pair
                queryParameters = {
                  pair: pair,
                  orderIdSeed: toAddress
                };
                if (promoCode != null) queryParameters.promotionCode = promoCode;
                _context3.next = 18;
                return swHttpCall('/offer', 'GET', null, queryParameters);

              case 18:
                json = _context3.sent;
                maxLimit = json.maxLimit, minLimit = json.minLimit, minerFee = json.minerFee, quote = json.quote, signature = json.signature, expiryTs = json.expiryTs, orderId = json.orderId; // get native min max limits

                _context3.next = 22;
                return Promise.all([fromWallet.denominationToNative(maxLimit.toString(), fromCurrencyCode), fromWallet.denominationToNative(minLimit.toString(), fromCurrencyCode)]);

              case 22:
                _yield$Promise$all3 = _context3.sent;
                _yield$Promise$all4 = _slicedToArray(_yield$Promise$all3, 2);
                nativeMax = _yield$Promise$all4[0];
                nativeMin = _yield$Promise$all4[1];
                _context3.next = 28;
                return Promise.all([fromWallet.nativeToDenomination(nativeAmount, fromCurrencyCode), toWallet.nativeToDenomination(nativeAmount, toCurrencyCode)]);

              case 28:
                _yield$Promise$all5 = _context3.sent;
                _yield$Promise$all6 = _slicedToArray(_yield$Promise$all5, 2);
                fromAmount = _yield$Promise$all6[0];
                toAmount = _yield$Promise$all6[1];
                quoteForFrom = quoteFor === 'from'; // check for min / max limits

                if (!quoteForFrom) {
                  _context3.next = 40;
                  break;
                }

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(nativeAmount, nativeMin)) {
                  _context3.next = 36;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapBelowLimitError(swapInfo, nativeMin);

              case 36:
                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.gt)(nativeAmount, nativeMax)) {
                  _context3.next = 38;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapAboveLimitError(swapInfo, nativeMax);

              case 38:
                _context3.next = 45;
                break;

              case 40:
                toAmountInFrom = (0,biggystring__WEBPACK_IMPORTED_MODULE_0__.div)(toAmount, quote, 8);

                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.lt)(toAmountInFrom, minLimit)) {
                  _context3.next = 43;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapBelowLimitError(swapInfo, nativeMin);

              case 43:
                if (!(0,biggystring__WEBPACK_IMPORTED_MODULE_0__.gt)(toAmountInFrom, maxLimit)) {
                  _context3.next = 45;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_1__.SwapAboveLimitError(swapInfo, nativeMax);

              case 45:
                // order creation body
                quoteAmount = quoteForFrom ? {
                  fromAmount: fromAmount
                } : {
                  toAmount: toAmount
                };
                orderCreationBody = _objectSpread({
                  pair: pair,
                  toAddress: toAddress,
                  refundAddress: fromAddress,
                  signature: signature,
                  orderId: orderId
                }, quoteAmount);
                if (promoCode != null) orderCreationBody.promotionCode = promoCode; // plugin output creation

                fromNativeAmount = nativeAmount;
                _context3.next = 51;
                return toWallet.denominationToNative((0,biggystring__WEBPACK_IMPORTED_MODULE_0__.sub)((0,biggystring__WEBPACK_IMPORTED_MODULE_0__.mul)(quote, fromAmount), minerFee), toCurrencyCode);

              case 51:
                toNativeAmount = _context3.sent;

                if (quoteForFrom) {
                  _context3.next = 57;
                  break;
                }

                _context3.next = 55;
                return fromWallet.denominationToNative((0,biggystring__WEBPACK_IMPORTED_MODULE_0__.div)((0,biggystring__WEBPACK_IMPORTED_MODULE_0__.add)(toAmount, minerFee), quote, 8), fromCurrencyCode);

              case 55:
                fromNativeAmount = _context3.sent;
                toNativeAmount = nativeAmount;

              case 57:
                expirationDate = new Date(expiryTs * 1000); // create preliminary tx using our recieve address to calculate a networkFee

                spendInfo = {
                  currencyCode: fromCurrencyCode,
                  networkFeeOption: fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                  spendTargets: [{
                    nativeAmount: fromNativeAmount,
                    publicAddress: dummyAddresses[fromWallet.currencyInfo.currencyCode] || fromAddress
                  }]
                };
                _context3.next = 61;
                return fromWallet.makeSpend(spendInfo);

              case 61:
                preliminaryTx = _context3.sent;
                // convert that to the output format:
                out = {
                  isEstimate: false,
                  fromNativeAmount: fromNativeAmount,
                  toNativeAmount: toNativeAmount,
                  networkFee: {
                    currencyCode: fromWallet.currencyInfo.currencyCode,
                    nativeAmount: preliminaryTx.parentNetworkFee != null ? preliminaryTx.parentNetworkFee : preliminaryTx.networkFee
                  },
                  expirationDate: expirationDate,
                  pluginId: pluginId,
                  approve: function approve() {
                    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                      var json, orderId, exchangeAddress, exchangeAddressTag, spendTarget, spendInfo, completeTx, signedTransaction, broadcastedTransaction;
                      return regeneratorRuntime.wrap(function _callee$(_context) {
                        while (1) {
                          switch (_context.prev = _context.next) {
                            case 0:
                              _context.next = 2;
                              return swHttpCall('/order', 'POST', orderCreationBody);

                            case 2:
                              json = _context.sent;
                              orderId = json.orderId, exchangeAddress = json.exchangeAddress, exchangeAddressTag = json.exchangeAddressTag; // create tx with response and send

                              spendTarget = {
                                nativeAmount: fromNativeAmount,
                                publicAddress: exchangeAddress,
                                uniqueIdentifier: exchangeAddressTag
                              };
                              spendInfo = {
                                currencyCode: fromCurrencyCode,
                                spendTargets: [spendTarget],
                                networkFeeOption: fromCurrencyCode.toUpperCase() === 'BTC' ? 'high' : 'standard',
                                swapData: {
                                  orderId: orderId,
                                  orderUri: orderUri + orderId,
                                  isEstimate: false,
                                  payoutAddress: toAddress,
                                  payoutCurrencyCode: request.toCurrencyCode,
                                  payoutNativeAmount: toNativeAmount,
                                  payoutWalletId: request.toWallet.id,
                                  plugin: _objectSpread({}, swapInfo),
                                  refundAddress: fromAddress
                                }
                              };
                              _context.next = 8;
                              return fromWallet.makeSpend(spendInfo);

                            case 8:
                              completeTx = _context.sent;
                              _context.next = 11;
                              return fromWallet.signTx(completeTx);

                            case 11:
                              signedTransaction = _context.sent;
                              _context.next = 14;
                              return fromWallet.broadcastTx(signedTransaction);

                            case 14:
                              broadcastedTransaction = _context.sent;
                              _context.next = 17;
                              return fromWallet.saveTx(signedTransaction);

                            case 17:
                              return _context.abrupt("return", {
                                transaction: broadcastedTransaction,
                                destinationAddress: exchangeAddress,
                                orderId: orderId
                              });

                            case 18:
                            case "end":
                              return _context.stop();
                          }
                        }
                      }, _callee);
                    }))();
                  },
                  close: function close() {
                    return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                      return regeneratorRuntime.wrap(function _callee2$(_context2) {
                        while (1) {
                          switch (_context2.prev = _context2.next) {
                            case 0:
                            case "end":
                              return _context2.stop();
                          }
                        }
                      }, _callee2);
                    }))();
                  }
                };
                return _context3.abrupt("return", out);

              case 64:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./src/swap/transfer.js":
/*!******************************!*\
  !*** ./src/swap/transfer.js ***!
  \******************************/
/***/ (function(__unused_webpack_module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "makeTransferPlugin": function() { return /* binding */ makeTransferPlugin; }
/* harmony export */ });
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! edge-core-js/types */ "./node_modules/edge-core-js/types.js");
/* harmony import */ var edge_core_js_types__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _swap_helpers_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../swap-helpers.js */ "./src/swap-helpers.js");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }



var pluginId = 'transfer';
var swapInfo = {
  pluginId: pluginId,
  displayName: 'Transfer',
  orderUri: undefined,
  supportEmail: 'support@edge.com'
};
function makeTransferPlugin(opts) {
  var log = opts.log;
  var out = {
    swapInfo: swapInfo,
    fetchSwapQuote: function fetchSwapQuote(request, userSettings) {
      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _yield$request$toWall, toAddress, tx, quote;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(request.fromCurrencyCode !== request.toCurrencyCode)) {
                  _context.next = 2;
                  break;
                }

                throw new edge_core_js_types__WEBPACK_IMPORTED_MODULE_0__.SwapCurrencyError(swapInfo, request.fromCurrencyCode, request.toCurrencyCode);

              case 2:
                _context.next = 4;
                return request.toWallet.getReceiveAddress();

              case 4:
                _yield$request$toWall = _context.sent;
                toAddress = _yield$request$toWall.publicAddress;
                _context.next = 8;
                return request.fromWallet.makeSpend({
                  currencyCode: request.fromCurrencyCode,
                  spendTargets: [{
                    nativeAmount: request.nativeAmount,
                    publicAddress: toAddress
                  }]
                });

              case 8:
                tx = _context.sent;
                quote = (0,_swap_helpers_js__WEBPACK_IMPORTED_MODULE_1__.makeSwapPluginQuote)(request, request.nativeAmount, request.nativeAmount, tx, toAddress, 'transfer');
                log(quote);
                return _context.abrupt("return", quote);

              case 12:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    }
  };
  return out;
}

/***/ }),

/***/ "./node_modules/cleaners/lib/index.mjs":
/*!*********************************************!*\
  !*** ./node_modules/cleaners/lib/index.mjs ***!
  \*********************************************/
/***/ (function(__unused_webpack___webpack_module__, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "asArray": function() { return /* binding */ asArray; },
/* harmony export */   "asBoolean": function() { return /* binding */ asBoolean; },
/* harmony export */   "asCodec": function() { return /* binding */ asCodec; },
/* harmony export */   "asDate": function() { return /* binding */ asDate; },
/* harmony export */   "asEither": function() { return /* binding */ asEither; },
/* harmony export */   "asJSON": function() { return /* binding */ asJSON; },
/* harmony export */   "asMap": function() { return /* binding */ asMap; },
/* harmony export */   "asMaybe": function() { return /* binding */ asMaybe; },
/* harmony export */   "asNone": function() { return /* binding */ asNone; },
/* harmony export */   "asNull": function() { return /* binding */ asNull; },
/* harmony export */   "asNumber": function() { return /* binding */ asNumber; },
/* harmony export */   "asObject": function() { return /* binding */ asObject; },
/* harmony export */   "asOptional": function() { return /* binding */ asOptional; },
/* harmony export */   "asString": function() { return /* binding */ asString; },
/* harmony export */   "asUndefined": function() { return /* binding */ asUndefined; },
/* harmony export */   "asUnknown": function() { return /* binding */ asUnknown; },
/* harmony export */   "asValue": function() { return /* binding */ asValue; },
/* harmony export */   "uncleaner": function() { return /* binding */ uncleaner; }
/* harmony export */ });
/* harmony import */ var _index_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! ./index.js */ "./node_modules/cleaners/lib/index.js");
// Generated by rollup-plugin-mjs-entry



const asArray = _index_js__WEBPACK_IMPORTED_MODULE_0__.asArray;
const asBoolean = _index_js__WEBPACK_IMPORTED_MODULE_0__.asBoolean;
const asCodec = _index_js__WEBPACK_IMPORTED_MODULE_0__.asCodec;
const asDate = _index_js__WEBPACK_IMPORTED_MODULE_0__.asDate;
const asEither = _index_js__WEBPACK_IMPORTED_MODULE_0__.asEither;
const asJSON = _index_js__WEBPACK_IMPORTED_MODULE_0__.asJSON;
const asMap = _index_js__WEBPACK_IMPORTED_MODULE_0__.asMap;
const asMaybe = _index_js__WEBPACK_IMPORTED_MODULE_0__.asMaybe;
const asNone = _index_js__WEBPACK_IMPORTED_MODULE_0__.asNone;
const asNull = _index_js__WEBPACK_IMPORTED_MODULE_0__.asNull;
const asNumber = _index_js__WEBPACK_IMPORTED_MODULE_0__.asNumber;
const asObject = _index_js__WEBPACK_IMPORTED_MODULE_0__.asObject;
const asOptional = _index_js__WEBPACK_IMPORTED_MODULE_0__.asOptional;
const asString = _index_js__WEBPACK_IMPORTED_MODULE_0__.asString;
const asUndefined = _index_js__WEBPACK_IMPORTED_MODULE_0__.asUndefined;
const asUnknown = _index_js__WEBPACK_IMPORTED_MODULE_0__.asUnknown;
const asValue = _index_js__WEBPACK_IMPORTED_MODULE_0__.asValue;
const uncleaner = _index_js__WEBPACK_IMPORTED_MODULE_0__.uncleaner;


/***/ }),

/***/ "?3521":
/*!************************!*\
  !*** buffer (ignored) ***!
  \************************/
/***/ (function() {

/* (ignored) */

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			id: moduleId,
/******/ 			loaded: false,
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	!function() {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = function(module) {
/******/ 			var getter = module && module.__esModule ?
/******/ 				function() { return module['default']; } :
/******/ 				function() { return module; };
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/node module decorator */
/******/ 	!function() {
/******/ 		__webpack_require__.nmd = function(module) {
/******/ 			module.paths = [];
/******/ 			if (!module.children) module.children = [];
/******/ 			return module;
/******/ 		};
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
!function() {
"use strict";
/*!*****************************!*\
  !*** ./src/react-native.js ***!
  \*****************************/
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var regenerator_runtime_runtime__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! regenerator-runtime/runtime */ "./node_modules/regenerator-runtime/runtime.js");
/* harmony import */ var regenerator_runtime_runtime__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(regenerator_runtime_runtime__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _index_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./index.js */ "./src/index.js");


window.addEdgeCorePlugins(_index_js__WEBPACK_IMPORTED_MODULE_1__.default);
}();
/******/ })()
;
//# sourceMappingURL=edge-exchange-plugins.js.map